
'-------------------------------------------------------------------------------
' ReBar.bas
'   d_homans@yahoo.com.au
'   22 Feb 2012
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"

InitCommonControls()

#INCLUDE "win/RQInclude.bi"

DECLARE FUNCTION PanWndProc(hWnd As HWND, wMsg As UINT, wParam As WPARAM, lParam As LPARAM) As LRESULT
'-------------------------------------------------------------------------------
' Global data
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form
DIM SHARED AS QBUTTON Butn
DIM SHARED AS QSTATUSBAR StatBar

DIM SHARED AS QFORM PTR lpForm      = @Form
DIM SHARED AS QBUTTON PTR lpButn    = @Butn
DIM SHARED AS QSTATUSBAR PTR lpStat = @StatBar

'
' Objects in the Rebar ribbon (2 button panels and a combo panel)
'
CONST NUM_BTN = 10
CONST BTN_IDX = 100

DIM SHARED AS HWND hwndRebar
DIM SHARED AS QPANEL rbPanel(0 TO 2)                    ' Rebar ribbon containers
DIM SHARED AS QBUTTON rbButn(0 TO NUM_BTN-1)            ' Toolbar btns
DIM SHARED AS QCOMBOBOX rbCombo

'-------------------------------------------------------------------------------
' User added event Subs
'-------------------------------------------------------------------------------

SUB Exit_Click(Sender AS QBUTTON)
    Application.Terminate
END SUB

'-------------------------------------------------------------------------------
' Initialisation of object structs
'-------------------------------------------------------------------------------
SUB ConfigComponents
    lpForm->objIndex=0
    lpForm->Width=500: lpForm->Height=400
    'lpForm->Caption=Application.Name
    lpForm->Visible=1

    lpButn->objIndex=1
    lpButn->Left=200: lpButn->Top=320
    lpButn->Width=100: lpButn->Height=25
    lpButn->Caption="Exit"
    lpButn->OnClick=@Exit_Click

    lpStat->objIndex=2
    lpStat->Height=19
    lpStat->SimplePanel=1
    lpStat->SimpleText="Simple Text"
    lpStat->SizeGrip=1
END SUB

'-------------------------------------------------------------------------------
' Creation of program objects
'-------------------------------------------------------------------------------
SUB AddSubItems
DIM AS REBARBANDINFO rbBand
DIM AS RECT rct
DIM AS QBUTTON PTR lpBtn
DIM AS QPANEL PTR lpPan
DIM AS integer i, j

    '--------------- Add the first Rebar ribbon panel ------------------------
    lpPan=@rbPanel(0)
    lpPan->Left=0: lpPan->Top=0
    lpPan->Width=124: lpPan->Height=27
    lpPan->Caption="": lpPan->Parent=hwndRebar
    lpPan->Handle=CreateWindowEx(0, "STATIC", "", _
                WS_CHILD OR WS_VISIBLE OR SS_NOTIFY OR SS_LEFT OR SS_SUNKEN OR SS_CENTERIMAGE, _
                            lpPan->Left, lpPan->Top, lpPan->Width, lpPan->Height, _
                            hwndRebar, CAST(HMENU,1000), 0, 0)
    FOR i=0 TO 3
        lpBtn=@rbButn(i)
        lpBtn->objId=Q_BUTTON: lpBtn->objIndex=BTN_IDX+i
        lpBtn->Left=i*30: lpBtn->Top=0
        lpBtn->Width=30: lpBtn->Height=25
        lpBtn->Caption="A" & i+1
        lpBtn->Parent=lpPan->Handle
        lpBtn->Handle=CreateWindowEx(0, "BUTTON", lpBtn->Caption, _
                                        WS_CHILD OR WS_VISIBLE OR BS_PUSHBUTTON, _
                                        lpBtn->Left, lpBtn->Top, lpBtn->Width, lpBtn->Height, _
                                        lpPan->Handle, CAST(HMENU,lpBtn->objIndex), 0, 0)
    NEXT i
    lpPan->OldWndProc=SetWindowLong(lpPan->Handle, GWL_WNDPROC, @PanWndProc)    ' Hook into Panel WndProc

    '--------------- Add the second Rebar ribbon panel ------------------------
    lpPan=@rbPanel(1)
    lpPan->Left=0: lpPan->Top=0
    lpPan->Width=184: lpPan->Height=27
    lpPan->Caption="": lpPan->Parent=hwndRebar
    lpPan->Handle=CreateWindowEx(0, "STATIC", "", _
                WS_CHILD OR WS_VISIBLE OR SS_NOTIFY OR SS_LEFT OR SS_SUNKEN OR SS_CENTERIMAGE, _
                            lpPan->Left, lpPan->Top, lpPan->Width, lpPan->Height, _
                            hwndRebar, CAST(HMENU,1001), 0, 0)
    j=0
    FOR i = i TO NUM_BTN-1
        lpBtn=@rbButn(i)
        lpBtn->objId=Q_BUTTON: lpBtn->objIndex=BTN_IDX+i
        lpBtn->Left=j*30: lpBtn->Top=0
        lpBtn->Width=30: lpBtn->Height=25
        lpBtn->Caption="B" & j+1
        j += 1
        lpBtn->Parent=lpPan->Handle
        lpBtn->Handle=CreateWindowEx(0, "BUTTON", lpBtn->Caption, _
                                        WS_CHILD OR WS_VISIBLE OR BS_PUSHBUTTON, _
                                        lpBtn->Left, lpBtn->Top, lpBtn->Width, lpBtn->Height, _
                                        lpPan->Handle, CAST(HMENU,lpBtn->objIndex), 0, 0)
    NEXT i
    lpPan->OldWndProc=SetWindowLong(lpPan->Handle, GWL_WNDPROC, @PanWndProc)    ' Hook into Panel WndProc

    '--------------- Add the third Rebar ribbon panel ------------------------
    lpPan=@rbPanel(2)
    lpPan->Left=0: lpPan->Top=0
    lpPan->Width=104: lpPan->Height=27
    lpPan->Caption="": lpPan->Parent=hwndRebar
    lpPan->Handle=CreateWindowEx(0, "STATIC", "", _
                WS_CHILD OR WS_VISIBLE OR SS_NOTIFY OR SS_LEFT OR SS_SUNKEN OR SS_CENTERIMAGE, _
                            lpPan->Left, lpPan->Top, lpPan->Width, lpPan->Height, _
                            hwndRebar, CAST(HMENU,1002), 0, 0)

    rbCombo.objId=Q_COMBOBOX: rbCombo.objIndex=BTN_IDX+i                    ' Unique idx
    rbCombo.Left=0: rbCombo.Top=0
    rbCombo.Width=100: rbCombo.Height=150
    rbCombo.Parent=lpPan->Handle
    rbCombo.Handle=CreateWindowEx(0, "COMBOBOX", "", _
                                        WS_VISIBLE OR WS_CHILD OR WS_VSCROLL OR CBS_DROPDOWNLIST, _
                                        rbCombo.Left, rbCombo.Top, rbCombo.Width, rbCombo.Height, _
                                        lpPan->Handle, CAST(HMENU,rbCombo.objIndex), 0, 0)

    '----------------- Populate the Rebar ribbon ------------------------
    DIM AS string tstr
    FOR i=1 TO 20
        tstr="Item " & i
        SendMessage(rbCombo.Handle, CB_ADDSTRING, 0, CAST(LPARAM, STRPTR(tstr)))
    NEXT i

    rbBand.cbSize=SIZEOF(rbBand)
    rbBand.fMask=RBBIM_STYLE OR RBBIM_CHILD OR RBBIM_CHILDSIZE OR RBBIM_SIZE        ' OR RBBS_BREAK
    rbBand.fStyle=RBBS_CHILDEDGE OR RBBS_GRIPPERALWAYS 

    FOR i=0 TO 2
        rbBand.lpText=0
        rbBand.hwndChild=rbPanel(i).Handle
        GetWindowRect(rbPanel(i).Handle, @rct)
        rbBand.cyChild = rct.Right-rct.Left
        rbBand.cyMinChild = rct.Bottom-rct.Top                                ' Minimum height of band
        rbBand.cxMinChild = rct.Right-rct.Left                                ' Minimum width of band
        rbBand.cx=rct.Right-rct.Left
        SendMessage(hwndRebar, RB_INSERTBAND, -1, @rbBand)
    NEXT i
END SUB

SUB AddChildWindows(Parent AS HWND)
    hwndRebar=CreateWindowEx(WS_EX_TOOLWINDOW, "ReBarWindow32", "", _
                                        WS_CHILD OR WS_VISIBLE OR WS_CLIPCHILDREN OR _
                                        WS_CLIPSIBLINGS OR RBS_VARHEIGHT OR RBS_BANDBORDERS, _
                                        0,0,0,0, Parent, 0, 0, 0)
    AddSubItems

    lpButn->Parent=Parent
    lpButn->Handle=CreateWindowEx(0, "BUTTON", lpButn->Caption, _
                                        WS_CHILD OR WS_VISIBLE OR BS_PUSHBUTTON, _
                                        lpButn->Left, lpButn->Top, lpButn->Width, lpButn->Height, _
                                        Parent, CAST(HMENU,lpButn->objIndex), 0, 0)

    lpStat->Parent=Parent
    lpStat->Handle = CreateWindowEx(0, "msctls_statusbar32", "Status", _
                                        WS_CHILD OR WS_VISIBLE, _
                                        lpStat->Left, lpStat->Top, lpStat->Width, lpStat->Height, _
                                        Parent, CAST(HMENU,lpStat->objIndex), 0, 0)
END SUB

' Rebar panels containing buttons
FUNCTION PanWndProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS integer i

    SELECT CASE uMsg
        CASE WM_COMMAND
            i=LOWORD(wParam)-BTN_IDX
            SELECT CASE i
                CASE 0 TO NUM_BTN-1
                    SetWindowText(StatBar.Handle,"Rebar Btn: " & i+1)
            END SELECT
    END SELECT
    RETURN CallWindowProc(rbPanel(0).OldWndProc, hWnd, uMsg, wParam, lParam)
END FUNCTION

FUNCTION WndProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT

    SELECT CASE uMsg
        CASE WM_CREATE
            AddChildWindows(hWnd)

        CASE WM_PAINT
            DIM AS RECT rct                                                 ' Auto adjust statusbar to form
            DIM AS integer ht1, ht2
            GetClientRect(hwndRebar, @rct)
            ht1 = rct.Bottom-rct.Top+1                                       ' Height of rebar
            GetClientRect(lpStat->Handle, @rct)
            ht2 = rct.Bottom-rct.Top+1                                       ' Height of status bar

            GetClientRect(hWnd, @rct)
            MoveWindow(hwndRebar, rct.Left, rct.Bottom-ht1, rct.Right-rct.Left+1, ht1, 1)
            MoveWindow(lpStat->Handle, rct.Left, rct.Bottom-ht2, rct.Right-rct.Left+1, ht2, 1)

        CASE WM_COMMAND
            SELECT CASE LOWORD(wParam)
                CASE lpButn->ObjIndex
                    IF lpButn->OnClick>0 THEN lpButn->OnClick(lpButn)
            END SELECT

'        CASE WM_KEYDOWN
'            IF LOBYTE(wParam) = 27 THEN
'                PostMessage(hWnd, WM_CLOSE, 0, 0)
'            END IF

        CASE WM_DESTROY
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, uMsg, wParam, lParam)
END FUNCTION


' Main program loop
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS MSG wMsg
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize=SizeOf(WNDCLASSEX)
    .style=CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc=@WndProc
    .hInstance=hInst
    .hIcon=LoadIcon(0,IDI_APPLICATION)
    .hCursor=LoadCursor(0,IDC_ARROW)
    .hbrBackground=Cast(HBRUSH,COLOR_WINDOW)
    .lpszClassName=@"RQClass"
    .hIconSm=.hIcon
END WITH

    IF RegisterClassEx(@wc)=0 THEN
        ShowMessage("Register class error")
        RETURN 0
    END IF

    ConfigComponents

    lpForm->Parent=0
    lpForm->Handle=CreateWindowEx(0, "RQClass", lpForm->Caption, _
                                    WS_VISIBLE OR WS_OVERLAPPEDWINDOW, _
                                    lpForm->Left, lpForm->Top, lpForm->Width, lpForm->Height, _
                                    0, 0, hInst, 0)
    Application.hMainForm=lpForm->Handle                                ' Need this for the terminate fn
    lpForm->Center


    WHILE GetMessage(@wMsg, NULL, 0, 0) <> FALSE
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND

    RETURN wMsg.wParam
END FUNCTION
'
' Main Entry Point
'
END WinMain(Application.hInstance, NULL, Command(), SW_NORMAL)
