SUB Splitter_Moved

    IF MainForm.Visible THEN
        'MainForm.InheritOnShow      'weird bug fix
        re.Top = 0
        re.Left = 0

        IDE.RightSplitterPos = RightSplitter.Left                       'store for configuration
        IDE.LeftSplitterPos = LeftSplitter.Left

        IF LeftPanel.Visible THEN
            re.Width = CenterPanel.ClientWidth - RightSplitter.Width
        ELSE
            CenterPanel.Width = MainForm.ClientWidth
            re.Width = CenterPanel.ClientWidth  - RightSplitter.Width
        END IF
        'deal with height of edit control
        IF NOT!(BottomPanel.Visible) THEN
            CenterPanel.ClientHeight = MainForm.ClientHeight
            re.Height = CenterPanel.ClientHeight
        ELSE
            re.Height = CenterPanel.ClientHeight - BottomPanel.Height - BottomSplitter.Height
            BottomPanel.Top = BottomSplitter.Top + BottomSplitter.Height
            RichEditCompile.Width = BottomPanel.Width
            RichEditCompile.Height = BottomPanel.Height - 4
        END IF

        IF PanelSearch.Visible THEN
            PanelSearch.Width = RightPanel.Width
            SearchNextBut.Left = PanelSearch.Width - SearchNextBut.Width - 4
            SearchPrevBut.Left = SearchNextBut.Left - SearchPrevBut.Width - 4
            Poor.Width = SearchPrevBut.Left - 4
        END IF
        
        FindAllPanel.Width = RightPanel.ClientWidth - RightSplitter.Width
		SubFuncsPanel.Width = RightPanel.ClientWidth - RightSplitter.Width
        DEFINT i
		FOR i = 0 TO IDE_MAX_FILES
            SubFuncListView(i).Width = SubFuncsPanel.Width
            SubFuncListView(i).Height = SubFuncsPanel.Height
            SubFuncListView(i).Column(0).Width = SubFuncsPanel.Width
        NEXT i
    END IF


    STATIC AppInit AS INTEGER
    IF AppInit = FALSE THEN
        IF MainForm.Visible THEN
            IF IDE.AutoOpenLastProj THEN 

                IF FILEEXISTS(TRIM$(mnuRecentProj0.Caption)) THEN
                    MFE_LoadProject(TRIM$(mnuRecentProj0.Caption))
                ELSE
                    Showmessage "Project file: " + TRIM$(mnuRecentProj0.Caption) + " does not exist"
                END IF

            ELSE
                IF IDE.ShowWelcome THEN mnuOpenAppWizard_Click
            END IF

            AppInit = TRUE
        END IF
    END IF

END SUB



SUB MainFormResize
    Splitter_Moved                      'splitter positions are stored here
    IDE.MainFormLeft = MainForm.Left
    IDE.MainFormTop = MainForm.Top
    IDE.MainFormWidth = MainForm.Width
    IDE.MainFormHeight = MainForm.Height
    MainForm.DragZone.Right = MainForm.Width
    MainForm.DragZone.Bottom = MainForm.Height      'set drag zones!
END SUB



SUB MainFormOnDrag(Thefile AS STRING)
    IF UCASE$(StripFileExt(Thefile)) = ".QPROJ" THEN
        MFE_LoadProject(Thefile)
    ELSE
        MFE_Load(Thefile)
    END IF
END SUB



SUB ShowYXPos
	MFE_UpdateSaveButton
    Stat.Panel(3).Caption = "row:" + STR$(re.WhereY) + " col:" + STR$(re.WhereX + 1)
    Stat.Panel(4).Caption = "Pos: " + STR$(re.SelStart) + "  Sel Len: " + STR$(re.SelLength)
END SUB




SUB MainForm_KeyDown(Key AS Word, Shift AS INTEGER)         'this is for messaging when mainform has focus
'      CONST CtrlDown = 1 
'      CONST ShiftDown = 256 
    IF Key = 67 THEN IF (Shift = CtrlDown) THEN CopyClick : EXIT SUB       'ctrl-c key
    IF Key = 86 THEN IF (Shift = CtrlDown) THEN PasteClick : EXIT SUB      'ctrl-v key
    IF Key = 88 THEN IF (Shift = CtrlDown) THEN CutClick : EXIT SUB        'ctrl-x key
    IF Key = 65 THEN IF (Shift = CtrlDown) THEN SelectAllClick : EXIT SUB  'ctrl-a key
    IF Key = 89 THEN IF (Shift = CtrlDown) THEN RedoClick : EXIT SUB       'ctrl-y key
    IF Key = 90 THEN IF (Shift = CtrlDown) THEN UndoClick : EXIT SUB       'ctrl-z key

    'don't do this... will cause problems when QScintilla is focussed
    'DEFINT myKeyCode = OnKeyToKeyCode(Key, Shift)
    'IF IDE.MenuFuncPtr(myKeyCode) <> 0 THEN CALLFUNC IDE.MenuFuncPtr(myKeyCode)
END SUB


SUB MainRichEditKeyUp(Key AS WORD , Shift AS INTEGER)
    ShowYXPos
    MFE_GetCursor          'store position of cursor
'    IF IDE.HiLightTurnOFF = True THEN           'after error?
'        IDE.HiLightTurnOFF = False
'        IF IDE.ActiveLineBack <> -1 THEN re.ActiveLineColor(IDE.ActiveLineBack, 0) ELSE re.ActiveLineColor(IDE.BackGround, 0)
'    END IF
END SUB




'process key presses from Scintilla, 
'Key strokes with Ctrl + xx are passed to mainform and do not need to be processed here
'______________________________________________________________________________________
SUB MainRichEditKeyDown(theKey AS WORD , Shift AS INTEGER)

    'handle ALT key down, and F1-F12 + keys (when shift = 256, ctrl = 1, these are handled by Scintilla to default mainform accel keys)
    IF ((Shift AND 16) = 16) OR ((theKey > 111) AND (theKey < 124)) THEN
        DEFINT myKeyCode = OnKeyToKeyCode(theKey, Shift)
        IF myKeyCode > 46 THEN 
            IF IDE.MenuFuncPtr(myKeyCode) <> 0 THEN CALLFUNC IDE.MenuFuncPtr(myKeyCode)
        END IF
    END IF

    IF IDE.AutoComplete THEN            'first handle autoComplete (Ctrl+.)
        IF (theKey = 190) AND (Shift = 1) THEN IDE_AutoCompleteWord
    END IF
END SUB




SUB MainRichEditMouseDown(Button% AS INTEGER , X% AS INTEGER , Y% AS INTEGER)
    'did we just highlight a line after sub search or compile error? Then turn it off
    IF IDE.HiLightTurnOFF = True THEN
        IDE.HiLightTurnOFF = False
        IF IDE.ActiveLineBack <> -1 THEN re.ActiveLineColor(IDE.ActiveLineBack, 0) ELSE re.ActiveLineColor(IDE.BackGround, 0)
    END IF

    IF Button% = 1 THEN                                        'Handle right button click
        IF (GetAsyncKeyState(VK_CONTROL) <> 0) AND (IDE.KeyWordLookUp.ItemCount > 0) THEN 
            IDE_ShowQuickTip
        ELSE
            DEFINT y = Screen.MouseY :  IF y > Screen.Height - 330 THEN y = Screen.Height - 330 'too far down
            RE_PopupMenu.Popup(Screen.MouseX, y)
        END IF
    END IF
END SUB





SUB MainRichEditMouseUp(Button% AS INTEGER , X% AS INTEGER , Y% AS INTEGER)       ', Shift% as integer)
    ShowYXPos
    MFE_GetCursor          'store position of cursor only on up (for selection)
END SUB


SUB RichEditCompileKeyDown(Key AS Word, Shift AS INTEGER)
    'WM_CHAR = &H102
    IF Key = 13 THEN
        KILLMESSAGE RichEditCompile.handle, WM_CHAR     ' kill return
    END IF
END SUB
'
'SUB RichEditCompileKeyUp(Key AS Word, Shift AS INTEGER)
'END SUB


SUB RichEditCompile_MouseDown (Button%, X%, Y%, Shift%)
    IF Button% = 1 THEN                 'right mouse click
        IF Shift% <> 0 THEN
            DEFINT i
            DEFSTR TheErrLine, delimt$
            FOR i = 0 TO RichEditCompile.LineCount -1       '*****  parse for line with error  *****
                TheErrLine = RichEditCompile.Line(i)
                IF (LEFT$(TheErrLine, 5) = "Line ") AND (INSTR(TheErrLine, ": ") > 0) THEN
                    TheErrLine = TheErrLine - "Line "
                    IF INSTR(TheErrLine, Comma) THEN delimt$ = Comma ELSE delimt$ = ":"
                    re.GotoLine(VAL(FIELD$(TheErrLine, delimt$, 1)) -1)
                    re.ActiveLineColor(RGB(255,200,128), 0)                         
                    IDE.HiLightTurnOFF = True               'toggle to turn off compile error line
                END IF
            NEXT i
'        ELSE
'            DIM OutputPopup AS QPOPUPMENU              'won't work in sub
'            DIM OutputPopup1 AS QMENUITEM
'                OutputPopup1.Caption = "Close"
'                OutputPopup1.OnClick = mnuViewBottomPanel_Click
'            OutputPopup.AddItems OutputPopup1
'            OutputPopup.Popup(Screen.MouseX, Screen.MouseY)
        END IF
    END IF
END SUB


SUB ProjDirBack
    IF IDE.LastDir <> "" THEN
        IF DIREXISTS(IDE.LastDir) = False THEN IDE.LastDir = Application.Path
        'this line can generate an invalid address exception error on startup!!!
    ELSE
        IDE.LastDir = Application.Path
    END IF

    DirTree.Directory = IDE.LastDir         'this should now update itself and ProjFileList through SUB ChangeDirectories
    DirTree.Reload                          'directory tree in Project Tab
END SUB



SUB ProjDirUpDir
    DEFSTR tmpDir = CURDIR$
    IDE.LastDir = ProjFileList.Directory
    CHDIR ProjFileList.Directory
    CHDIR ".."
    ProjFileList.Directory = CURDIR$
    ProjFileList.Update
    DirTree.Directory = ProjFileList.Directory
    DirTree.Reload                          'directory tree in Project Tab
    CHDIR tmpDir        'restore
END SUB



SUB ProjFileList_Update
    ProjFileList.Mask = ProjFileListMaskEdit.Text
    ProjFileList.Directory = DirTree.Directory
    ProjFileList.Update
    IDE.LastDir = DirTree.Directory
END SUB



SUB IDE_ShortCutToKeyStrokes(Sender AS QMENUITEM)
    DEFSTR sCommand = UCASE$(Sender.ShortCut)
    DEFINT isShift = INSTR(sCommand, "SHIFT")
    DEFINT isCtrl = INSTR(sCommand, "CTRL")
    DEFINT isAlt = INSTR(sCommand, "ALT")
    DEFINT strt = RINSTR(sCommand, "+")+1
    DEFSTR TheCode = TRIM$(MID$(sCommand, strt, LEN(sCommand) - strt+1))
    DEFINT theVKCode


    SELECT CASE TheCode
            ' VK_A thru VK_Z are the same as their ASCII equivalents: 'A' thru 'Z'
            ' VK_0 thru VK_9 are the same as their ASCII equivalents: '0' thru '9'
        CASE "0" TO "Z"              :   theVKCode = ASC(TheCode)
        CASE "F1" TO "F24"           :   theVKCode = VK_F1 + VAL(TheCode) - 1
        CASE "*"                     :   theVKCode = VK_MULTIPLY
        CASE "+"                     :   theVKCode = VK_ADD
        CASE "|"                     :   theVKCode = VK_SEPARATOR
        CASE "-"                     :   theVKCode = VK_SUBTRACT
        CASE "."                     :   theVKCode = VK_DECIMAL
        CASE "/"                     :   theVKCode = VK_DIVIDE
        CASE ELSE                    :   theVKCode = ""        
        END SELECT

    IF (isCtrl AND GetAsyncKeyState(VK_CONTROL)) THEN        'ctrl-key down?
        keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)       'set up
    END IF
    IF (isShift AND GetAsyncKeyState(VK_SHIFT)) THEN         'shift-key down?
        keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0)         'set up
    END IF
    IF (isAlt AND GetAsyncKeyState(VK_MENU)) THEN            'alt-key down?
        keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)          'set up
    END IF

    re.SetFocus                                              'activate scitilla control
    IF isCtrl THEN 
        keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)       'signal release of keys
        keybd_event(VK_CONTROL, 0, 0, 0)                     'press Ctrl
    END IF
    IF isShift THEN 
        keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0)         'signal release of keys
        keybd_event(VK_SHIFT, 0, 0, 0)                       'press Ctrl
    END IF
    IF isAlt THEN 
        keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)          'signal release of keys
        keybd_event(VK_MENU, 0, 0, 0)                        'press Ctrl
    END IF

    keybd_event(theVKCode, 0, 0, 0)                          'press Final Key

    IF isCtrl THEN keybd_event(VK_CONTROL, 0, &H02020202, 0) 'signal release of keys
    IF isShift THEN keybd_event(VK_SHIFT, 0, &H02020202, 0)  'signal release of keys
    IF isAlt THEN keybd_event(VK_MENU, 0, &H02020202, 0)     'signal release of keys
    DOEVENTS 

END SUB





FUNCTION IDE_ManageMenu(Sender AS QMENUITEM) AS INTEGER
    'first store Caption, shortcut and visibility to global storage for stringGrid list
    IDE.MenuShortCutList = IDE.MenuShortCutList + Sender.Caption + ","_
                             + Sender.ShortCut + "," _
                             + STR$(Sender.Visible) + CRLF

    DEFSTR sCommand = UCASE$(Sender.ShortCut)
    DEFINT res = 0

    'for function pointers, put shift values in hi-order word
    'bits 0-7 = virtual key code pressed (0-255)
   ' (VK_CONTROL) = 1) (VK_SHIFT)= 256) (VK_MENU) =16)
    DEFINT isCtrl = ABS(INSTR(sCommand, "CTRL") > 0) * 256     'bit 8 (high) = Ctrl key is pressed (256)
    DEFINT isAlt = ABS(INSTR(sCommand, "ALT") > 0) * 512       'bit 9 (high) = Alt key is pressed  (512)
    DEFINT isShift = ABS(INSTR(sCommand, "SHIFT") > 0) * 1024  'bit 10 (high) = Shift key is pressed (1024)

    DEFINT strt = RINSTR(sCommand, "+") + 1
    sCommand = TRIM$(MID$(sCommand, strt, LEN(sCommand) - strt+1))

    'Do F1-F24 first!!
    IF (LEFT$(sCommand, 1) = "F") AND (LEN(sCommand) > 1) THEN
        res = 111 + VAL(RIGHT$(sCommand, 1))      '"F1 to F24
    ELSE
        SELECT CASE sCommand
            CASE "A" TO "z"                   'keep case correct here for ascii code, key = ascii
                res = ASC(sCommand)
            CASE "0" TO "9"                   'keep case correct here for ascii code, key = ascii
                res = ASC(sCommand)
            CASE ELSE
                IF sCommand = sQuot THEN
                    res = 222
                ELSEIF sCommand = "]" THEN
                    res = 221
                ELSEIF sCommand = "[" THEN
                    res = 219
                ELSEIF sCommand = "\" THEN
                    res = 220
                ELSEIF sCommand = "*" THEN
                    res = 106
                ELSEIF sCommand = "+" THEN
                    res = 107
                ELSEIF sCommand = "-" THEN
                    res = 189       'numpad = 109
                ELSEIF sCommand = "=" THEN
                    res = 187
                ELSEIF sCommand = "." THEN
                    res = 190
                ELSEIF sCommand = "," THEN
                    res = 188
                ELSEIF sCommand = ";" THEN
                    res = 186
                ELSEIF sCommand = "/" THEN
                    res = 119
                END IF
            END SELECT
    END IF
        RESULT = res OR isCtrl OR isAlt OR isShift             'shift result in hi-order word
END FUNCTION







FUNCTION OnKeyToKeyCode(Key AS Word, Shift AS INTEGER) AS INTEGER
    'IF VK_CONTROL then shift = 1
    'IF VK_MENU (alt key) then shift = 16
    'IF VK_SHIFT then shift = 256

    'for function pointers, put shift values in hi-order word
    DEFINT HiWrd = (Shift AND 1) SHL 8              'bit 8 (high) = Ctrl key is pressed (256)
    HiWrd = HiWrd + (Shift AND 16) SHL 5            'bit 9 (high) = Alt key is pressed  (512)
    HiWrd = HiWrd + (Shift AND 256) SHL 2           'bit 10 (high) = Shift key is pressed (1024)
    RESULT = key + HiWrd                            'bits 0-7 = virtual key code pressed (0-255)

END FUNCTION



 
SUB ReadMenuShortcuts
    IDE_Conf_MenuGrid.Tag = False                                               'flag, we use default menus
    IF IDE.MenuShortCutFile <> "" THEN
        IF FILEEXISTS(IDE.MenuShortCutFile) THEN
            tmpList.Clear
            tmpList.LoadFromFile(IDE.MenuShortCutFile)                          'get custom list
            IDE.MenuShortCutList = tmpList.Text                                 'transfer to global storage, overwrites defaults
            IDE_Conf_MenuGrid.Tag = True                                        'flag, we must reset menus
        ELSE
            IDE.MenuShortCutFile = ""                                           'it doesn't exist so get rid of it
        END IF
    END IF
    gMem.Clear:    gMem.Position = 0                                            'transfer string to MemoryStream
    gMem.WriteBinStr(IDE.MenuShortCutList, LEN(IDE.MenuShortCutList))           'to populate StringGrid, .Loadfromfile will not work...
    gMem.Position = 0                                                           'important!
    IDE_Conf_MenuGrid.LoadFromStream(gMem, 1, 0, IDE_Conf_MenuGrid.RowCount)    'populate the stringGrid
    gMem.Clear:    gMem.Position = 0                                            'dealloc

    'now reset the shortcuts for tools
    IDE_Conf_MenuGrid.Cell(0,72) = IDE.ExternalApp1
    IDE_Conf_MenuGrid.Cell(0,73) = IDE.ExternalApp2
    IDE_Conf_MenuGrid.Cell(0,74) = IDE.ExternalApp3
    IDE_Conf_MenuGrid.Cell(0,75) = IDE.ExternalApp4

END SUB



'here we load each menu item with Caption, Shortcuts, and visible properties,  function pointers
SUB SetMenuShortcuts
    IF IDE_Conf_MenuGrid.Tag THEN                                           'need to reset all properties
        WITH IDE_Conf_MenuGrid
            mnuNew.Caption = .Cell(0,1)      :  mnuNew.ShortCut = .Cell(1,1)       :  mnuNew.Visible = VAL(.Cell(2,1))
            mnuOpen.Caption = .Cell(0,2)      :  mnuOpen.ShortCut = .Cell(1,2)       :  mnuOpen.Visible = VAL(.Cell(2,2))
            mnuOpenFileFromWeb.Caption = .Cell(0,3)      :  mnuOpenFileFromWeb.ShortCut = .Cell(1,3)       :  mnuOpenFileFromWeb.Visible = VAL(.Cell(2,3))
            mnuSave.Caption = .Cell(0,4)      :  mnuSave.ShortCut = .Cell(1,4)       :  mnuSave.Visible = VAL(.Cell(2,4))
            mnuSaveAs.Caption = .Cell(0,5)      :  mnuSaveAs.ShortCut = .Cell(1,5)       :  mnuSaveAs.Visible = VAL(.Cell(2,5))
            mnuSaveAll.Caption = .Cell(0,6)      :  mnuSaveAll.ShortCut = .Cell(1,6)       :  mnuSaveAll.Visible = VAL(.Cell(2,6))
            mnuOpenProj.Caption = .Cell(0,7)      :  mnuOpenProj.ShortCut = .Cell(1,7)       :  mnuOpenProj.Visible = VAL(.Cell(2,7))
            mnuSaveProj.Caption = .Cell(0,8)      :  mnuSaveProj.ShortCut = .Cell(1,8)       :  mnuSaveProj.Visible = VAL(.Cell(2,8))
            mnuCloseProjFiles.Caption = .Cell(0,9)      :  mnuCloseProjFiles.ShortCut = .Cell(1,9)       :  mnuCloseProjFiles.Visible = VAL(.Cell(2,9))
            mnuClose.Caption = .Cell(0,10)      :  mnuClose.ShortCut = .Cell(1,10)       :  mnuClose.Visible = VAL(.Cell(2,10))
            mnuCloseAll.Caption = .Cell(0,11)      :  mnuCloseAll.ShortCut = .Cell(1,11)       :  mnuCloseAll.Visible = VAL(.Cell(2,11))
            PrintSetupMenu.Caption = .Cell(0,12)      :  PrintSetupMenu.ShortCut = .Cell(1,12)       :  PrintSetupMenu.Visible = VAL(.Cell(2,12))
            PrintMenu.Caption = .Cell(0,13)      :  PrintMenu.ShortCut = .Cell(1,13)       :  PrintMenu.Visible = VAL(.Cell(2,13))
            ExitMenu.Caption = .Cell(0,14)      :  ExitMenu.ShortCut = .Cell(1,14)       :  ExitMenu.Visible = VAL(.Cell(2,14))
            mnuViewModeSimple.Caption = .Cell(0,15)      :  mnuViewModeSimple.ShortCut = .Cell(1,15)       :  mnuViewModeSimple.Visible = VAL(.Cell(2,15))
            mnuViewModeNovice.Caption = .Cell(0,16)      :  mnuViewModeNovice.ShortCut = .Cell(1,16)       :  mnuViewModeNovice.Visible = VAL(.Cell(2,16))
            mnuViewModeIntermediate.Caption = .Cell(0,17)      :  mnuViewModeIntermediate.ShortCut = .Cell(1,17)       :  mnuViewModeIntermediate.Visible = VAL(.Cell(2,17))
            mnuViewModeExpert.Caption = .Cell(0,18)      :  mnuViewModeExpert.ShortCut = .Cell(1,18)       :  mnuViewModeExpert.Visible = VAL(.Cell(2,18))
            mnuViewLeftPanel.Caption = .Cell(0,19)      :  mnuViewLeftPanel.ShortCut = .Cell(1,19)       :  mnuViewLeftPanel.Visible = VAL(.Cell(2,19))
            mnuViewBottomPanel.Caption = .Cell(0,20)      :  mnuViewBottomPanel.ShortCut = .Cell(1,20)       :  mnuViewBottomPanel.Visible = VAL(.Cell(2,20))
            mnuViewRightPanel.Caption = .Cell(0,21)      :  mnuViewRightPanel.ShortCut = .Cell(1,21)       :  mnuViewRightPanel.Visible = VAL(.Cell(2,21))
            QuickSearchMnu.Caption = .Cell(0,22)      :  QuickSearchMnu.ShortCut = .Cell(1,22)       :  QuickSearchMnu.Visible = VAL(.Cell(2,22))
            mnuViewStatusBar.Caption = .Cell(0,23)      :  mnuViewStatusBar.ShortCut = .Cell(1,23)       :  mnuViewStatusBar.Visible = VAL(.Cell(2,23))
            mnuViewFormDesigner.Caption = .Cell(0,24)      :  mnuViewFormDesigner.ShortCut = .Cell(1,24)       :  mnuViewFormDesigner.Visible = VAL(.Cell(2,24))
            mnuViewTopPanel.Caption = .Cell(0,25)      :  mnuViewTopPanel.ShortCut = .Cell(1,25)       :  mnuViewTopPanel.Visible = VAL(.Cell(2,25))
            Mnu_SetLineNumbers.Caption = .Cell(0,26)      :  Mnu_SetLineNumbers.ShortCut = .Cell(1,26)       :  Mnu_SetLineNumbers.Visible = VAL(.Cell(2,26))
            Mnu_ViewIndentation.Caption = .Cell(0,27)      :  Mnu_ViewIndentation.ShortCut = .Cell(1,27)       :  Mnu_ViewIndentation.Visible = VAL(.Cell(2,27))
            Mnu_CodeFolding.Caption = .Cell(0,28)      :  Mnu_CodeFolding.ShortCut = .Cell(1,28)       :  Mnu_CodeFolding.Visible = VAL(.Cell(2,28))
            Mnu_CodeFoldingCollapseAll.Caption = .Cell(0,29)      :  Mnu_CodeFoldingCollapseAll.ShortCut = .Cell(1,29)       :  Mnu_CodeFoldingCollapseAll.Visible = VAL(.Cell(2,29))
            Mnu_CodeFoldingExpandAll.Caption = .Cell(0,30)      :  Mnu_CodeFoldingExpandAll.ShortCut = .Cell(1,30)       :  Mnu_CodeFoldingExpandAll.Visible = VAL(.Cell(2,30))
            Mnu_ViewLastTab.Caption = .Cell(0,31)      :  Mnu_ViewLastTab.ShortCut = .Cell(1,31)       :  Mnu_ViewLastTab.Visible = VAL(.Cell(2,31))
            mnuMagnifyFont.Caption = .Cell(0,32)      :  mnuMagnifyFont.ShortCut = .Cell(1,32)       :  mnuMagnifyFont.Visible = VAL(.Cell(2,32))
            mnuMinifyFont.Caption = .Cell(0,33)      :  mnuMinifyFont.ShortCut = .Cell(1,33)       :  mnuMinifyFont.Visible = VAL(.Cell(2,33))
            mnuDeleteBlankLines.Caption = .Cell(0,34)      :  mnuDeleteBlankLines.ShortCut = .Cell(1,34)       :  mnuDeleteBlankLines.Visible = VAL(.Cell(2,34))
            mnuTrimSpacesAtEnd.Caption = .Cell(0,35)      :  mnuTrimSpacesAtEnd.ShortCut = .Cell(1,35)       :  mnuTrimSpacesAtEnd.Visible = VAL(.Cell(2,35))
            mnuTabsToSpaces.Caption = .Cell(0,36)      :  mnuTabsToSpaces.ShortCut = .Cell(1,36)       :  mnuTabsToSpaces.Visible = VAL(.Cell(2,36))
            mnuSort.Caption = .Cell(0,37)      :  mnuSort.ShortCut = .Cell(1,37)       :  mnuSort.Visible = VAL(.Cell(2,37))
            mnuDateTime.Caption = .Cell(0,38)      :  mnuDateTime.ShortCut = .Cell(1,38)       :  mnuDateTime.Visible = VAL(.Cell(2,38))
            mnuInsertFile.Caption = .Cell(0,39)      :  mnuInsertFile.ShortCut = .Cell(1,39)       :  mnuInsertFile.Visible = VAL(.Cell(2,39))
            mnuTxtFind.Caption = .Cell(0,40)      :  mnuTxtFind.ShortCut = .Cell(1,40)       :  mnuTxtFind.Visible = VAL(.Cell(2,40))
            mnuFindinFiles.Caption = .Cell(0,41)      :  mnuFindinFiles.ShortCut = .Cell(1,41)       :  mnuFindinFiles.Visible = VAL(.Cell(2,41))
            mnuFindNext.Caption = .Cell(0,42)      :  mnuFindNext.ShortCut = .Cell(1,42)       :  mnuFindNext.Visible = VAL(.Cell(2,42))
            mnuFindPrev.Caption = .Cell(0,43)      :  mnuFindPrev.ShortCut = .Cell(1,43)       :  mnuFindPrev.Visible = VAL(.Cell(2,43))
            mnuReplace.Caption = .Cell(0,44)      :  mnuReplace.ShortCut = .Cell(1,44)       :  mnuReplace.Visible = VAL(.Cell(2,44))
            mnuReplaceinFiles.Caption = .Cell(0,45)      :  mnuReplaceinFiles.ShortCut = .Cell(1,45)       :  mnuReplaceinFiles.Visible = VAL(.Cell(2,45))
            mnuFindDeclare.Caption = .Cell(0,46)      :  mnuFindDeclare.ShortCut = .Cell(1,46)       :  mnuFindDeclare.Visible = VAL(.Cell(2,46))
            mnuGoToLine.Caption = .Cell(0,47)      :  mnuGoToLine.ShortCut = .Cell(1,47)       :  mnuGoToLine.Visible = VAL(.Cell(2,47))
            OptionsMenu.Caption = .Cell(0,48)      :  OptionsMenu.ShortCut = .Cell(1,48)       :  OptionsMenu.Visible = VAL(.Cell(2,48))
            Mnu_FontMenu.Caption = .Cell(0,49)      :  Mnu_FontMenu.ShortCut = .Cell(1,49)       :  Mnu_FontMenu.Visible = VAL(.Cell(2,49))
            Mnu_Hilight.Caption = .Cell(0,50)      :  Mnu_Hilight.ShortCut = .Cell(1,50)       :  Mnu_Hilight.Visible = VAL(.Cell(2,50))
            Mnu_WordWrap.Caption = .Cell(0,51)      :  Mnu_WordWrap.ShortCut = .Cell(1,51)       :  Mnu_WordWrap.Visible = VAL(.Cell(2,51))
            Mnu_AutoIndent.Caption = .Cell(0,52)      :  Mnu_AutoIndent.ShortCut = .Cell(1,52)       :  Mnu_AutoIndent.Visible = VAL(.Cell(2,52))
            Mnu_AutoComplete.Caption = .Cell(0,53)      :  Mnu_AutoComplete.ShortCut = .Cell(1,53)       :  Mnu_AutoComplete.Visible = VAL(.Cell(2,53))
            Mnu_CommentBlock.Caption = .Cell(0,54)      :  Mnu_CommentBlock.ShortCut = .Cell(1,54)       :  Mnu_CommentBlock.Visible = VAL(.Cell(2,54))
            Mnu_UnCommentBlock.Caption = .Cell(0,55)      :  Mnu_UnCommentBlock.ShortCut = .Cell(1,55)       :  Mnu_UnCommentBlock.Visible = VAL(.Cell(2,55))
            Mnu_Lowercase.Caption = .Cell(0,56)      :  Mnu_Lowercase.ShortCut = .Cell(1,56)       :  Mnu_Lowercase.Visible = VAL(.Cell(2,56))
            Mnu_Uppercase.Caption = .Cell(0,57)      :  Mnu_Uppercase.ShortCut = .Cell(1,57)       :  Mnu_Uppercase.Visible = VAL(.Cell(2,57))
            mnuRun.Caption = .Cell(0,58)      :  mnuRun.ShortCut = .Cell(1,58)       :  mnuRun.Visible = VAL(.Cell(2,58))
            mnuCompile.Caption = .Cell(0,59)      :  mnuCompile.ShortCut = .Cell(1,59)       :  mnuCompile.Visible = VAL(.Cell(2,59))
            mnuRunDebug.Caption = .Cell(0,60)      :  mnuRunDebug.ShortCut = .Cell(1,60)       :  mnuRunDebug.Visible = VAL(.Cell(2,60))
            IconsetMenu.Caption = .Cell(0,61)      :  IconsetMenu.ShortCut = .Cell(1,61)       :  IconsetMenu.Visible = VAL(.Cell(2,61))
            FBCompileMenu.Caption = .Cell(0,62)      :  FBCompileMenu.ShortCut = .Cell(1,62)       :  FBCompileMenu.Visible = VAL(.Cell(2,62))
            FBRunMenu.Caption = .Cell(0,63)      :  FBRunMenu.ShortCut = .Cell(1,63)       :  FBRunMenu.Visible = VAL(.Cell(2,63))
            FBDLLMenu.Caption = .Cell(0,64)      :  FBDLLMenu.ShortCut = .Cell(1,64)       :  FBDLLMenu.Visible = VAL(.Cell(2,64))
            mnuNViewBookMark.Caption = .Cell(0,65)      :  mnuNViewBookMark.ShortCut = .Cell(1,65)       :  mnuNViewBookMark.Visible = VAL(.Cell(2,65))
            mnuAddBookMark.Caption = .Cell(0,66)      :  mnuAddBookMark.ShortCut = .Cell(1,66)       :  mnuAddBookMark.Visible = VAL(.Cell(2,66))
            mnuDelBookMark.Caption = .Cell(0,67)      :  mnuDelBookMark.ShortCut = .Cell(1,67)       :  mnuDelBookMark.Visible = VAL(.Cell(2,67))
            mnuNextBookMark.Caption = .Cell(0,68)      :  mnuNextBookMark.ShortCut = .Cell(1,68)       :  mnuNextBookMark.Visible = VAL(.Cell(2,68))
            mnuPrevBookMark.Caption = .Cell(0,69)      :  mnuPrevBookMark.ShortCut = .Cell(1,69)       :  mnuPrevBookMark.Visible = VAL(.Cell(2,69))
            mnuGoToBookMark.Caption = .Cell(0,70)      :  mnuGoToBookMark.ShortCut = .Cell(1,70)       :  mnuGoToBookMark.Visible = VAL(.Cell(2,70))
            mnuExternApps.Caption = .Cell(0,71)      :  mnuExternApps.ShortCut = .Cell(1,71)       :  mnuExternApps.Visible = VAL(.Cell(2,71))
            mnuExternalApp1.Caption = .Cell(0,72)      :  mnuExternalApp1.ShortCut = .Cell(1,72)       :  mnuExternalApp1.Visible = VAL(.Cell(2,72))
            mnuExternalApp2.Caption = .Cell(0,73)      :  mnuExternalApp2.ShortCut = .Cell(1,73)       :  mnuExternalApp2.Visible = VAL(.Cell(2,73))
            mnuExternalApp3.Caption = .Cell(0,74)      :  mnuExternalApp3.ShortCut = .Cell(1,74)       :  mnuExternalApp3.Visible = VAL(.Cell(2,74))
            mnuExternalApp4.Caption = .Cell(0,75)      :  mnuExternalApp4.ShortCut = .Cell(1,75)       :  mnuExternalApp4.Visible = VAL(.Cell(2,75))
            mnuAutoDeclare.Caption = .Cell(0,76)      :  mnuAutoDeclare.ShortCut = .Cell(1,76)       :  mnuAutoDeclare.Visible = VAL(.Cell(2,76))
            mnuBeautifyCode.Caption = .Cell(0,77)      :  mnuBeautifyCode.ShortCut = .Cell(1,77)       :  mnuBeautifyCode.Visible = VAL(.Cell(2,77))
            mnuCommandLine.Caption = .Cell(0,78)      :  mnuCommandLine.ShortCut = .Cell(1,78)       :  mnuCommandLine.Visible = VAL(.Cell(2,78))
            mnuCalcExe.Caption = .Cell(0,79)      :  mnuCalcExe.ShortCut = .Cell(1,79)       :  mnuCalcExe.Visible = VAL(.Cell(2,79))
            mnuNConvter.Caption = .Cell(0,80)      :  mnuNConvter.ShortCut = .Cell(1,80)       :  mnuNConvter.Visible = VAL(.Cell(2,80))
            mnuCharMapExe.Caption = .Cell(0,81)      :  mnuCharMapExe.ShortCut = .Cell(1,81)       :  mnuCharMapExe.Visible = VAL(.Cell(2,81))
            mnuColorPicker.Caption = .Cell(0,82)      :  mnuColorPicker.ShortCut = .Cell(1,82)       :  mnuColorPicker.Visible = VAL(.Cell(2,82))
            mnuToolKey.Caption = .Cell(0,83)      :  mnuToolKey.ShortCut = .Cell(1,83)       :  mnuToolKey.Visible = VAL(.Cell(2,83))
            ContentHelpMenu.Caption = .Cell(0,84)      :  ContentHelpMenu.ShortCut = .Cell(1,84)       :  ContentHelpMenu.Visible = VAL(.Cell(2,84))
            ContentTopicHelpMenu.Caption = .Cell(0,85)      :  ContentTopicHelpMenu.ShortCut = .Cell(1,85)       :  ContentTopicHelpMenu.Visible = VAL(.Cell(2,85))
            Content2Menu.Caption = .Cell(0,86)      :  Content2Menu.ShortCut = .Cell(1,86)       :  Content2Menu.Visible = VAL(.Cell(2,86))
            WinHelpMenu.Caption = .Cell(0,87)      :  WinHelpMenu.ShortCut = .Cell(1,87)       :  WinHelpMenu.Visible = VAL(.Cell(2,87))
            mnuCloseMFE_Tab.Caption = .Cell(0,88)      :  mnuCloseMFE_Tab.ShortCut = .Cell(1,88)       :  mnuCloseMFE_Tab.Visible = VAL(.Cell(2,88))
        END WITH
    END IF


    SetToolsMenus

    BIND  IDE.MenuFuncPtr(mnuNew.Tag)  TO MFE_NewFile
    BIND  IDE.MenuFuncPtr(mnuOpen.Tag)  TO MFE_Open
    BIND  IDE.MenuFuncPtr(mnuOpenFileFromWeb.Tag)  TO mnuOpenFileFromWeb_Click
    BIND  IDE.MenuFuncPtr(mnuSave.Tag)  TO MFE_Save
    BIND  IDE.MenuFuncPtr(mnuSaveAs.Tag)  TO MFE_SaveAs
    BIND  IDE.MenuFuncPtr(mnuSaveAll.Tag)  TO MFE_SaveAll
    BIND  IDE.MenuFuncPtr(mnuOpenProj.Tag)  TO MFE_OpenProject
    BIND  IDE.MenuFuncPtr(mnuSaveProj.Tag)  TO MFE_SaveProject
    BIND  IDE.MenuFuncPtr(mnuCloseProjFiles.Tag)  TO MFE_CloseProjectFiles
    BIND  IDE.MenuFuncPtr(mnuClose.Tag)  TO MFE_Close
    BIND  IDE.MenuFuncPtr(mnuCloseAll.Tag)  TO MFE_CloseAll
    BIND  IDE.MenuFuncPtr(PrintSetupMenu.Tag)  TO pagesetupclick
    BIND  IDE.MenuFuncPtr(PrintMenu.Tag)  TO pageprintclick
    BIND  IDE.MenuFuncPtr(ExitMenu.Tag)  TO ExitClick
    BIND  IDE.MenuFuncPtr(mnuViewModeSimple.Tag)  TO mnuViewModeSimple_Click
    BIND  IDE.MenuFuncPtr(mnuViewModeNovice.Tag)  TO mnuViewModeNovice_Click
    BIND  IDE.MenuFuncPtr(mnuViewModeIntermediate.Tag)  TO mnuViewModeIntermediate_Click
    BIND  IDE.MenuFuncPtr(mnuViewModeExpert.Tag)  TO mnuViewModeExpert_Click
    BIND  IDE.MenuFuncPtr(mnuViewLeftPanel.Tag)  TO mnuViewLeftPanel_Click
    BIND  IDE.MenuFuncPtr(mnuViewBottomPanel.Tag)  TO mnuViewBottomPanel_Click
    BIND  IDE.MenuFuncPtr(mnuViewRightPanel.Tag)  TO mnuViewRightPanel_Click
    BIND  IDE.MenuFuncPtr(QuickSearchMnu.Tag)  TO VisibileQuickSearchClick
    BIND  IDE.MenuFuncPtr(mnuViewStatusBar.Tag)  TO mnuViewStatusBar_Click
    BIND  IDE.MenuFuncPtr(mnuViewFormDesigner.Tag)  TO mnuViewFormDesigner_Click
    BIND  IDE.MenuFuncPtr(mnuViewTopPanel.Tag)  TO mnuViewTopPanel_Click
    BIND  IDE.MenuFuncPtr(Mnu_SetLineNumbers.Tag)  TO Mnu_SetLineNumbersClick
    BIND  IDE.MenuFuncPtr(Mnu_ViewIndentation.Tag)  TO Mnu_ViewIndentationClick
    BIND  IDE.MenuFuncPtr(Mnu_CodeFolding.Tag)  TO Mnu_CodeFolding_Click
    BIND  IDE.MenuFuncPtr(Mnu_CodeFoldingCollapseAll.Tag)  TO Mnu_CodeFoldingCollapseAll_Click
    BIND  IDE.MenuFuncPtr(Mnu_CodeFoldingExpandAll.Tag)  TO Mnu_CodeFoldingExpandAll_Click
    BIND  IDE.MenuFuncPtr(Mnu_ViewLastTab.Tag)  TO Mnu_ViewLastTab_Click
    BIND  IDE.MenuFuncPtr(mnuMagnifyFont.Tag)  TO mnuMagnifyFont_Click
    BIND  IDE.MenuFuncPtr(mnuMinifyFont.Tag)  TO mnuMinifyFont_Click
    BIND  IDE.MenuFuncPtr(mnuDeleteBlankLines.Tag)  TO mnuRemoveBlankLines_Click
    BIND  IDE.MenuFuncPtr(mnuTrimSpacesAtEnd.Tag)  TO mnuTrimSpacesAtEnd_Click
    BIND  IDE.MenuFuncPtr(mnuTabsToSpaces.Tag)  TO mnuTabsToSpaces_Click
    BIND  IDE.MenuFuncPtr(mnuSort.Tag)  TO mnuSort_Click
    BIND  IDE.MenuFuncPtr(mnuDateTime.Tag)  TO mnuDateTime_Click
    BIND  IDE.MenuFuncPtr(mnuInsertFile.Tag)  TO mnuInsertFile_Click
    BIND  IDE.MenuFuncPtr(mnuTxtFind.Tag)  TO FindReplaceForm_Search
    BIND  IDE.MenuFuncPtr(mnuFindinFiles.Tag)  TO FindInFiles
    BIND  IDE.MenuFuncPtr(mnuFindNext.Tag)  TO FindReplaceForm_NextExecute
    BIND  IDE.MenuFuncPtr(mnuFindPrev.Tag)  TO FindReplaceForm_PrevExecute
    BIND  IDE.MenuFuncPtr(mnuReplace.Tag)  TO FindReplaceForm_Replace
    BIND  IDE.MenuFuncPtr(mnuReplaceinFiles.Tag)  TO ReplaceInFiles
    BIND  IDE.MenuFuncPtr(mnuGoToLine.Tag)  TO IDE_GotoLineNumber
    BIND  IDE.MenuFuncPtr(OptionsMenu.Tag)  TO IDE_Conf_Form_Show
    BIND  IDE.MenuFuncPtr(Mnu_FontMenu.Tag)  TO Mnu_FontMenuClick
    BIND  IDE.MenuFuncPtr(Mnu_Hilight.Tag)  TO Mnu_HilightClick
    BIND  IDE.MenuFuncPtr(Mnu_WordWrap.Tag)  TO Mnu_WordWrapClick
    BIND  IDE.MenuFuncPtr(Mnu_AutoIndent.Tag)  TO Mnu_AutoIndentClick
    BIND  IDE.MenuFuncPtr(Mnu_AutoComplete.Tag)  TO Mnu_AutoCompleteClick
    BIND  IDE.MenuFuncPtr(Mnu_CommentBlock.Tag)  TO mnuCommentBlockClick
    BIND  IDE.MenuFuncPtr(Mnu_UnCommentBlock.Tag)  TO mnuUnCommentBlockClick
    BIND  IDE.MenuFuncPtr(Mnu_Lowercase.Tag)  TO Mnu_LowercaseClick
    BIND  IDE.MenuFuncPtr(Mnu_Uppercase.Tag)  TO Mnu_UppercaseClick
    BIND  IDE.MenuFuncPtr(mnuRun.Tag)  TO RunClick
    BIND  IDE.MenuFuncPtr(mnuCompile.Tag)  TO CompileClick
    BIND  IDE.MenuFuncPtr(mnuRunDebug.Tag)  TO DebugCompileClick
    BIND  IDE.MenuFuncPtr(IconsetMenu.Tag)  TO IconsetClick
    BIND  IDE.MenuFuncPtr(FBCompileMenu.Tag)  TO FBCompileClick
    BIND  IDE.MenuFuncPtr(FBRunMenu.Tag)  TO FBRunClick
    BIND  IDE.MenuFuncPtr(FBDLLMenu.Tag)  TO FBDLLClick
    BIND  IDE.MenuFuncPtr(mnuNViewBookMark.Tag)  TO mnuNViewBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuAddBookMark.Tag)  TO mnuAddBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuDelBookMark.Tag)  TO mnuDelBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuNextBookMark.Tag)  TO mnuNextBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuPrevBookMark.Tag)  TO mnuPrevBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuGoToBookMark.Tag)  TO mnuGoToBookMark_Click
    BIND  IDE.MenuFuncPtr(mnuExternApps.Tag)  TO IDE_Cong_ShowExternApp
    BIND  IDE.MenuFuncPtr(mnuExternalApp1.Tag)  TO mnuExternalApp1_Click
    BIND  IDE.MenuFuncPtr(mnuExternalApp2.Tag)  TO mnuExternalApp2_Click
    BIND  IDE.MenuFuncPtr(mnuExternalApp3.Tag)  TO mnuExternalApp3_Click
    BIND  IDE.MenuFuncPtr(mnuExternalApp4.Tag)  TO mnuExternalApp4_Click
    BIND  IDE.MenuFuncPtr(mnuAutoDeclare.Tag)  TO mnuAutoDeclare_Click
    BIND  IDE.MenuFuncPtr(mnuBeautifyCode.Tag)  TO mnuBeautifyCode_Click
    BIND  IDE.MenuFuncPtr(mnuMenuDesigner.Tag)  TO mnuMenuDesigner_Click
    BIND  IDE.MenuFuncPtr(mnuCommandLine.Tag)  TO mnuCommandLine_Click
    BIND  IDE.MenuFuncPtr(mnuCalcExe.Tag)  TO mnuCalcExe_Click
    BIND  IDE.MenuFuncPtr(mnuNConvter.Tag)  TO NConv_Show
    BIND  IDE.MenuFuncPtr(mnuCharMapExe.Tag)  TO mnuCharMapExe_Click
    BIND  IDE.MenuFuncPtr(mnuColorPicker.Tag)  TO mnuColorPicker_Click
    BIND  IDE.MenuFuncPtr(mnuToolKey.Tag)  TO mnuToolKey_Click
    BIND  IDE.MenuFuncPtr(ContentHelpMenu.Tag)  TO mnuHelpClick
    BIND  IDE.MenuFuncPtr(ContentTopicHelpMenu.Tag)  TO HelpOnTopicClick
    BIND  IDE.MenuFuncPtr(Content2Menu.Tag)  TO mnuHelp2Click
    BIND  IDE.MenuFuncPtr(WinHelpMenu.Tag)  TO mnuHelpWinClick
    BIND  IDE.MenuFuncPtr(mnuCloseMFE_Tab.Tag)  TO MFE_Close

    Mnu_RightJustify                            'weirdness, need to reset right justify
END SUB
     


