

CREATE IDE_Conf_VersionInfoForm AS QFORM
    Caption = "VersionInfo Resources"
    Width = 556
    Height = 502
    Center
    CREATE IDE_Conf_ManifestEmbedCheckBox AS QCHECKBOX
        Font.Size = 10
        Caption = "Embed Manifest"
        Left = 14
        Top = 8
        Width = 505
        Height = 20
        TabOrder = 1
        Checked = IDE.EmbedManifest
    END CREATE

    CREATE IDE_Conf_VersionInfoCheckBox AS QCHECKBOX
        Font.Size = 10
        Caption = "Embed Version Info"
        Left = 14
        Top = 38
        Width = 505
        Height = 20
        TabOrder = 1
        Checked = IDE.EmbedVersionInfo
    END CREATE

    CREATE IDE_Conf_VersionInfoGrid AS QSTRINGGRID
        Left = 13
        Top = 70  '147
        Width = 505
        Height = 330    '257
        fixedrows = 1
        FixedCols = 1
        ColCount = 2
        RowCount = 17
        ColWidths(0) = 170
        ColWidths(1) = 335
        EditorMode = True
        AddOptions(goEditing, goDrawFocusSelected, goTabs, goColSizing, goThumbTracking)
        DefaultRowHeight = 20
        Cell(0,0) = "VersionInfo"
        Cell(1,0) = "Value"
        Cell(0,1) = "FILEVERSION"       : Cell(1,1) = REPLACESUBSTR$(IDE.FileVersion, ".", ",")
        Cell(0,2) = "PRODUCTVERSION"    : Cell(1,2) = REPLACESUBSTR$(IDE.ProductVersion, ".", ",")
        Cell(0,3) = "FILEOS"            : Cell(1,3) = "0x00010001L"
        Cell(0,4) = "FILETYPE"          : Cell(1,4) = "0x00000001L"
        Cell(0,5) = " "
        Cell(0,6) = "CompanyName"       : Cell(1,6) = IDE.CompanyName
        Cell(0,7) = "Contact e-mail"    : Cell(1,7) = IDE.CompanyEmail 
        Cell(0,8) = "FileDescription"   : Cell(1,8) = IDE.FileDescription
        Cell(0,9) = "FileVersion"       : Cell(1,9) = REPLACESUBSTR$(IDE.FileVersion, ",", ".")
        Cell(0,10) = "DevelopmentFile"  : Cell(1,10) = IIF(IDE.MainFileForCompiler <> "", IDE.MainFileForCompiler, IDE.MFEActiveFile)
        Cell(0,11) = "LegalCopyright"   : Cell(1,11) = IDE.LegalCopyright
        Cell(0,12) = ""
        Cell(0,13) = ""
        Cell(0,14) = ""
        Cell(0,15) = ""
    END CREATE



    CREATE IDE_Conf_VersionInfoOKButton AS QBUTTON
        Caption = "OK"
        Left = 443
        Top = 430
        TabOrder = 4
        Default = True
        Cancel = True
        OnClick = IDE_Conf_VersionInfoForm_Close
    END CREATE
 
END CREATE



'=======================================================================
'    Main configuration / Options form
'=======================================================================
CREATE IDE_Conf_Form AS QFORM
    Caption = "Configuration"
    Width = 666
    Height = 604
    OnShow = IDE_Conf_Form_Refresh

    CREATE IDE_Conf_DefaultButton AS QBUTTON
        Caption = "Defaults"
        Left = 24
        Top = 525
        Width = 67
        Height = 33
        TabOrder = 3
        OnClick = IDE_SetDefaultVariables
    END CREATE

    CREATE IDE_Conf_LoadButton AS QBUTTON
        Caption = "Load"
        Left = IDE_Conf_DefaultButton.Left + IDE_Conf_DefaultButton.Width + 30
        Top = 525
        Width = 67
        Height = 33
        TabOrder = 2
        Default = True
        OnClick = IDE_Conf_Form_LoadIni
    END CREATE

    CREATE IDE_Conf_OKButton AS QBUTTON
        Caption = "Save"
        Left = 473
        Top = 525
        Width = 67
        Height = 33
        TabOrder = 0
        Default = True
        OnClick = IDE_Conf_Form_SaveVars
    END CREATE

    CREATE IDE_Conf_SaveProjButton AS QBUTTON
        Caption = "Save As Project"
        Left = 310
        Top = 525
        Width = 128
        Height = 33
        TabOrder = 0
        OnClick = MFE_SaveProject
    END CREATE


    CREATE IDE_Conf_CloseButton AS QBUTTON
        Caption = "Close"
        Left = 561
        Top = 525
        Width = 67
        Height = 33
        TabOrder = 1
        Cancel = True
        OnClick = IDE_Conf_Form_Close
    END CREATE



    CREATE IDE_Conf_TabControl AS QTABCONTROL
        Top = 0
        Height = 520
        Width = IDE_Conf_Form.ClientWidth
		TabInactiveColor = RGB(225,226,229)
        AddTabs "  Colors / Formating  ", _
                "  Other Options  ", _
                "  Menus / Short Cuts  ", _
                "  RQ Compiler / Paths  ", _
                "  FreeBasic /Java  ", _
                "  External Apps  "
        TabIndex = 0
        OnChange = IDE_Conf_TabChange
    END CREATE

'____________________Panel with Editor / Highlighter options __________________________________________
    CREATE IDE_Conf_EditorGroupBox AS QGROUPBOX
        Caption = "Editor / Highlighter"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48
        TabOrder = 3

        CREATE IDE_Conf_FontButton AS QBUTTON
            Caption = "Font ..."
            Left = 255
            Top = 27
            Width = 163
            Height = 24
            TabOrder = 12
            OnClick = IDE_Conf_PickFont
        END CREATE

        CREATE IDE_Conf_FontColorLabel AS QLABEL
            Left = 260
            Top = 64
            Width = 22
            Height = 22
            Color = 0
        END CREATE
        CREATE IDE_Conf_FontColorButton AS QBUTTON
            Caption = "Font Color"
            Left = 296
            Top = 60
            Width = 122
            TabOrder = 1
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_FontBackLabel AS QLABEL
            Left = 260
            Top = 96
            Width = 22
            Height = 22
            Color = &HFFFFFF
        END CREATE

        CREATE IDE_Conf_FontBackButton AS QBUTTON
            Caption = "Font Background"
            Left = 296
            Top = 94
            Width = 122
            TabOrder = 2
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_BoldCheckBox AS QCHECKBOX
            Caption = "Bold"
            Left = 262
            Top = 136
            TabOrder = 3
            OnClick = IDE_Conf_RichEdit_Store
        END CREATE
        CREATE IDE_Conf_ItalicCheckBox AS QCHECKBOX
            Caption = "Italic"
            Left = 262
            Top = 160
            TabOrder = 4
            OnClick = IDE_Conf_RichEdit_Store
        END CREATE

        CREATE IDE_Conf_UnderLineCheckBox AS QCHECKBOX
            Caption = "Underline"
            Left = 262
            Top = 186
            TabOrder = 5
            OnClick = IDE_Conf_RichEdit_Store
        END CREATE


        CREATE IDE_Conf_TabBackLabel AS QLABEL
            Left = 260
            Top = 225
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_TabBackButton AS QBUTTON
            Caption = "Tab Background"
            Left = 296
            Top = 225
            Width = 122
            TabOrder = 4
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_TabInactiveLabel AS QLABEL
            Left = 260
            Top = 259
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_TabForeButton AS QBUTTON
            Caption = "Tab Inactive"
            Left = 296
            Top = 259
            Width = 122
            TabOrder = 4
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_SelForeLabel AS QLABEL
            Left = 260
            Top = 289
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_SelForeButton AS QBUTTON
            Caption = "Selection Foreground"
            Left = 296
            Top = 290
            Width = 122
            TabOrder = 13
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_SelBackLabel AS QLABEL
            Left = 260
            Top = 324
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_SelBackButton AS QBUTTON
            Caption = "Selection Background"
            Left = 296
            Top = 324
            Width = 122
            TabOrder = 14
            OnClick = IDE_Conf_SelectColor
        END CREATE
        CREATE IDE_Conf_LineNumForeLabel AS QLABEL
            Left = 260
            Top = 360
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_LineNumForeButton AS QBUTTON
            Caption = "Line Num Foreground"
            Left = 296
            Top = 360
            Width = 122
            TabOrder = 5
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_LineNumBackLabel AS QLABEL
            Left = 260
            Top = 393
            Width = 22
            Height = 22
        END CREATE

        CREATE IDE_Conf_LineNumBackButton AS QBUTTON
            Caption = "Line Num Background"
            Left = 296
            Top = 393
            Width = 122
            TabOrder = 16
            OnClick = IDE_Conf_SelectColor
        END CREATE

        CREATE IDE_Conf_ActiveLineBackLabel AS QLABEL
            Left = 260
            Top = 426
            Width = 22
            Height = 22
            Color = -1
            Visible = NOT!(IDE.ActiveLineBack)
            OnClick = IDE_Conf_ActiveLineSelectColor
        END CREATE


        CREATE IDE_Conf_ActiveLineBackButton AS QCHECKBOX
            Caption = "Active Line Highlighting"
            Left = 296
            Top = 426
            Width = 180
            Checked = False
            TabOrder = 17
            OnClick = IDE_Conf_ToggleActiveLineColor
        END CREATE

        CREATE IDE_Conf_TextRichEdit AS QLISTBOX 'QRICHEDIT
            Font = IDE.MainFont
            Left = 19
            Top = 29
            Width = 217
            Height = 160
            AddItems "default", "'Comment", "Number -.1234..", "STRINGS", "$Preprocessor", "Operators <=>/+", "KeyWords", "KeyWords 2", "KeyWords 3"
            ItemIndex = 0
            OnClick = IDE_Conf_RichEdit_Repaint
            'IDE_Conf_Form_Refresh
'            ReadOnly = True
'            AddStrings "default", "'Comment", "Number -.1234..", "STRINGS", "$Preprocessor", "Operators <=>/+", "KeyWords", "KeyWords 2", "KeyWords 3"
'             OnKeyDown = IDE_Conf_TextRichEditKeyDown'(Key AS WORD, Shift AS INTEGER) Key held down 2 WG 
'             OnMouseDown = IDE_Conf_TextRichEditMouseDown' (Button%, X%, Y%, Shift%) 

            'SUB IDE_Conf_TextRichEditKeyDown(Key AS WORD, Shift AS INTEGER) 
            '    IDE_Conf_Form_Refresh
            'END SUB
            '
            'SUB IDE_Conf_TextRichEditMouseDown(Button%, X%, Y%, Shift%) 
            '    IDE_Conf_Form_Refresh
            'END SUBIDE_Conf_TextRichEditMouseDown' 


        END CREATE

        CREATE IDE_Conf_MainLanguageLabel AS QLABEL
            Left = 19
            Top = 200
            Width = 217
            Font.Size = 12
            Caption = "Default Language"
        END CREATE

        CREATE IDE_Conf_MainLanguage AS QCOMBOBOX
            Style = csDropDownList
            Left = 19
            Top = 230
            Width = 140
            Height = 32
            Font.Size = 11
            AddItems("RapidQ                                     8",_ 
                    "FreeBasic                                  75", _
                    "Visual Basic                               8", _
                    "Blitz Basic                                66", _
                    "Pure Basic                                 67", _
                    "IBasic                                     30", _
                    "Power Basic                                51", _
                    "ASM                                        34", _
                    "VB Script                                   28", _
                    "ASP / PHP                                   4", _
                    "python                                      2", _
                    "C/C++                                       3", _
                    "pascal                                      18", _
                    "ruby                                        22", _
                    "fortran                                     36", _
                    "html                                        4", _
                    "perl                                        6", _
                    "lua                                         15")

            ItemIndex = 0               'set to first one
            OnChange = IDE_SetLanguage
        END CREATE

        CREATE IDE_Conf_LoadKeywordsButton AS QBUTTON
            Caption = "Load Keywords"
            Enabled = False
            Left = 445
            Top = 14
            Width = 166
            TabOrder = 7
            OnClick = IDE_Conf_LoadKeywords
        END CREATE

        CREATE IDE_Conf_ListBox AS QLISTBOX
            Font.Size = 10
            Left = 441
            Top = 45
            Width = 174
            Height = 376
            TabOrder = 6
        END CREATE

        CREATE IDE_Conf_Label6 AS QLABEL
            Caption = "Spaces"
            Left = 179
            Top = 279
            Width = 36
            Transparent = 1
        END CREATE

        CREATE IDE_Conf_NumSpacesForTabsEdit AS QEDIT
            Text = "4"
            Left = 128
            Top = 275
            Width = 30
            TabOrder = 8
        END CREATE
        CREATE IDE_Conf_UseTabsCheckBox AS QCHECKBOX
            Caption = "Use tabs/ else"
            Left = 21
            Top = 276
            Width = 105
            Height = 20
            TabOrder = 9
        END CREATE
        CREATE IDE_Conf_LineNumCheckBox AS QCHECKBOX
            Caption = "Line Numbers"
            Left = 21
            Top = 305
            TabOrder = 10
        END CREATE
        CREATE IDE_Conf_AutoIndentCheckBox AS QCHECKBOX
            Caption = "Auto Indent"
            Left = 21
            Top = 331
            TabOrder = 10
        END CREATE
        CREATE IDE_Conf_CodeFoldingCheckBox AS QCHECKBOX
            Caption = "Code folding"
            Left = 21
            Top = 358
            TabOrder = 11
        END CREATE
        CREATE IDE_Conf_ViewIndentsCheckBox AS QCHECKBOX
            Caption = "View Indents"
            Left = 21
            Top = 385
            TabOrder = 15
        END CREATE
        CREATE IDE_Conf_HiLiteCheckBox AS QCHECKBOX
            Caption = "Syntax Highlighting"
            Left = 21
            Top = 407
            Width = 240
            TabOrder = 15
        END CREATE
        CREATE IDE_Conf_WordWrapCheckBox AS QCHECKBOX
            Caption = "Word Wrap"
            Left = 21
            Top = 429
            Width = 240
            TabOrder = 15
        END CREATE
    END CREATE


'____________________Panel with Rapidq compiler paths and options___________________________________________
    CREATE IDE_Conf_PathsGroupBox AS QGROUPBOX
        Font.Size=11
        Caption = "Paths / Compile Options"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48
        TabOrder = 3
        Visible = False

        CREATE IDE_Conf_LibLabel AS QLABEL
            Caption = "Library / DLL location"
            Left = 12
            Top = 77
            Width = 180
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_CompilerLabel AS QLABEL
            Caption = "Compiler location"
            Left = 12
            Top = 24
            Width = 180
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_IncFilesLabel AS QLABEL
            Caption = "Include Files location"
            Left = 12
            Top = 131
            Width = 180
            Height = 22
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_HelpFileLabel AS QLABEL
            Caption = "Help file"
            Left = 16
            Top = 184
            Width = 180
            Height = 22
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_IconDirLabel AS QLABEL
            Caption = "Icon directory"
            Left = 16
            Top = 236
            Width = 180
            Height = 22
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_TemplateDirLabel AS QLABEL
            Caption = "Template directory"
            Left = 14
            Top = 290
            Width = 180
            Transparent = 1
        END CREATE

        CREATE IDE_Conf_CompilerPathEdit AS QEDIT
            Text = "\Rapidq\rc.exe"
            Left = 12
            Top = 47
            Width = 329
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_CompilerPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 45
            Width = 36
            Height = 26
            TabOrder = 4
            Tag = 1
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        CREATE IDE_Conf_HelpFilePathEdit AS QEDIT
            Text = "\Rapidq\Rapidq.chm"
            Left = 12
            Top = 203
            Width = 329
            TabOrder = 5
        END CREATE
        CREATE IDE_Conf_HelpPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 201
            Width = 36
            Height = 26
            TabOrder = 6
            Tag = 6
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        CREATE IDE_Conf_LibPathEdit AS QEDIT
            Text = "\Rapidq\lib"
            Left = 12
            Top = 98
            Width = 329
            TabOrder = 7
        END CREATE
        CREATE IDE_Conf_LibPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 96
            Width = 36
            Height = 26
            Tag = 2
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        CREATE IDE_Conf_IconPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 256
            Width = 36
            Height = 26
            TabOrder = 13
            Tag = 4
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        CREATE IDE_Conf_IconPathEdit AS QEDIT
            Text = "\Rapidq\icon"
            Left = 12
            Top = 258
            Width = 329
            TabOrder = 14
        END CREATE

        CREATE IDE_Conf_IncludePathEdit AS QEDIT
            Text = "\Rapidq\include"
            Left = 12
            Top = 152
            Width = 329
            TabOrder = 5
        END CREATE
        CREATE IDE_Conf_IncludePathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 149
            Width = 36
            Height = 26
            TabOrder = 4
            Tag = 3
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        CREATE IDE_Conf_TemplatesPathEdit AS QEDIT
            Text = "\Rapidq\templates"
            Left = 12
            Top = 313
            Width = 329
            TabOrder = 8
        END CREATE
        CREATE IDE_Conf_TemplatesPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 310
            Width = 36
            Height = 27
            TabOrder = 9
            Tag = 5
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        CREATE IDE_Conf_OptimizeCheckBox AS QCHECKBOX
            Caption = "Default Optimize On "
            Left = 420
            Top = 25
            Width = 177
            TabOrder = 8
        END CREATE
        CREATE IDE_Conf_TypeCheckCheckBox AS QCHECKBOX
            Caption = "Default Typecheck On"
            Left = 420
            Top = 50
            Width = 153
            TabOrder = 1
        END CREATE
        CREATE IDE_Conf_VerboseCheckBox AS QCHECKBOX
            Caption = "Default Verbose On"
            Left = 420
            Top = 75
            Width = 169
            TabOrder = 2
        END CREATE
        CREATE IDE_Conf_ByteCodeCheckBox AS QCHECKBOX
            Caption = "Compile Byte Code"
            Left = 420
            Top = 100
            Width = 169
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_GenManifestCheckBox AS QCHECKBOX
            Caption = "Generate Manifest file"
            Left = 420
            Top = 125
            Width = 150
            TabOrder = 15
            OnClick = IDE_Config_ResetEmbed
        END CREATE

        CREATE IDE_Conf_GenManifestButton AS QBUTTON
            Caption = ">"
            Left =IDE_Conf_GenManifestCheckBox.Left + IDE_Conf_GenManifestCheckBox.Width + 8
            Top = IDE_Conf_GenManifestCheckBox.Top
            Width = 28
            Height = IDE_Conf_GenManifestCheckBox.Height
            OnClick = IDE_Conf_VersionInfoForm_Show
        END CREATE

        CREATE IDE_Conf_SaveBeforeCompileCheckBox AS QCHECKBOX
            Caption = "Save file before compile"
            Left = 420
            Top = 150
            Width = 180
            TabOrder = 16
        END CREATE

        CREATE IDE_Conf_SaveAllBeforeCompileCheckBox AS QCHECKBOX
            Caption = "Save All before compile"
            Left = 420
            Top = 175
            Width = 180
            TabOrder = 17
        END CREATE

        CREATE IDE_Conf_HiLightCompileErr AS QCHECKBOX
            Caption = "Goto Compile Error Line"
            Left = 420
            Top = 200
            Width = 180
            TabOrder = 18
        END CREATE

        CREATE IDE_Conf_UseAppDirectory AS QCHECKBOX
            Caption = "Set path to application"
            Left = 420
            Top = 225
            Width = 180
            TabOrder = 19
        END CREATE

        CREATE IDE_Conf_ConstDirectoryLabel AS QLABEL
            Caption = "Set path to location:"
            Left = 420
            Top = 250
            Width = 180
        END CREATE

        CREATE IDE_Conf_ConstDirectory AS QEDIT
            Text = ""
            Left = 420
            Top = 275
            Width = 180
            ShowHint = True
        END CREATE

        CREATE IDE_Conf_RunScriptLabel AS QLABEL
            Caption = "Run this file before compile"
            Left = 420
            Top = 315
            Width = 180
        END CREATE

        CREATE IDE_Conf_RunScriptEdit AS QEDIT
            Text = ""
            Left = 420
            Top = 335
            Width = 180
            Hint = "free parameters:" + CRLF + CRLF + gSubstitutionsString
            ShowHint = True
        END CREATE

        CREATE IDE_Conf_OpenExtLabel AS QLABEL
            Caption = "Open File Filter Mask (File types)"
            Left = 16
            Top = 360
            Width = 230
        END CREATE

        CREATE IDE_Conf_FileExtensionsListBox AS QEDIT
            Left = 16
            Top = 380
            Width = 500
            TabOrder = 9
        END CREATE

        CREATE IDE_Conf_SearchEngLabel AS QLABEL
            Caption = "Search Engine"
            Left = 16
            Top = 412
            Width = 180
            Transparent = 1
        END CREATE

        CREATE IDE_Conf_WebSearchEdit AS QEDIT
            Text = "http://www.google.com/search?hl=en&source=hp&q="
            Left = 16
            Top = 431
            Width = 500
            TabOrder = 12
        END CREATE
    END CREATE      'Paths tab



'____________________Panel with Other Options  __________________________________________________

    CREATE IDE_Conf_OtherGroupBox AS QGROUPBOX
        Caption = "Other Options"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48
        TabOrder = 3
        CREATE IDE_Conf_ShowSplashScreen AS QCHECKBOX
            Caption = "Show Splash Screen"
            Left = 12
            Top = 25
            Width = 177
            Checked = True
        END CREATE
        CREATE IDE_Conf_SaveSettingsOnExit AS QCHECKBOX
            Caption = "Save Settings on Exit"
            Left = 12
            Top = 55
            Width = 144
            TabOrder = 2
            Checked = True
        END CREATE
        CREATE IDE_Conf_SwitchToSubView AS QCHECKBOX
            Caption = "Switch to Sub/Func View after load"
            Left = 12
            Top = 85
            Width = 230
            TabOrder = 1
            Checked = True
        END CREATE
        CREATE IDE_Conf_SortSubs AS QCHECKBOX
            Caption = "Sort Sub/Func Names"
            Left = 12
            Top = 115
            Width = 230
            TabOrder = 1
            Checked = True
        END CREATE

        CREATE IDE_Conf_SingleInstance AS QCHECKBOX
            Caption = "Run only one instance of FreeQ IDE"
            Left = 12
            Top = 145
            Width = 230
            TabOrder = 4
        END CREATE

        CREATE IDE_Conf_NewFileAtStartUp AS QCHECKBOX
            Caption = "Open new tab at Startup"
            Left = 12
            Top = 175
            Width = 230
            TabOrder = 10
        END CREATE

        CREATE IDE_Conf_MenuIcons AS QCHECKBOX
            Caption = "Show Menu Icons"
            Hint = "Setting icons requires a program restart"
            ShowHint = True
            Left = 12
            Top = 205
            Width = 230
            TabOrder = 11
        END CREATE

        CREATE IDE_Conf_ShowWelcome AS QCHECKBOX
            Caption = "App Wizard/ Welcome at Startup"
            Hint = "Open the application wizard and welcome screen at startup"
            ShowHint = True
            Left = 12
            Top = 235
            Width = 230
            TabOrder = 12
        END CREATE


        'right side
        CREATE IDE_Conf_BackupFiles AS QCHECKBOX
            Caption = "Backup Files"
            Left = 362
            Top = 25
            Width = 230
            TabOrder = 6
        END CREATE

        CREATE IDE_Conf_BackupFilesExt AS QEDIT
            Left = 362
            Top = 55
            Width = 230
            TabOrder = 7
            Text = IDE.BackupFilesExt
            Hint = "Extension for Backup File"
            ShowHint = True
        END CREATE

        CREATE IDE_Conf_HighlightBraces AS QCHECKBOX
            Caption = "Highlight Braces (missing)"
            Left = 362
            Top = 85
            Width = 230
            TabOrder = 8
        END CREATE

        CREATE IDE_Conf_AutoComplete AS QCHECKBOX
            Caption = "Auto Complete"
            Left = 362
            Top = 115
            Width = 230
            TabOrder = 9
        END CREATE

        CREATE IDE_Conf_NewFileLabel AS QLABEL
            Caption = "Name of New file"
            Left = 362
            Top = 145
            Width = 230
        END CREATE

        CREATE IDE_Conf_NewFileNameEdit AS QEDIT
            Left = 362
            Top = 170
            Width = 230
            TabOrder = 10
            Text = IDE.NewFileName
            Hint = "Default name for inserting new file into editor"
            ShowHint = True
        END CREATE

        CREATE IDE_Conf_NewFileAutoSave AS QCHECKBOX
            Caption = "Auto Save New file"
            Left = 362
            Top = 195
            Width = 230
            TabOrder = 11
        END CREATE

        CREATE IDE_Conf_AutoOpenLastProj AS QCHECKBOX
            Caption = "Auto open last project"
            Left = 362
            Top = 220
            Width = 230
            Checked = False
            TabOrder = 12
        END CREATE

        CREATE IDE_Conf_FindDeclDialogBox AS QCHECKBOX
            Caption = "Float Find Declare dialog"
            Hint = "Set the mode for dialog box on Find Declaration"
            ShowHint = True
            Top = 245
            Left = 361
            Width = 230
            Checked = False
            TabOrder = 13
        END CREATE


        'bottom left
        CREATE IDE_Conf_AutoDeclGroupBox AS QGROUPBOX
            Caption = "Auto Declare Defaults"
            Left = 10
            Top = 267
            Width = 340
            Height = 196
            TabOrder = 3
            CREATE IDE_Conf_AutoDeclClipboardActiveFile AS QRADIOBUTTON
                Caption = "Declare statements to Clipboard (active file only)"
                Left = 18
                Top = 25
                Width = 280
            END CREATE
            CREATE IDE_Conf_AutoDeclClipboardAllFiles AS QRADIOBUTTON
                Caption = "Declare statments to Clipboard (all open files)"
                Left = 18
                Top = 52
                Width = 280
                TabOrder = 1
            END CREATE
            CREATE IDE_Conf_AutoDeclAtTopActiveFile AS QRADIOBUTTON
                Caption = "Put Declare statements at the top (active file only)"
                Left = 18
                Top = 78
                Width = 280
                TabOrder = 2
            END CREATE
            CREATE IDE_Conf_AutoDeclAtTopAllFiles AS QRADIOBUTTON
                Caption = "Put Declare statements at the top of each open file"
                Left = 18
                Top = 103
                Width = 280
                TabOrder = 4
            END CREATE
            CREATE IDE_Conf_AutoDeclInFile AS QRADIOBUTTON
                Caption = "Put All Declare statements in a file named:"
                Left = 18
                Top = 136
                Width = 280
                TabOrder = 5
            END CREATE
            CREATE IDE_Conf_AutoDeclInFileName AS QEDIT
                Text = IDE.AutoDeclInFileName
                Left = 16
                Top = 160
                Width = 310
                TabOrder = 3
            END CREATE
        END CREATE



        'bottom Right
        CREATE IDE_Conf_BeautifyGroupBox AS QGROUPBOX
            Caption = "Beautify Code Options"
            Left = 360
            Top = 327
            Width = 240
            Height = 136
            CREATE IDE_Conf_BeautifyCodeTabSpaces AS QLABEL
                Caption = "number of spaces to replace a tab"
                Left = 18
                Top = 25
                Width = 200
            END CREATE
            CREATE BeautifyEditS AS QEDIT
                Text = STR$(IDE.TabSpaces)
                Left = 18
                Top = 52
                Width = 160
                TabOrder = 1
            END CREATE
            CREATE BeautifyLabelC AS QLABEL
                Caption = "Spaces before Comments"
                Left = 18
                Top = 78
                Width = 200
            END CREATE
            CREATE BeautifyEditC AS QEDIT
                Text = "0"
                Left = 18
                Top = 103
                Width = 160
            END CREATE
        END CREATE
    END CREATE







'____________________Panel with FreeBasic compiler paths and options___________________________________________
    CREATE IDE_Conf_FBPathsGroupBox AS QGROUPBOX
        Font.Size=11
        Caption = "FreeBasic or Java Paths / Compiler Options"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48
        TabOrder = 3
        Visible = False

        CREATE IDE_Conf_IsJavaCheckBox AS QCHECKBOX
            Caption = "This is a Java compiler"
            Left = 12
            Top = 24
            Font.Size = 12
            Font.Bold = True
            Width = 240
            Height = 24
        END CREATE
        CREATE IDE_Conf_FBCompilerLabel AS QLABEL
            Caption = "Compiler location"
            Left = 12
            Top = 72
            Width = 180
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_FBCommandLineLabel AS QLABEL
            Caption = "compiler command line options"
            Left = 12
            Top = 146
            Width = 220
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_FBHelpFileLabel AS QLABEL
            Caption = "Help file"
            Left = 16
            Top = 234
            Width = 180
            Height = 22
            Transparent = 1
        END CREATE

        CREATE IDE_Conf_FBCompilerPathEdit AS QEDIT
            Text = "\Program Files (x86)\FreeBasic\fbc.exe"
            Left = 12
            Top = 97
            Width = 329
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_FBCompilerPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 95
            Width = 36
            Height = 26
            TabOrder = 4
            Tag = 10
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        CREATE IDE_Conf_FBCommandLineEdit AS QEDIT
            Text = ""
            Left = 12
            Top = 170
            Width = 329
            TabOrder = 6
            ShowHint = True
            Hint = _
                "input files: *.a = static library, *.o = object file, *.bas = source" + CRLF + _
                "  *.rc = resource script, *.res = compiled resource (win32)" + CRLF + _
                "options:" + CRLF + _
                "  @<file>          Read more command line arguments from a file" + CRLF + _
                "  -a <file>        Treat file as .o/.a input file" + CRLF + _
                "  -arch <type>     Set target architecture (default: 486)" + CRLF + _
                "  -asm att;intel   Set asm format (-gen gcc;llvm, x86 or x86_64 only)" + CRLF + _
                "  -b <file>        Treat file as .bas input file" + CRLF + _
                "  -c               Compile only, do not link" + CRLF + _
                "  -C               Preserve temporary .o files" + CRLF + _
                "  -d <name>[=<val>]  Add a global #define" + CRLF + _
                "  -dll             Create a DLL (win32) or shared library (*nix/*BSD)" + CRLF + _
                "  -e               Enable runtime error checking" + CRLF + _
                "  -ex              -e plus RESUME support" + CRLF + _
                "  -exx             -ex plus array bounds/null-pointer checking" + CRLF + _
                "  -export          Export symbols for dynamic linkage" + CRLF + _
                "  -forcelang <name>  Override #lang statements in source code" + CRLF + _
                "  -fpmode fast;precise  Select floating-point math accuracy/speed" + CRLF + _
                "  -fpu x87;sse     Set target FPU" + CRLF + _
                "  -g               Add debug info" + CRLF + _
                "  -gen gas;gcc;llvm  Select code generation backend" + CRLF + _
                "  -i <path>        Add an include file search path" + CRLF + _
                "  -include <file>  Pre-#include a file for each input .bas" + CRLF + _
                "  -l <name>        Link in a library" + CRLF + _
                "  -lang <name>     Select FB dialect: deprecated, fblite, qb" + CRLF + _
                "  -lib             Create a static library" + CRLF + _
                "  -m <name>        Specify main module (default if not -c: first input .bas)" + CRLF + _
                "  -map <file>      Save linking map to file" + CRLF + _
                "  -maxerr <n>      Only show <n> errors" + CRLF + _
                "  -mt              Use thread-safe FB runtime" + CRLF + _
                "  -nodeflibs       Do not include the default libraries" + CRLF + _
                "  -noerrline       Do not show source context in error messages" + CRLF + _
                "  -o <file>        Set .o (or -pp .bas) file name for prev/next input file" + CRLF + _
                "  -O <value>       Optimization level (default: 0)" + CRLF + _
                "  -p <path>        Add a library search path" + CRLF + _
                "  -pic             Generate position-indepedent code (non-x86 Unix shared libs)" + CRLF + _
                "  -pp              Write out preprocessed input file (.pp.bas) only" + CRLF + _
                "  -prefix <path>   Set the compiler prefix path" + CRLF + _
                "  -print host;target  Display host/target system name" + CRLF + _
                "  -print fblibdir  Display the compiler's lib/ path" + CRLF + _
                "  -print x         Display output binary/library file name (if known)" + CRLF + _
                "  -profile         Enable function profiling" + CRLF + _
                "  -r               Write out .asm (-gen gas), .c (-gen gcc) or .ll (-gen llvm) only" + CRLF + _
                "  -rr              Write out the final .asm only" + CRLF + _
                "  -R               Preserve temporary .asm/.c/.ll/.def files" + CRLF + _
                "  -RR              Preserve the final .asm file" + CRLF + _
                "  -s console;gui   Select win32 subsystem" + CRLF + _
                "  -showincludes    Display a tree of file names of #included files" + CRLF + _
                "  -static          Prefer static libraries over dynamic ones when linking" + CRLF + _
                "  -t <value>       Set .exe stack size in kbytes, default: 1024 (win32/dos)" + CRLF + _
                "  -target <name>   Set cross-compilation target" + CRLF + _
                "  -title <name>    Set XBE display title (xbox)" + CRLF + _
                "  -v               Be verbose" + CRLF + _
                "  -vec <n>         Automatic vectorization level (default: 0)" + CRLF + _
                "  [-]-version      Show compiler version" + CRLF + _
                "  -w all;pedantic;<n>  Set min warning level: all, pedantic or a value" + CRLF + _
                "  -Wa <a,b,c>      Pass options to 'as'" + CRLF + _
                "  -Wc <a,b,c>      Pass options to 'gcc' (-gen gcc) or 'llc' (-gen llvm)" + CRLF + _
                "  -Wl <a,b,c>      Pass options to 'ld'" + CRLF + _
                "  -x <file>        Set output executable/library file name" + CRLF + _
                "  -z gosub-setjmp  Use setjmp/longjmp to implement GOSUB"

        END CREATE
        CREATE IDE_Conf_FBHelpFilePathEdit AS QEDIT
            Text = "\Program Files (x86)\FreeBasic\freebasic.chm"
            Left = 12
            Top = 253
            Width = 329
            TabOrder = 5
        END CREATE
        CREATE IDE_Conf_FBHelpPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 251
            Width = 36
            Height = 26
            TabOrder = 6
            Tag = 16
            OnClick = IDE_Conf_FindPathTarget
        END CREATE


        CREATE IDE_Conf_FBRunCmdLabel AS QLABEL
            Caption = "Run time command line parameters"
            Left = 16
            Top = 314
            Width = 280
            Height = 22
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_FBRunCmdEdit AS QEDIT
            Text = ""
            Height = 26
            Left = 12
            Top = 333
            Width = 329
            TabOrder = 7
            Hint = "parameters to pass to your output program at run time"
            ShowHint = True
        END CREATE


        CREATE IDE_Conf_FBPauseAfterRun AS QCHECKBOX
            Checked = False
            Caption = "Pause after execution"
            Left = IDE_Conf_FBRunCmdEdit.Left + IDE_Conf_FBRunCmdEdit.Width + 32
            Top = 333
            Width = 200
            Height = 22
        END CREATE


        CREATE IDE_Conf_FBRunAfterLabel AS QLABEL
            Caption = "Run this file after compile"
            Left = 16
            Top = 394
            Width = 180
            Height = 22
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_FBRunAfterEdit AS QEDIT
            Text = ""
            Height = 26
            Left = 12
            Top = 413
            Width = 329
            TabOrder = 8
            Hint = "free parameters:" + CRLF + CRLF + gSubstitutionsString 
            ShowHint = True
        END CREATE
        CREATE IDE_Conf_FBRunAfterPathSearchButton AS QBUTTON
            Caption = "..."
            Left = 349
            Top = 411
            Width = 36
            Height = 26
            TabOrder = 9
            Tag = 17
            OnClick = IDE_Conf_FindPathTarget
        END CREATE


END CREATE

'____________________Panel with ShorCuts __________________________________________________
    CREATE IDE_Conf_Shortcut_GroupBox AS QGROUPBOX
        Caption = "Short Cut Keys"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48

        CREATE IDE_Conf_Menus_DefaultsButton AS QBUTTON
            Caption = "Default keys"
            Left = 24
            Top = 435
            Width = 120
            Height = 22
            OnClick = IDE_Conf_Menus_DefaultButton_Click
        END CREATE
        CREATE IDE_Conf_Menus_LoadButton AS QBUTTON
            Caption = "Load settings..."
            Left = 240
            Top = 435
            Width = 120
            Height = 22
            OnClick = IDE_Conf_Menus_LoadButton_Click
        END CREATE
        CREATE IDE_Conf_Menus_SaveButton AS QBUTTON
            Caption = "Save settings..."
            Left = 450
            Top = 435
            Width = 120
            Height = 22
            OnClick = IDE_Conf_Menus_SaveButton_Click
        END CREATE
        CREATE IDE_Conf_MenuGrid AS QSTRINGGRID
            Tag = False             'signal loading
            Font.Size = 10
            Left = 11
            Top = 14
            Height = 416
            Width = 600
            FixedCols = 0
            ColCount = 3
            RowCount = 120          'max menu shortcuts in app!
            Col = 0
            Row = 1
            ColWidths(0) = 240
            ColWidths(1) = 240
            ColWidths(2) = 80
            DefaultRowHeight = 20
            Separator = ","
            AddOptions(goEditing, goAlwaysShowEditor, goThumbTracking, goTabs)
            Cell(0,0) = "Menu Caption"
            Cell(1,0) = "ShortCut"
            Cell(2,0) = "Visible"
        END CREATE
    END CREATE      'Shortcut tab



'____________________Panel with External applications ________________________________________________
    CREATE IDE_Conf_ExternAppGroupBox AS QGROUPBOX
        Caption = "External Apps"
        Left = 11
        Top = 32
        Width = IDE_Conf_TabControl.Width - 22
        Height = IDE_Conf_TabControl.Height - 48

        CREATE IDE_Conf_ExternAppLabel1 AS QLABEL
            Caption = "App 1"
            Left = 12
            Top = 25
            Width = 40
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_ExternApp1 AS QEDIT
            Text = ""
            Left = IDE_Conf_ExternAppLabel1.Left + IDE_Conf_ExternAppLabel1.Width + 8
            Top = IDE_Conf_ExternAppLabel1.Top
            Width = 515
        END CREATE
        CREATE IDE_Conf_ExternApp1SearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_ExternApp1.Left + IDE_Conf_ExternApp1.Width + 8
            Top = IDE_Conf_ExternApp1.Top
            Width = 36
            Height = 24
            TabOrder = 4
            Tag = 21
            OnClick = IDE_Conf_FindPathTarget
        END CREATE
        '====================================================

        CREATE IDE_Conf_ExternAppLabel2 AS QLABEL
            Caption = "App 2"
            Left = 12
            Top = 60
            Width = 40
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_ExternApp2 AS QEDIT
            Text = ""
            Left = IDE_Conf_ExternAppLabel2.Left + IDE_Conf_ExternAppLabel2.Width + 8
            Top = IDE_Conf_ExternAppLabel2.Top
            Width = 515
            TabOrder = 1
        END CREATE
        CREATE IDE_Conf_ExternApp2SearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_ExternApp2.Left + IDE_Conf_ExternApp2.Width + 8
            Top = IDE_Conf_ExternApp2.Top
            Width = 36
            Height = 24
            TabOrder = 4
            Tag = 22
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        '====================================================
        CREATE IDE_Conf_ExternAppLabel3 AS QLABEL
            Caption = "App 3"
            Left = 12
            Top = 95
            Width = 40
            Color = 0
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_ExternApp3 AS QEDIT
            Text = ""
            Left = IDE_Conf_ExternAppLabel3.Left + IDE_Conf_ExternAppLabel3.Width + 8
            Top = IDE_Conf_ExternAppLabel3.Top
            Width = 515
            TabOrder = 2
        END CREATE
        CREATE IDE_Conf_ExternApp3SearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_ExternApp3.Left + IDE_Conf_ExternApp3.Width + 8
            Top = IDE_Conf_ExternApp3.Top
            Width = 36
            Height = 24
            TabOrder = 4
            Tag = 23
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        '====================================================
        CREATE IDE_Conf_ExternAppLabel4 AS QLABEL
            Caption = "App  4"
            Left = 12
            Top = 130
            Width = 40
            Color = 0
            Transparent = 1
        END CREATE
        CREATE IDE_Conf_ExternApp4 AS QEDIT
            Text = ""
            Left = IDE_Conf_ExternAppLabel4.Left + IDE_Conf_ExternAppLabel4.Width + 8
            Top = IDE_Conf_ExternAppLabel4.Top
            Width = 515
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_ExternApp4SearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_ExternApp4.Left + IDE_Conf_ExternApp4.Width + 8
            Top = IDE_Conf_ExternApp4.Top
            Width = 36
            Height = 24
            TabOrder = 4
            Tag = 24
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        CREATE IDE_Conf_ExternAppInfoLabel AS QLABEL
            Font.Size = 10
            Caption = "Substitutions:" + CRLF + gSubstitutionsString
            Left = 14
            Top = IDE_Conf_ExternAppLabel4.Top + IDE_Conf_ExternAppLabel4.Height + 16
            Width = 369
            Height = 168
            Transparent = 1
        END CREATE


    '----- Special external apps ------
        CREATE IDE_Conf_upxAppLabel AS QLABEL
            Caption = "UPX de/compressor"
            Font.Size = 11
            Left = 12
            Top = IDE_Conf_ExternAppInfoLabel.Top + IDE_Conf_ExternAppInfoLabel.Height + 18
            Width = 240
            Color = 0
            Transparent = 1
        END CREATE

        CREATE UpxLinkLabel AS QLABEL
            Caption = "http://upx.sourceforge.net"
            Left = IDE_Conf_upxAppLabel.Left + IDE_Conf_upxAppLabel.Width + 12
            Top = IDE_Conf_upxAppLabel.Top 
            Width = 230
            Height = 20
            Cursor = crHandPoint
            OnClick = LaunchMe
            OnMouseMove = HighlightMyLabel
        END CREATE

        CREATE IDE_Conf_upxApp AS QEDIT
            Text = ""
            Left = 12
            Top = IDE_Conf_upxAppLabel.Top + 18
            Width = 550
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_upxAppSearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_upxApp.Left + IDE_Conf_upxApp.Width + 8
            Top = IDE_Conf_upxApp.Top
            Width = 36
            Height = 22
            TabOrder = 7
            Tag = 30
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

        CREATE IDE_Conf_upxDecompressExe AS QCHECKBOX
            Left = IDE_Conf_upxApp.Left
            Top = IDE_Conf_upxApp.Top + IDE_Conf_upxApp.Height + 8
            Width = 240
            Caption = "Decompress output exe"
            Checked = False
        END CREATE

        CREATE IDE_Conf_ResHackerAppLabel AS QLABEL
            Caption = "ResHacker"
            Font.Size = 11
            Left = 12
            Top = IDE_Conf_upxApp.Top + IDE_Conf_upxApp.Height + 38
            Width = 240
            Color = 0
            Transparent = 1
        END CREATE

        CREATE ResHackerLinkLabel AS QLABEL
            Caption = "http://angusj.com/resourcehacker/"
            Left = IDE_Conf_ResHackerAppLabel.Left + IDE_Conf_ResHackerAppLabel.Width + 12
            Top = IDE_Conf_ResHackerAppLabel.Top 
            Width = 230
            Height = 20
            Cursor = crHandPoint
            OnClick = LaunchMe
            OnMouseMove = HighlightMyLabel
        END CREATE

        CREATE IDE_Conf_ResHackerApp AS QEDIT
            Text = ""
            Left = 12
            Top = IDE_Conf_ResHackerAppLabel.Top + 18
            Width = 550
            TabOrder = 3
        END CREATE
        CREATE IDE_Conf_ResHackerAppSearchButton AS QBUTTON
            Caption = "..."
            Left = IDE_Conf_ResHackerApp.Left + IDE_Conf_ResHackerApp.Width + 8
            Top = IDE_Conf_ResHackerApp.Top
            Width = 36
            Height = 22
            TabOrder = 8
            Tag = 31
            OnClick = IDE_Conf_FindPathTarget
        END CREATE

    END CREATE          'External applications tab


END CREATE      'config form

'=====  set to first tab =============
IDE_Conf_TabControl.TabIndex = 0
IDE_Conf_TabChange
'======================================

SUB IDE_Conf_Form_Close
    IDE_Conf_Form.Close
END SUB



SUB IDE_Conf_Form_Show
'    IF IDE.MFEActiveProject <> "" THEN              'allow save to project only
'        IDE_Conf_SaveProjButton.Visible = True 
'    ELSE 
'        IDE_Conf_SaveProjButton.Visible = False     'else allow default config save
'    END IF
    IDE_Conf_Form.ShowModal
END SUB


SUB IDE_Conf_TabChange
  SELECT CASE IDE_Conf_TabControl.TabIndex
    CASE 0
    IDE_Conf_EditorGroupBox.Visible = True
    IDE_Conf_OtherGroupBox.Visible = False
    IDE_Conf_Shortcut_GroupBox.Visible = False
    IDE_Conf_PathsGroupBox.Visible = False
    IDE_Conf_FBPathsGroupBox.Visible = False
    IDE_Conf_ExternAppGroupBox.Visible = False
    CASE 1
    IDE_Conf_EditorGroupBox.Visible = False
    IDE_Conf_OtherGroupBox.Visible = True
    IDE_Conf_Shortcut_GroupBox.Visible = False
    IDE_Conf_PathsGroupBox.Visible = False
    IDE_Conf_FBPathsGroupBox.Visible = False
    IDE_Conf_ExternAppGroupBox.Visible = False
    CASE 2
    IDE_Conf_EditorGroupBox.Visible = False
    IDE_Conf_OtherGroupBox.Visible = False
    IDE_Conf_Shortcut_GroupBox.Visible = True
    IDE_Conf_PathsGroupBox.Visible = False
    IDE_Conf_FBPathsGroupBox.Visible = False
    IDE_Conf_ExternAppGroupBox.Visible = False
    CASE 3
    IDE_Conf_EditorGroupBox.Visible = False
    IDE_Conf_OtherGroupBox.Visible = False
    IDE_Conf_Shortcut_GroupBox.Visible = False
    IDE_Conf_PathsGroupBox.Visible = True
    IDE_Conf_FBPathsGroupBox.Visible = False
    IDE_Conf_ExternAppGroupBox.Visible = False
    CASE 4
    IDE_Conf_EditorGroupBox.Visible = False
    IDE_Conf_OtherGroupBox.Visible = False
    IDE_Conf_Shortcut_GroupBox.Visible = False
    IDE_Conf_PathsGroupBox.Visible = False
    IDE_Conf_FBPathsGroupBox.Visible = True
    IDE_Conf_ExternAppGroupBox.Visible = False
    CASE 5
    IDE_Conf_EditorGroupBox.Visible = False
    IDE_Conf_PathsGroupBox.Visible = False
    IDE_Conf_OtherGroupBox.Visible = False
    IDE_Conf_FBPathsGroupBox.Visible = False
    IDE_Conf_Shortcut_GroupBox.Visible = False
    IDE_Conf_ExternAppGroupBox.Visible = True
    END SELECT
END SUB


SUB IDE_Conf_CompileOpt_Show
    IF IDE.DefaultLexLanguage = 8 THEN          'rapidq ' or     IF IDE.IsJava = False THEN 
        IDE_Conf_TabControl.TabIndex = 3
    ELSE
        IDE_Conf_TabControl.TabIndex = 4
    END IF
    IDE_Conf_TabChange
    IDE_Conf_Form_Show
END SUB

SUB IDE_Cong_ShowExternApp      '=====  set to extern app tab =============
    'IDE_Conf_Form.Show
    IDE_Conf_TabControl.TabIndex = 5
    IDE_Conf_TabChange
    IDE_Conf_Form_Show
END SUB




'------------------------------------------------------
'------------------------------------------------------
'  set the global variables from the form values 
'  then save them to the ini file 
'------------------------------------------------------
'------------------------------------------------------


SUB IDE_Conf_ValuesToGlobals                'allow last minute changes to be updated to globals
    'colors are tricky, they may not be set
    IDE.MainFont.Color    =     IDE_Conf_FontColorLabel.Color
    IDE.BackGround    =         IDE_Conf_FontBackLabel.Color
    IDE.FileTabContolBack    =  IDE_Conf_TabBackLabel.Color
    IDE.FileTabContolInactive = IDE_Conf_TabInactiveLabel.Color
    IDE.SelectionFore    =      IDE_Conf_SelForeLabel.Color
    IDE.SelectionBack    =      IDE_Conf_SelBackLabel.Color
    IDE.LineNumbersFore    =    IDE_Conf_LineNumForeLabel.Color
    IDE.LineNumbersBack    =    IDE_Conf_LineNumBackLabel.Color

    IF IDE_Conf_ActiveLineBackLabel.Color <> -1 THEN
        IDE.ActiveLineBack  =   IDE_Conf_ActiveLineBackLabel.Color
    END IF

    IDE.TabSpaces     =         VAL(IDE_Conf_NumSpacesForTabsEdit.Text)
    IDE.UseTabs    =            IDE_Conf_UseTabsCheckBox.Checked
    IDE.LineNumbers =           IDE_Conf_LineNumCheckBox.Checked
    IDE.AutoIndent    =         IDE_Conf_AutoIndentCheckBox.Checked
    IDE.CodeFolding    =        IDE_Conf_CodeFoldingCheckBox.Checked
    IDE.ViewIndents    =        IDE_Conf_ViewIndentsCheckBox.Checked
    IDE.HiLighting  =           IDE_Conf_HiLiteCheckBox.Checked
    IDE.WordWrap =              IDE_Conf_WordWrapCheckBox.Checked
    
    'IDE.UseAppDirectory =       IDE_Conf_UseAppDirectory.Checked
    IDE.ConstPath =             IDE_Conf_ConstDirectory.Text
    IDE.CompilerPath       =    IDE_Conf_CompilerPathEdit.Text
    IDE.CompilerHelpFile   =    IDE_Conf_HelpFilePathEdit.Text
    IDE.CompilerLibPath    =    IDE_Conf_LibPathEdit.Text
    IDE.CompilerIconPath   =    IDE_Conf_IconPathEdit.Text
    IDE.CompilerIncPath    =    IDE_Conf_IncludePathEdit.Text
    IDE.CompilerTemplatePath =  IDE_Conf_TemplatesPathEdit.Text

    IDE.FBCompilerPath    =     IDE_Conf_FBCompilerPathEdit.Text
    IDE.FBCommandLIne =         IDE_Conf_FBCommandLineEdit.Text
    IDE.FBCompilerHelpFile    = IDE_Conf_FBHelpFilePathEdit.Text
    IDE.FBRunCmd            =   IDE_Conf_FBRunCmdEdit.Text
    IDE.FBPauseAfterRun     =   IDE_Conf_FBPauseAfterRun.Checked
    IDE.FBRunAfterFile      =   IDE_Conf_FBRunAfterEdit.Text
    IDE.IsJava              =   IDE_Conf_IsJavaCheckBox.Checked

    IDE.OptimizeOn    =         IDE_Conf_OptimizeCheckBox.Checked
    IDE.TypeCheckOn    =        IDE_Conf_TypeCheckCheckBox.Checked
    IDE.VerboseOn    =          IDE_Conf_VerboseCheckBox.Checked
    IDE.ByteCodeOn  =           IDE_Conf_ByteCodeCheckBox.Checked
    IDE.GenerateManifest    =    IDE_Conf_GenManifestCheckBox.Checked
    IDE.SaveFileBeforeCompile    =    IDE_Conf_SaveBeforeCompileCheckBox.Checked
    IDE.SaveAllBeforeCompile    =   IDE_Conf_SaveAllBeforeCompileCheckBox.Checked
    IDE.ScriptBeforeCompile    =    IDE_Conf_RunScriptEdit.Text
    IDE.SingleInstanceOnly        =     IDE_Conf_SingleInstance.Checked               
    IDE.ShowSplashScreen        =     IDE_Conf_ShowSplashScreen.Checked             
    IDE.SaveSettingsOnExit        =     IDE_Conf_SaveSettingsOnExit.Checked           
    IDE.ShowSubsAfterLoad        =     IDE_Conf_SwitchToSubView.Checked
    IDE.SortSubs        =     IDE_Conf_SortSubs.Checked
    IDE.HiLightCompileErr        =     IDE_Conf_HiLightCompileErr.Checked            
    IDE.BackupFiles        =     IDE_Conf_BackupFiles.Checked                  
    IDE.BackupFilesExt        =     IDE_Conf_BackupFilesExt.Text
    IDE.HighlightBraces        =     IDE_Conf_HighlightBraces.Checked                 
    IDE.AutoComplete        =  IDE_Conf_AutoComplete.Checked
    IDE.NewTabAtStartup     =  IDE_Conf_NewFileAtStartUp.Checked
    IDE.NewFileName         = IDE_Conf_NewFileNameEdit.Text
    IDE.NewFileAutoSave     = IDE_Conf_NewFileAutoSave.Checked
    IDE.AutoOpenLastProj    = IDE_Conf_AutoOpenLastProj.Checked
    IDE.FindDeclDialogBox   = IDE_Conf_FindDeclDialogBox.Checked
    IDE.ShowWelcome         = IDE_Conf_ShowWelcome.Checked
    IDE.MenuIcons           = IDE_Conf_MenuIcons.Checked

    IDE.AutoDeclClipboardActiveFile        =     IDE_Conf_AutoDeclClipboardActiveFile.Checked  
    IDE.AutoDeclClipboardAllFiles        =     IDE_Conf_AutoDeclClipboardAllFiles.Checked    
    IDE.AutoDeclAtTopActiveFile        =     IDE_Conf_AutoDeclAtTopActiveFile.Checked      
    IDE.AutoDeclAtTopAllFiles        =     IDE_Conf_AutoDeclAtTopAllFiles.Checked        
    IDE.AutoDeclInFile              =     IDE_Conf_AutoDeclInFile.Checked               
    IDE.AutoDeclInFileName        =     IDE_Conf_AutoDeclInFileName.Text              

    IDE.BeautifyCodeTabSpaces   = VAL(BeautifyEditS.Text)
    IDE.BeautifyCodeCommentSpaces   = VAL(BeautifyEditC.Text)

    IDE.SearchEngine           =    IDE_Conf_WebSearchEdit.Text

    IDE.ExternalApp1           = IDE_Conf_ExternApp1.Text
    IDE.ExternalApp2           = IDE_Conf_ExternApp2.Text
    IDE.ExternalApp3           = IDE_Conf_ExternApp3.Text
    IDE.ExternalApp4           = IDE_Conf_ExternApp4.Text

    IDE.upx                     = IDE_Conf_upxApp.Text
    IDE.ResHacker               = IDE_Conf_ResHackerApp.Text
    IDE.DecompressEXE           = IDE_Conf_upxDecompressExe.Checked

    IDE.EmbedManifest	=	    IDE_Conf_ManifestEmbedCheckBox.Checked 
    IDE.EmbedVersionInfo	=   IDE_Conf_VersionInfoCheckBox.Checked 
    IDE.FileVersion 	=	    IDE_Conf_VersionInfoGrid.Cell(1,1)  
    IDE.ProductVersion 	=	    IDE_Conf_VersionInfoGrid.Cell(1,2) 
    IDE.CompanyName 	=	    IDE_Conf_VersionInfoGrid.Cell(1,6) 
    IDE.CompanyEmail 	=	    IDE_Conf_VersionInfoGrid.Cell(1,7) 
    IDE.FileDescription 	=	IDE_Conf_VersionInfoGrid.Cell(1,8) 
    IDE.LegalCopyright 	=	    IDE_Conf_VersionInfoGrid.Cell(1,10) 
END SUB



SUB IDE_Conf_Form_SaveVars
    IDE_Conf_ValuesToGlobals            'the configuration form widgets are stored to global IDE variables from manual entry
    WriteIDEVariables(True)             'store IDE variables to INI file
    IDE_Conf_VersionInfoForm_Close      'this sets the versionInfo!! need this here because of WriteIDEVariables...
    IDE_Conf_Form.Close
    SetIDEVariables                     'activate actual IDE settings
END SUB



'------------------------------------------------------
'------------------------------------------------------
'populate the form values with the global variables
'------------------------------------------------------
'------------------------------------------------------

SUB IDE_Conf_Form_Refresh                   'set the forms with IDE variable
'     IDE_Conf_FontColorLabel.Color         = IDE.MainFont.Color            'these can change depending on listbox
'     IDE_Conf_FontBackLabel.Color          = IDE.BackGround

    IDE_Conf_TabBackLabel.Color           = IDE.FileTabContolBack
    IDE_Conf_TabInactiveLabel.Color       = IDE.FileTabContolInactive
    IDE_Conf_SelForeLabel.Color           = IDE.SelectionFore
    IDE_Conf_SelBackLabel.Color           = IDE.SelectionBack
    IDE_Conf_LineNumForeLabel.Color       = IDE.LineNumbersFore
    IDE_Conf_LineNumBackLabel.Color       = IDE.LineNumbersBack
    IDE_Conf_ActiveLineBackLabel.Color    = IDE.ActiveLineBack

    IF IDE_Conf_ActiveLineBackLabel.Color = -1 THEN
        IDE_Conf_ActiveLineBackLabel.Visible = False
        IDE_Conf_ActiveLineBackButton.Checked = False
    ELSE
        IDE_Conf_ActiveLineBackLabel.Visible = True
        IDE_Conf_ActiveLineBackButton.Checked = True
    END IF

    IDE_Conf_NumSpacesForTabsEdit.Text    = STR$(IDE.TabSpaces)
    IDE_Conf_UseTabsCheckBox.Checked      = IDE.UseTabs
    IDE_Conf_LineNumCheckBox.Checked      = IDE.LineNumbers
    IDE_Conf_AutoIndentCheckBox.Checked   = IDE.AutoIndent
    IDE_Conf_CodeFoldingCheckBox.Checked  = IDE.CodeFolding
    IDE_Conf_ViewIndentsCheckBox.Checked  = IDE.ViewIndents
    IDE_Conf_HiLiteCheckBox.Checked       = IDE.HiLighting
    IDE_Conf_WordWrapCheckBox.Checked     = IDE.WordWrap

    IF RIGHT$(IDE.CompilerLibPath, 1) = "\" THEN 
        IDE.CompilerLibPath = LEFT$(IDE.CompilerLibPath, LEN(IDE.CompilerLibPath)-1)
    END IF
    IF RIGHT$(IDE.CompilerIconPath, 1) = "\" THEN 
        IDE.CompilerIconPath = LEFT$(IDE.CompilerIconPath, LEN(IDE.CompilerIconPath)-1)
    END IF
    IF RIGHT$(IDE.CompilerIncPath, 1) = "\" THEN 
        IDE.CompilerIncPath = LEFT$(IDE.CompilerIncPath, LEN(IDE.CompilerIncPath)-1)
    END IF

    IDE_Conf_CompilerPathEdit.Text = IDE.CompilerPath
    IDE_Conf_HelpFilePathEdit.Text = IDE.CompilerHelpFile
    IDE_Conf_LibPathEdit.Text = IDE.CompilerLibPath
    IDE_Conf_IconPathEdit.Text = IDE.CompilerIconPath
    IDE_Conf_IncludePathEdit.Text = IDE.CompilerIncPath
    IDE_Conf_TemplatesPathEdit.Text = IDE.CompilerTemplatePath

    IDE_Conf_FBCompilerPathEdit.Text = IDE.FBCompilerPath
    IF IDE.FBCommandLine <> "" THEN IDE_Conf_FBCommandLineEdit.Text = IDE.FBCommandLine
    IDE_Conf_FBHelpFilePathEdit.Text = IDE.FBCompilerHelpFile
    IDE_Conf_FBRunCmdEdit.Text = IDE.FBRunCmd
    IDE_Conf_FBPauseAfterRun.Checked = IDE.FBPauseAfterRun  
    IDE_Conf_FBRunAfterEdit.Text = IDE.FBRunAfterFile   
    IDE_Conf_IsJavaCheckBox.Checked = IDE.IsJava

    IDE_Conf_ManifestEmbedCheckBox.Checked = IDE.EmbedManifest
    IDE_Conf_VersionInfoCheckBox.Checked = IDE.EmbedVersionInfo
    IDE_Conf_VersionInfoGrid.Cell(1,1)  = REPLACESUBSTR$(IDE.FileVersion, ".", ",")
    IDE_Conf_VersionInfoGrid.Cell(1,2) = IDE.ProductVersion 
    IDE_Conf_VersionInfoGrid.Cell(1,6) = IDE.CompanyName 
    IDE_Conf_VersionInfoGrid.Cell(1,7) = IDE.CompanyEmail 
    IDE_Conf_VersionInfoGrid.Cell(1,8) = IDE.FileDescription 
    IDE_Conf_VersionInfoGrid.Cell(1,9) = REPLACESUBSTR$(IDE.FileVersion, ",", ".")
    IDE_Conf_VersionInfoGrid.Cell(1,10) = IDE.LegalCopyright 

    IDE_Conf_OptimizeCheckBox.Checked = IDE.OptimizeOn
    IDE_Conf_TypeCheckCheckBox.Checked = IDE.TypeCheckOn
    IDE_Conf_VerboseCheckBox.Checked = IDE.VerboseOn
    IDE_Conf_ByteCodeCheckBox.Checked = IDE.ByteCodeOn
    IDE_Conf_GenManifestCheckBox.Checked = IDE.GenerateManifest
    IDE_Conf_SaveBeforeCompileCheckBox.Checked = IDE.SaveFileBeforeCompile
    IDE_Conf_SaveAllBeforeCompileCheckBox.Checked = IDE.SaveAllBeforeCompile

    'IDE_Conf_UseAppDirectory.Checked = IDE.UseAppDirectory
    IF IDE_Conf_UseAppDirectory.Checked = False THEN 
        IDE_Conf_ConstDirectory.Text = IDE.ConstPath
    ELSE
        IDE_Conf_ConstDirectory.Enabled = False
    END IF

    IDE_Conf_RunScriptEdit.Text = IDE.ScriptBeforeCompile
    IDE_Conf_FileExtensionsListBox.Text = IDE.FileFilter
    IDE_Conf_WebSearchEdit.Text = IDE.SearchEngine

    '--------------------Other options --------------------
    IDE_Conf_SingleInstance.Checked               = IDE.SingleInstanceOnly
    IDE_Conf_ShowSplashScreen.Checked             = IDE.ShowSplashScreen
    IDE_Conf_SaveSettingsOnExit.Checked           = IDE.SaveSettingsOnExit
    IDE_Conf_SwitchToSubView.Checked              = IDE.ShowSubsAfterLoad
    IDE_Conf_SortSubs.Checked                     = IDE.SortSubs
    IDE_Conf_HiLightCompileErr.Checked            = IDE.HiLightCompileErr
    IDE_Conf_BackupFiles.Checked                  = IDE.BackupFiles
    IDE_Conf_BackupFilesExt.Text                  = IDE.BackupFilesExt
    IDE_Conf_HighlightBraces.Checked              = IDE.HighlightBraces    
    IDE_Conf_AutoComplete.Checked                 = IDE.AutoComplete
    IDE_Conf_NewFileAtStartUp.Checked             = IDE.NewTabAtStartup
    IDE_Conf_NewFileNameEdit.Text                 = IDE.NewFileName 
    IDE_Conf_NewFileAutoSave.Checked              = IDE.NewFileAutoSave
    IDE_Conf_AutoOpenLastProj.Checked             = IDE.AutoOpenLastProj
    IDE_Conf_FindDeclDialogBox.Checked            = IDE.FindDeclDialogBox
    IDE_Conf_ShowWelcome.Checked                  = IDE.ShowWelcome
    IDE_Conf_MenuIcons.Checked                    = IDE.MenuIcons
    
    IDE_Conf_AutoDeclClipboardActiveFile.Checked  = IDE.AutoDeclClipboardActiveFile
    IDE_Conf_AutoDeclClipboardAllFiles.Checked    = IDE.AutoDeclClipboardAllFiles
    IDE_Conf_AutoDeclAtTopActiveFile.Checked      = IDE.AutoDeclAtTopActiveFile
    IDE_Conf_AutoDeclAtTopAllFiles.Checked        = IDE.AutoDeclAtTopAllFiles
    IDE_Conf_AutoDeclInFile.Checked               = IDE.AutoDeclInFile
    IDE_Conf_AutoDeclInFileName.Text              = IDE.AutoDeclInFileName

    BeautifyEditS.Text = STR$(IDE.BeautifyCodeTabSpaces)
    BeautifyEditC.Text = STR$(IDE.BeautifyCodeCommentSpaces)


    '--------------------External applications --------------------
    IDE_Conf_ExternApp1.Text = IDE.ExternalApp1
    IDE_Conf_ExternApp2.Text = IDE.ExternalApp2
    IDE_Conf_ExternApp3.Text = IDE.ExternalApp3
    IDE_Conf_ExternApp4.Text = IDE.ExternalApp4

    IDE_Conf_upxApp.Text = IDE.upx
    IDE_Conf_ResHackerApp.Text = IDE.ResHacker
    IDE_Conf_upxDecompressExe.Checked = IDE.DecompressEXE

    IDE_Conf_RichEdit_Repaint
    IDE.CompiledOK = False                                  'reset to recompile
END SUB





SUB IDE_Conf_RichEdit_Repaint
    SELECT CASE IDE_Conf_TextRichEdit.ItemIndex 'WhereY
    CASE 0      'default
    IDE_Conf_FontColorLabel.Color         = IDE.MainFont.Color
    IDE_Conf_FontBackLabel.Color          = IDE.BackGround
    IDE_Conf_BoldCheckBox.Checked         = IDE.MainFont.Bold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.MainFont.Italic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.MainFont.UnderLine
    IDE_Conf_ListBox.Clear
    CASE 1      'comment
    IDE_Conf_FontColorLabel.Color         = IDE.CommentFore
    IDE_Conf_FontBackLabel.Color          = IDE.CommentBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.CommentBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.CommentItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.CommentUnderL
    IDE_Conf_ListBox.Clear
    CASE 2      'number
    IDE_Conf_FontColorLabel.Color         = IDE.NumberFore
    IDE_Conf_FontBackLabel.Color          = IDE.NumberBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.NumberBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.NumberItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.CommentUnderL
    IDE_Conf_ListBox.Clear
    CASE 3      'strings
    IDE_Conf_FontColorLabel.Color         = IDE.StringFore
    IDE_Conf_FontBackLabel.Color          = IDE.StringBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.StringBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.StringItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.StringUnderL
    IDE_Conf_ListBox.Clear
    CASE 4      'preprocessor
    IDE_Conf_FontColorLabel.Color         = IDE.PreProcessorFore
    IDE_Conf_FontBackLabel.Color          = IDE.PreProcessorBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.PreProcessorBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.PreProcessorItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.PreProcessorUnderL
    IDE_Conf_ListBox.Clear
    CASE 5      'operator
    IDE_Conf_FontColorLabel.Color         = IDE.OperatorFore
    IDE_Conf_FontBackLabel.Color          = IDE.OperatorBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.OperatorBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.OperatorItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.OperatorUnderL
    IDE_Conf_ListBox.Clear
    CASE 6      'Keywords
    IDE_Conf_LoadKeywordsButton.Enabled = True
    IDE_Conf_FontColorLabel.Color         = IDE.KeywordFore
    IDE_Conf_FontBackLabel.Color          = IDE.KeywordBack
    IDE_Conf_BoldCheckBox.Checked         = IDE.KeywordBold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.KeywordItalic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.KeywordUnderL
    IF IDE.KeyWordList.ItemCount > 0 THEN IDE_Conf_ListBox.Text = IDE.KeywordList.Text ELSE IDE_Conf_ListBox.Clear
    CASE 7      'Keywords2
    IDE_Conf_LoadKeywordsButton.Enabled = True
    IDE_Conf_FontColorLabel.Color         = IDE.Keyword2Fore
    IDE_Conf_FontBackLabel.Color          = IDE.Keyword2Back
    IDE_Conf_BoldCheckBox.Checked         = IDE.Keyword2Bold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.Keyword2Italic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.Keyword2UnderL
    IF IDE.KeyWordList2.ItemCount > 0 THEN IDE_Conf_ListBox.Text = IDE.KeyWordList2.Text ELSE IDE_Conf_ListBox.Clear
    CASE 8      'Keywords3
    IDE_Conf_LoadKeywordsButton.Enabled = True
    IDE_Conf_FontColorLabel.Color         = IDE.Keyword3Fore
    IDE_Conf_FontBackLabel.Color          = IDE.Keyword3Back
    IDE_Conf_BoldCheckBox.Checked         = IDE.Keyword3Bold
    IDE_Conf_ItalicCheckBox.Checked       = IDE.Keyword3Italic
    IDE_Conf_UnderLineCheckBox.Checked    = IDE.Keyword3UnderL
    IF IDE.KeyWordList3.ItemCount > 0 THEN IDE_Conf_ListBox.Text = IDE.KeyWordList3.Text ELSE IDE_Conf_ListBox.Clear
    END SELECT
END SUB




SUB IDE_Conf_RichEdit_Store

    SELECT CASE IDE_Conf_TextRichEdit.ItemIndex 'WhereY
    CASE 0 'default
    IDE.MainFont.Color    =    IDE_Conf_FontColorLabel.Color
    IDE.BackGround    =    IDE_Conf_FontBackLabel.Color
    IDE.MainFont.Bold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.MainFont.Italic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.MainFont.UnderLine    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 1 'comment
    IDE.CommentFore    =    IDE_Conf_FontColorLabel.Color
    IDE.CommentBack    =    IDE_Conf_FontBackLabel.Color
    IDE.CommentBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.CommentItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.CommentUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 2 'number
    IDE.NumberFore    =    IDE_Conf_FontColorLabel.Color
    IDE.NumberBack    =    IDE_Conf_FontBackLabel.Color
    IDE.NumberBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.NumberItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.CommentUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 3 'strings
    IDE.StringFore    =    IDE_Conf_FontColorLabel.Color
    IDE.StringBack    =    IDE_Conf_FontBackLabel.Color
    IDE.StringBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.StringItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.StringUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 4 'preprocessor
    IDE.PreProcessorFore    =    IDE_Conf_FontColorLabel.Color
    IDE.PreProcessorBack    =    IDE_Conf_FontBackLabel.Color
    IDE.PreProcessorBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.PreProcessorItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.PreProcessorUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 5 'operator
    IDE.OperatorFore    =    IDE_Conf_FontColorLabel.Color
    IDE.OperatorBack    =    IDE_Conf_FontBackLabel.Color
    IDE.OperatorBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.OperatorItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.OperatorUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 6 'Keywords
    IDE.KeywordFore    =    IDE_Conf_FontColorLabel.Color
    IDE.KeywordBack    =    IDE_Conf_FontBackLabel.Color
    IDE.KeywordBold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.KeywordItalic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.KeywordUnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 7 'Keywords2
    IDE.Keyword2Fore    =    IDE_Conf_FontColorLabel.Color
    IDE.Keyword2Back    =    IDE_Conf_FontBackLabel.Color
    IDE.Keyword2Bold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.Keyword2Italic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.Keyword2UnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    CASE 8 'Keywords3
    IDE.Keyword3Fore    =    IDE_Conf_FontColorLabel.Color
    IDE.Keyword3Back    =    IDE_Conf_FontBackLabel.Color
    IDE.Keyword3Bold    =    IDE_Conf_BoldCheckBox.Checked
    IDE.Keyword3Italic    =    IDE_Conf_ItalicCheckBox.Checked
    IDE.Keyword3UnderL    =    IDE_Conf_UnderLineCheckBox.Checked
    END SELECT

END SUB


SUB IDE_Conf_SelectColor(Sender AS QButton)
    IDE_ColorSelector.Style = cdFullOpen
    IDE_ColorSelector.Top = Screen.MouseY
    IDE_ColorSelector.Left = Screen.MouseX
    IF IDE_ColorSelector.Execute THEN
        SELECT CASE Sender.Handle

            CASE IDE_Conf_FontColorButton.handle
                IDE_Conf_FontColorLabel.Color = IDE_ColorSelector.Color
                MainListBox1.Color = IDE_ColorSelector.Color
                MainListBoxResources.Color = IDE_ColorSelector.Color
                MainListBoxIncludes.Color = IDE_ColorSelector.Color
                MainListBox1.Font.Color = IDE_ColorSelector.Color
                MainListBoxResources.Font.Color = IDE_ColorSelector.Color
                MainListBoxIncludes.Font.Color = IDE_ColorSelector.Color
                ProjFileList.Font.Color = IDE_ColorSelector.Color
                DirTree.Font.Color = IDE_ColorSelector.Color
                FindTreeView.Font.Color = IDE_ColorSelector.Color
                RichEditCompile.Font.Color = IDE_ColorSelector.Color
                FOR zzz = 0 TO IDE_MAX_FILES
                    SubFuncListView(zzz).Font.Color = IDE_ColorSelector.Color
                NEXT zzz

                IDE_Conf_RichEdit_Store
                IDE_Conf_RichEdit_Repaint

            CASE IDE_Conf_FontBackButton.handle
                IDE_Conf_FontBackLabel.Color = IDE_ColorSelector.Color
                IDE.BackGround = IDE_ColorSelector.Color
                IDE.CommentBack = IDE_ColorSelector.Color
                IDE.NumberBack = IDE_ColorSelector.Color
                IDE.StringBack = IDE_ColorSelector.Color
                IDE.PreProcessorBack = IDE_ColorSelector.Color
                IDE.OperatorBack = IDE_ColorSelector.Color
                IDE.KeywordBack = IDE_ColorSelector.Color
                IDE.Keyword2Back = IDE_ColorSelector.Color
                IDE.Keyword3Back = IDE_ColorSelector.Color
                IDE_Conf_RichEdit_Store
                IDE_Conf_RichEdit_Repaint
                ProjFileList.Color = IDE_ColorSelector.Color
                RichEditCompile.Color = IDE_ColorSelector.Color
                DirTree.Color = IDE_ColorSelector.Color
                FindTreeView.Color = IDE_ColorSelector.Color
                FOR zzz = 0 TO IDE_MAX_FILES
                    SubFuncListView(zzz).Color = IDE_ColorSelector.Color
                NEXT zzz

            CASE IDE_Conf_TabBackButton.handle
                IDE.FileTabContolBack = IDE_ColorSelector.Color
                IDE_Conf_TabBackLabel.Color = IDE_ColorSelector.Color
                LeftPanel.Color = IDE_ColorSelector.Color
                LeftPanelBottomPanel.Color = IDE_ColorSelector.Color
                RightPanel.Color = IDE_ColorSelector.Color
                LeftPanelTopPanel.Color = IDE_ColorSelector.Color
                RightPanelTopPanel.Color = IDE_ColorSelector.Color
                PanelSearch.Color = IDE_ColorSelector.Color
                CenterPanel.Color = IDE_ColorSelector.Color
                BottomPanel.Color = IDE_ColorSelector.Color
                ProjPanel.Color = IDE_ColorSelector.Color
                IncResPanel.Color = IDE_ColorSelector.Color
                FindAllPanel.Color = IDE_ColorSelector.Color
                SubFuncsPanel.Color = IDE_ColorSelector.Color
                TopPanel.Color = IDE_ColorSelector.Color
                FileToolPanel.Color = IDE_ColorSelector.Color
                EditToolPanel.Color = IDE_ColorSelector.Color
                CompileToolPanel.Color = IDE_ColorSelector.Color
                ViewToolPanel.Color = IDE_ColorSelector.Color
                CodeFoldingToolPanel.Color = IDE_ColorSelector.Color
                FormatToolPanel.Color = IDE_ColorSelector.Color
                BookMarkToolPanel.Color = IDE_ColorSelector.Color
                WidgetPanel.Color = IDE_ColorSelector.Color

                'now tabcontrols
                IDE_Conf_TabControl.Color = IDE_ColorSelector.Color
                MFE_Tab.Color = IDE_ColorSelector.Color
                TabControl3.Color = IDE_ColorSelector.Color
                WidgetTab.Color = IDE_ColorSelector.Color


            CASE IDE_Conf_TabForeButton.handle    :   IDE.FileTabContolInactive = IDE_ColorSelector.Color  :  IDE_Conf_TabInactiveLabel.Color = IDE_ColorSelector.Color
            CASE IDE_Conf_SelForeButton.handle    :   IDE.SelectionFore = IDE_ColorSelector.Color  :  IDE_Conf_SelForeLabel.Color = IDE_ColorSelector.Color
            CASE IDE_Conf_SelBackButton.handle    :   IDE.SelectionBack = IDE_ColorSelector.Color  :  IDE_Conf_SelBackLabel.Color = IDE_ColorSelector.Color
            CASE IDE_Conf_LineNumForeButton.handle:   IDE.LineNumbersFore = IDE_ColorSelector.Color  :  IDE_Conf_LineNumForeLabel.Color = IDE_ColorSelector.Color
            CASE IDE_Conf_LineNumBackButton.handle:   IDE.LineNumbersBack = IDE_ColorSelector.Color  :  IDE_Conf_LineNumBackLabel.Color = IDE_ColorSelector.Color
        END SELECT
    END IF
END SUB



SUB IDE_Conf_ActiveLineSelectColor
    IDE_ColorSelector.Style = cdFullOpen
    IDE_ColorSelector.Top = Screen.MouseY
    IDE_ColorSelector.Left = Screen.MouseX
    IF IDE_ColorSelector.Execute THEN
        IDE.ActiveLineBack = IDE_ColorSelector.Color
        IDE_Conf_ActiveLineBackLabel.Color = IDE_ColorSelector.Color
    END IF
END SUB


SUB WriteIDE_FormVariables
    ini.Section = "IDE_Variables"
    ini.write("MainFormLeft", STR$(MainForm.Left)) 'IDE.MainFormLeft))      '
    ini.write("MainFormTop", STR$(MainForm.Top))  'IDE.MainFormTop))         '
    ini.write("MainFormWidth", STR$(MainForm.Width))   'IDE.MainFormWidth))      ' '
    ini.write("MainFormHeight", STR$(MainForm.Height))  'IDE.MainFormHeight))    ' '
    ini.write("RightSplitterPos",  STR$(RightSplitter.Left))  'IDE.RightSplitterPos))   ' '
    ini.write("LeftSplitterPos",  STR$(LeftSplitter.Left))   'IDE.LeftSplitterPos))  ''
    ini.write("FindReplaceFormLeft", STR$(FindReplaceForm.Left))
    ini.write("FindReplaceFormTop", STR$( FindReplaceForm.Top))
    ini.write("SetFindTransparency", STR$( FindTransparencyOnLostFocusBox.Checked))
    ini.write("FindTransparencyValue", STR$( FindReplaceTrackBar.Position))

    IF ComboBoxFind.ItemCount > 0 THEN IF TRIM$(ComboBoxFind.Item(0)) <> "" THEN ini.write("FindReplaceItem0", ComboBoxFind.Item(0))
    IF ComboBoxFind.ItemCount > 1 THEN IF TRIM$(ComboBoxFind.Item(1)) <> "" THEN ini.write("FindReplaceItem1", ComboBoxFind.Item(1))
    IF ComboBoxFind.ItemCount > 2 THEN IF TRIM$(ComboBoxFind.Item(2)) <> "" THEN ini.write("FindReplaceItem2", ComboBoxFind.Item(2))
    IF ComboBoxFind.ItemCount > 3 THEN IF TRIM$(ComboBoxFind.Item(3)) <> "" THEN ini.write("FindReplaceItem3", ComboBoxFind.Item(3))
    IF ComboBoxFind.ItemCount > 4 THEN IF TRIM$(ComboBoxFind.Item(4)) <> "" THEN ini.write("FindReplaceItem4", ComboBoxFind.Item(4))
    IF ComboBoxFind.ItemCount > 5 THEN IF TRIM$(ComboBoxFind.Item(5)) <> "" THEN ini.write("FindReplaceItem5", ComboBoxFind.Item(5))
    IF ComboBoxFind.ItemCount > 6 THEN IF TRIM$(ComboBoxFind.Item(6)) <> "" THEN ini.write("FindReplaceItem6", ComboBoxFind.Item(6))
    IF ComboBoxFind.ItemCount > 7 THEN IF TRIM$(ComboBoxFind.Item(7)) <> "" THEN ini.write("FindReplaceItem7", ComboBoxFind.Item(7))
    IF ComboBoxFind.ItemCount > 8 THEN IF TRIM$(ComboBoxFind.Item(8)) <> "" THEN ini.write("FindReplaceItem8", ComboBoxFind.Item(8))
    IF ComboBoxFind.ItemCount > 9 THEN IF TRIM$(ComboBoxFind.Item(9)) <> "" THEN ini.write("FindReplaceItem9", ComboBoxFind.Item(9))


END SUB



SUB WriteIDEVariables (ResetIt AS INTEGER)

    ini.Section = "IDE_Variables"

    ini.write("ShowSplashScreen", STR$(  IDE.ShowSplashScreen))
    ini.write("ViewQuickSearch",  STR$( IDE.ViewQuickSearch))
    ini.write("ViewStatusBar",  STR$( IDE.ViewStatusBar))
    ini.write("ViewLeftPanel",  STR$( IDE.ViewLeftPanel))
    ini.write("ViewRightPanel",  STR$( IDE.ViewRightPanel))
    ini.write("ViewBottomPanel",  STR$( IDE.ViewBottomPanel))
    ini.write("ViewTopPanel",  STR$( IDE.ViewTopPanel))
    ini.write("ViewFileToolPanel",  STR$( IDE.ViewFileToolPanel))
    ini.write("ViewEditToolPanel",  STR$( IDE.ViewEditToolPanel))
    ini.write("ViewCompileToolPanel",  STR$( IDE.ViewCompileToolPanel))
    ini.write("ViewViewToolPanel",  STR$( IDE.ViewViewToolPanel))
    ini.write("ViewCodeFoldingToolPanel",  STR$( IDE.ViewCodeFoldingToolPanel))
    ini.write("ViewFormatToolPanel",  STR$( IDE.ViewFormatToolPanel))
    ini.write("ViewBookMarkToolPanel",  STR$( IDE.ViewBookMarkToolPanel))
    ini.write("ViewIconToolPanel",  STR$( IDE.ViewIconToolPanel))
    ini.write("ViewWidgetToolPanel",  STR$( IDE.ViewWidgetToolPanel))

    ini.write("MainFont.Name", IDE.MainFont.Name)
    ini.write("MainFont.Size", STR$( IDE.MainFont.Size))
    ini.write("MainFont.Color", HEX$( IDE.MainFont.Color AND &HFFFFFF))
    ini.write("MainFont.Bold", STR$( IDE.MainFont.Bold))
    ini.write("MainFont.Italic", STR$( IDE.MainFont.Italic))
    ini.write("MainFont.Underline", STR$( IDE.MainFont.Underline))
    ini.write("BackGround", HEX$( IDE.BackGround AND &HFFFFFF))
    ini.write("SelectionFore", HEX$( IDE.SelectionFore AND &HFFFFFF))
    ini.write("SelectionBack", HEX$( IDE.SelectionBack AND &HFFFFFF))
    ini.write("LineNumbersFore", HEX$( IDE.LineNumbersFore AND &HFFFFFF))
    ini.write("LineNumbersBack", HEX$( IDE.LineNumbersBack AND &HFFFFFF))
    ini.write("CommentFore", HEX$( IDE.CommentFore AND &HFFFFFF))
    ini.write("CommentBack", HEX$( IDE.CommentBack AND &HFFFFFF))
    ini.write("CommentBold", STR$( IDE.CommentBold))
    ini.write("CommentItalic", STR$( IDE.CommentItalic))
    ini.write("CommentUnderL", STR$( IDE.CommentUnderL))
    ini.write("NumberFore", HEX$( IDE.NumberFore AND &HFFFFFF))
    ini.write("NumberBack", HEX$( IDE.NumberBack AND &HFFFFFF))
    ini.write("NumberBold", STR$( IDE.NumberBold))
    ini.write("NumberItalic", STR$( IDE.NumberItalic))
    ini.write("NumberUnderL", STR$( IDE.NumberUnderL))
    ini.write("StringFore", HEX$( IDE.StringFore AND &HFFFFFF))
    ini.write("StringBack", HEX$( IDE.StringBack AND &HFFFFFF))
    ini.write("StringBold", STR$( IDE.StringBold))
    ini.write("StringItalic", STR$( IDE.StringItalic))
    ini.write("StringUnderL", STR$( IDE.StringUnderL))
    ini.write("PreProcessorFore", HEX$( IDE.PreProcessorFore AND &HFFFFFF))
    ini.write("PreProcessorBack", HEX$( IDE.PreProcessorBack AND &HFFFFFF))
    ini.write("PreProcessorBold", STR$( IDE.PreProcessorBold))
    ini.write("PreProcessorItalic", STR$( IDE.PreProcessorItalic))
    ini.write("PreProcessorUnderL", STR$( IDE.PreProcessorUnderL))
    ini.write("OperatorFore", HEX$( IDE.OperatorFore AND &HFFFFFF))
    ini.write("OperatorBack", HEX$( IDE.OperatorBack AND &HFFFFFF))
    ini.write("OperatorBold", STR$( IDE.OperatorBold))
    ini.write("OperatorItalic", STR$( IDE.OperatorItalic))
    ini.write("OperatorUnderL", STR$( IDE.OperatorUnderL))
    ini.write("KeywordFore", HEX$( IDE.KeywordFore AND &HFFFFFF))
    ini.write("KeywordBack", HEX$( IDE.KeywordBack AND &HFFFFFF))
    ini.write("KeywordBold", STR$( IDE.KeywordBold))
    ini.write("KeywordItalic", STR$( IDE.KeywordItalic))
    ini.write("KeywordUnderL", STR$( IDE.KeywordUnderL))
    ini.write("Keyword2Fore", HEX$( IDE.Keyword2Fore AND &HFFFFFF))
    ini.write("Keyword2Back", HEX$( IDE.Keyword2Back AND &HFFFFFF))
    ini.write("Keyword2Bold", STR$( IDE.Keyword2Bold))
    ini.write("Keyword2Italic", STR$( IDE.Keyword2Italic))
    ini.write("Keyword2UnderL", STR$( IDE.Keyword2UnderL))
    ini.write("Keyword3Fore", HEX$( IDE.Keyword3Fore AND &HFFFFFF))
    ini.write("Keyword3Back", HEX$( IDE.Keyword3Back AND &HFFFFFF))
    ini.write("Keyword3Bold", STR$( IDE.Keyword3Bold))
    ini.write("Keyword3Italic", STR$( IDE.Keyword3Italic))
    ini.write("Keyword3UnderL", STR$( IDE.Keyword3UnderL))
    ini.write("FileTabContolBack", HEX$( IDE.FileTabContolBack AND &HFFFFFF))
    ini.write("FileTabContolInactive", HEX$( IDE.FileTabContolInactive AND &HFFFFFF))
    ini.write("HiLighting", STR$( IDE.HiLighting))
    ini.write("DefaultLexLanguage", STR$( IDE.DefaultLexLanguage))
    ini.write("LineNumbers", STR$( IDE.LineNumbers))
    ini.write("ActiveLineBack", STR$( IDE.ActiveLineBack))
    ini.write("UseTabs", STR$( IDE.UseTabs))
    ini.write("TabSpaces", STR$( IDE.TabSpaces))
    ini.write("CodePage", STR$( IDE.CodePage))
    ini.write("AutoIndent", STR$( IDE.AutoIndent))
    ini.write("CodeFolding", STR$( IDE.CodeFolding))
    ini.write("CodeFoldCollapseAll", STR$( IDE.CodeFoldCollapseAll))
    ini.write("CodeFoldExpandAll", STR$( IDE.CodeFoldExpandAll))
    ini.write("ViewIndents", STR$( IDE.ViewIndents))
    ini.write("FontZoom", STR$( IDE.FontZoom))
    ini.write("WordWrap", STR$(IDE.WordWrap))
    ini.write("UseAppDirectory", STR$(IDE_Conf_UseAppDirectory.Checked)) 'IDE.UseAppDirectory))
    ini.write("ConstPath",   IDE.ConstPath)

    ini.write("FileFilter",   IDE.FileFilter)
    ini.write("CompilerPath",   IDE.CompilerPath)
    ini.write("LastDir",   IDE.LastDir)
    ini.write("CompilerLibPath",   IDE.CompilerLibPath)
    ini.write("CompilerIncPath",   IDE.CompilerIncPath)
    ini.write("CompilerIconPath",   IDE.CompilerIconPath)
    ini.write("CompilerHelpFile",   IDE.CompilerHelpFile)
    ini.write("CompilerTemplatePath",   IDE.CompilerTemplatePath)

    ini.write("FBCompilerPath",   IDE.FBCompilerPath)
    ini.write("FBCommandLIne",   IDE.FBCommandLIne)
    ini.write("FBCompilerHelpFile",   IDE.FBCompilerHelpFile)
    ini.write("FBRunCmd",   IDE.FBRunCmd)
    ini.write("FBPauseAfterRun",   STR$(IDE.FBPauseAfterRun))
    ini.write("FBRunAfterFile",   IDE.FBRunAfterFile)
    ini.write("IsJava",   STR$(IDE.IsJava))
    ini.write("IconName",   IDE.IconName)
    ini.write("OptimizeOn", STR$( IDE.OptimizeOn))
    ini.write("TypeCheckOn", STR$( IDE.TypeCheckOn))
    ini.write("VerboseOn", STR$( IDE.VerboseOn))
    ini.write("ByteCodeOn", STR$( IDE.ByteCodeOn))
    ini.write("GenerateManifest", STR$( IDE.GenerateManifest))

    ini.write("SaveFileBeforeCompile", STR$( IDE.SaveFileBeforeCompile))
    ini.write("SaveAllBeforeCompile", STR$( IDE.SaveAllBeforeCompile))
    ini.write("ScriptBeforeCompile", IDE.ScriptBeforeCompile)

    '--------------------Other options --------------------
    ini.write("SingleInstanceOnly", STR$(  IDE.SingleInstanceOnly))
    ini.write("SaveSettingsOnExit", STR$(  IDE.SaveSettingsOnExit))
    ini.write("ShowSubsAfterLoad", STR$(  IDE.ShowSubsAfterLoad))
    ini.write("SortSubs", STR$(  IDE.SortSubs))
    ini.write("HiLightCompileErr", STR$(  IDE.HiLightCompileErr))
    ini.write("BackupFiles", STR$(  IDE.BackupFiles))
    ini.write("BackupFilesExt",  IDE.BackupFilesExt)
    ini.write("HighlightBraces",  STR$(IDE.HighlightBraces))
    ini.write("AutoComplete",  STR$(IDE.AutoComplete))
    ini.write("NewTabAtStartup",  STR$(IDE.NewTabAtStartup))
    ini.write("NewFileName",  IDE.NewFileName)
    ini.write("NewFileAutoSave",  STR$(IDE.NewFileAutoSave))
    ini.write("AutoOpenLastProj",  STR$(IDE.AutoOpenLastProj))
    ini.write("FindDeclDialogBox",  STR$(IDE.FindDeclDialogBox))
    ini.write("ShowWelcome",  STR$(IDE.ShowWelcome))
    ini.write("MenuIcons",  STR$(IDE.MenuIcons))

    ini.write("AutoDeclClipboardActiveFile", STR$(  IDE.AutoDeclClipboardActiveFile))
    ini.write("AutoDeclClipboardAllFiles", STR$(  IDE.AutoDeclClipboardAllFiles))
    ini.write("AutoDeclAtTopActiveFile", STR$(  IDE.AutoDeclAtTopActiveFile))
    ini.write("AutoDeclAtTopAllFiles", STR$(  IDE.AutoDeclAtTopAllFiles))
    ini.write("AutoDeclInFile", STR$(  IDE.AutoDeclInFile))
    ini.write("AutoDeclInFileName", IDE.AutoDeclInFileName )

    ini.write("BeautifyCodeTabSpaces", STR$(IDE.BeautifyCodeTabSpaces))
    ini.write("BeautifyCodeCommentSpaces", STR$(IDE.BeautifyCodeCommentSpaces))

    ini.write("SearchEngine",   IDE.SearchEngine)
    ini.write("HomePage",   IDE.HomePage)

    ini.write("ExternalApp1",   IDE.ExternalApp1)
    ini.write("ExternalApp2",   IDE.ExternalApp2)
    ini.write("ExternalApp3",   IDE.ExternalApp3)
    ini.write("ExternalApp4",   IDE.ExternalApp4)

    ini.write("upx",   IDE.upx)
    ini.write("ResHacker",   IDE.ResHacker)
    ini.write("DecompressEXE", STR$(IDE.DecompressEXE))

    '.....resources......
    'these objects are not created on first initialization!!!
    'running this code without checking will cause GP Fault on first creation of .ini file
    IF ResetIt THEN                 
        IDE.EmbedManifest  =         IDE_Conf_ManifestEmbedCheckBox.Checked 
        IDE.EmbedVersionInfo  =      IDE_Conf_VersionInfoCheckBox.Checked 
        IDE.FileVersion   =          IDE_Conf_VersionInfoGrid.Cell(1,1)  
        IDE.ProductVersion   =       IDE_Conf_VersionInfoGrid.Cell(1,2) 
        IDE.CompanyName   =          IDE_Conf_VersionInfoGrid.Cell(1,6) 
        IDE.CompanyEmail   =         IDE_Conf_VersionInfoGrid.Cell(1,7) 
        IDE.FileDescription   =      IDE_Conf_VersionInfoGrid.Cell(1,8) 
        IDE.LegalCopyright   =       IDE_Conf_VersionInfoGrid.Cell(1,10) 
    END IF

    ini.write("EmbedManifest",   STR$( IDE.EmbedManifest) )
    ini.write("EmbedVersionInfo",   STR$( IDE.EmbedVersionInfo) )
    ini.write("FileVersion",   IDE.FileVersion)
    ini.write("ProductVersion",   IDE.ProductVersion)
    ini.write("CompanyName",   IDE.CompanyName)
    ini.write("CompanyEmail",   IDE.CompanyEmail)
    ini.write("FileDescription",   IDE.FileDescription)
    ini.write("LegalCopyright",   IDE.LegalCopyright)

    ini.write("KeyWordListFile", IDE.KeyWordListFile)
    ini.write("KeyWordListFile2", IDE.KeyWordListFile2)
    ini.write("KeyWordListFile3", IDE.KeyWordListFile3)

    '.....menus......
    ini.write("MenuShortCutFile",   IDE.MenuShortCutFile)
    IF ResetIt THEN SetIDEVariables
    IDE.CompiledOK = False                                  'reset to recompile

END SUB



SUB ReadIDEVariables
    DIM TmpInt   AS INTEGER
    DIM TmpStr   AS STRING

    IF ini.Exist THEN 

        ini.Section = "IDE_Variables"
        TmpInt = VAL(ini.Get("MainFormLeft", ""))               :    IDE.MainFormLeft = TmpInt
        TmpInt = VAL(ini.Get("MainFormTop", ""))                :    IDE.MainFormTop = TmpInt
        TmpInt = VAL(ini.Get("MainFormWidth", ""))              :    IDE.MainFormWidth = TmpInt
        TmpInt = VAL(ini.Get("MainFormHeight", ""))             :    IDE.MainFormHeight = TmpInt
        TmpInt = VAL(ini.Get("RightSplitterPos", ""))           :    IDE.RightSplitterPos = TmpInt
        TmpInt = VAL(ini.Get("LeftSplitterPos", "100"))         :    IDE.LeftSplitterPos = TmpInt

        'find replace form settings
        TmpInt = VAL(ini.Get("FindReplaceFormLeft", ""))
            IF (TmpInt > 0) AND (TmpInt < (Screen.Width - 300)) THEN FindReplaceForm.Left = TmpInt
        TmpInt = VAL(ini.Get("FindReplaceFormTop", ""))
            IF (TmpInt > 0) AND (TmpInt < (Screen.Height - 450)) THEN FindReplaceForm.Top = TmpInt
        TmpInt = VAL(ini.Get("SetFindTransparency", ""))        :   FindTransparencyOnLostFocusBox.Checked = TmpInt
        TmpInt = VAL(ini.Get("FindTransparencyValue", "255"))   :   FindReplaceTrackBar.Position = TmpInt

        TmpStr = TRIM$(ini.Get("FindReplaceItem0", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem1", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem2", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem3", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem4", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem5", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem6", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem7", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem8", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr
        TmpStr = TRIM$(ini.Get("FindReplaceItem9", "")) : IF TmpStr <> "" THEN ComboBoxFind.AddItems TmpStr

        TmpInt = VAL(ini.Get("ViewStatusBar", "null"))   :    IDE.ViewStatusBar = TmpInt
        TmpInt = VAL(ini.Get("ViewQuickSearch", "null"))   :    IDE.ViewQuickSearch = TmpInt
        TmpInt = VAL(ini.Get("ViewLeftPanel", "null"))   :    IDE.ViewLeftPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewRightPanel", "null"))   :    IDE.ViewRightPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewBottomPanel", "null"))   :    IDE.ViewBottomPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewTopPanel", "null"))   :    IDE.ViewTopPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewFileToolPanel", "null"))   :    IDE.ViewFileToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewEditToolPanel", "null"))   :    IDE.ViewEditToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewCompileToolPanel", "null"))   :    IDE.ViewCompileToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewViewToolPanel", "null"))   :    IDE.ViewViewToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewCodeFoldingToolPanel", "null"))   :    IDE.ViewCodeFoldingToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewFormatToolPanel", "null"))   :    IDE.ViewFormatToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewBookMarkToolPanel", "null"))   :    IDE.ViewBookMarkToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewIconToolPanel", "null"))   :    IDE.ViewIconToolPanel = TmpInt
        TmpInt = VAL(ini.Get("ViewWidgetToolPanel", "null"))   :    IDE.ViewWidgetToolPanel = TmpInt

        TmpStr = ini.Get("MainFont.Name", "Courier New")   : IDE.MainFont.Name= TmpStr
        TmpInt = VAL(ini.Get("MainFont.Size", "10"))   : IDE.MainFont.Size = TmpInt
        TmpInt = HexToDec(ini.Get("MainFont.Color", "0"))   : IDE.MainFont.Color= TmpInt
        TmpInt = VAL(ini.Get("MainFont.Bold", "0"))   : IDE.MainFont.Bold= TmpInt
        TmpInt = VAL(ini.Get("MainFont.Italic", "0"))   : IDE.MainFont.Italic= TmpInt
        TmpInt = VAL(ini.Get("MainFont.Underline", "0"))   : IDE.MainFont.Underline= TmpInt

        TmpInt = HexToDec(ini.Get("BackGround", "FFFFFF"))   :    IDE.BackGround = TmpInt
        TmpInt = HexToDec(ini.Get("SelectionFore", "0"))   :    IDE.SelectionFore = TmpInt
        TmpInt = HexToDec(ini.Get("SelectionBack", "A0A0A0"))   :    IDE.SelectionBack = TmpInt
        TmpInt = HexToDec(ini.Get("LineNumbersFore", "FFA6A6"))   :    IDE.LineNumbersFore = TmpInt
        TmpInt = HexToDec(ini.Get("LineNumbersBack", ""))   :    IDE.LineNumbersBack = TmpInt
        TmpInt = HexToDec(ini.Get("CommentFore", ""))   :    IDE.CommentFore = TmpInt
        TmpInt = HexToDec(ini.Get("CommentBack", ""))   :    IDE.CommentBack = TmpInt
        TmpInt = VAL(ini.Get("CommentBold", ""))   :    IDE.CommentBold = TmpInt
        TmpInt = VAL(ini.Get("CommentItalic", ""))   :    IDE.CommentItalic = TmpInt
        TmpInt = VAL(ini.Get("CommentUnderL", ""))   :    IDE.CommentUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("NumberFore", ""))   :    IDE.NumberFore = TmpInt
        TmpInt = HexToDec(ini.Get("NumberBack", ""))   :    IDE.NumberBack = TmpInt
        TmpInt = VAL(ini.Get("NumberBold", ""))   :    IDE.NumberBold = TmpInt
        TmpInt = VAL(ini.Get("NumberItalic", ""))   :    IDE.NumberItalic = TmpInt
        TmpInt = VAL(ini.Get("NumberUnderL", ""))   :    IDE.NumberUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("StringFore", ""))   :    IDE.StringFore = TmpInt
        TmpInt = HexToDec(ini.Get("StringBack", ""))   :    IDE.StringBack = TmpInt
        TmpInt = VAL(ini.Get("StringBold", ""))   :    IDE.StringBold = TmpInt
        TmpInt = VAL(ini.Get("StringItalic", ""))   :    IDE.StringItalic = TmpInt
        TmpInt = VAL(ini.Get("StringUnderL", ""))   :    IDE.StringUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("PreProcessorFore", ""))   :    IDE.PreProcessorFore = TmpInt
        TmpInt = HexToDec(ini.Get("PreProcessorBack", ""))   :    IDE.PreProcessorBack = TmpInt
        TmpInt = VAL(ini.Get("PreProcessorBold", ""))   :    IDE.PreProcessorBold = TmpInt
        TmpInt = VAL(ini.Get("PreProcessorItalic", ""))   :    IDE.PreProcessorItalic = TmpInt
        TmpInt = VAL(ini.Get("PreProcessorUnderL", ""))   :    IDE.PreProcessorUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("OperatorFore", ""))   :    IDE.OperatorFore = TmpInt
        TmpInt = HexToDec(ini.Get("OperatorBack", ""))   :    IDE.OperatorBack = TmpInt
        TmpInt = VAL(ini.Get("OperatorBold", ""))   :    IDE.OperatorBold = TmpInt
        TmpInt = VAL(ini.Get("OperatorItalic", ""))   :    IDE.OperatorItalic = TmpInt
        TmpInt = VAL(ini.Get("OperatorUnderL", ""))   :    IDE.OperatorUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("KeywordFore", ""))   :    IDE.KeywordFore = TmpInt
        TmpInt = HexToDec(ini.Get("KeywordBack", ""))   :    IDE.KeywordBack = TmpInt
        TmpInt = VAL(ini.Get("KeywordBold", ""))   :    IDE.KeywordBold = TmpInt
        TmpInt = VAL(ini.Get("KeywordItalic", ""))   :    IDE.KeywordItalic = TmpInt
        TmpInt = VAL(ini.Get("KeywordUnderL", ""))   :    IDE.KeywordUnderL = TmpInt
        TmpInt = HexToDec(ini.Get("Keyword2Fore", ""))   :    IDE.Keyword2Fore = TmpInt
        TmpInt = HexToDec(ini.Get("Keyword2Back", ""))   :    IDE.Keyword2Back = TmpInt
        TmpInt = VAL(ini.Get("Keyword2Bold", ""))   :    IDE.Keyword2Bold = TmpInt
        TmpInt = VAL(ini.Get("Keyword2Italic", ""))   :    IDE.Keyword2Italic = TmpInt
        TmpInt = VAL(ini.Get("Keyword2UnderL", ""))   :    IDE.Keyword2UnderL = TmpInt
        TmpInt = HexToDec(ini.Get("Keyword3Fore", ""))   :    IDE.Keyword3Fore = TmpInt
        TmpInt = HexToDec(ini.Get("Keyword3Back", ""))   :    IDE.Keyword3Back = TmpInt
        TmpInt = VAL(ini.Get("Keyword3Bold", ""))   :    IDE.Keyword3Bold = TmpInt
        TmpInt = VAL(ini.Get("Keyword3Italic", ""))   :    IDE.Keyword3Italic = TmpInt
        TmpInt = VAL(ini.Get("Keyword3UnderL", ""))   :    IDE.Keyword3UnderL = TmpInt
        TmpInt = HexToDec(ini.Get("FileTabContolBack", ""))   :    IDE.FileTabContolBack = TmpInt
        TmpInt = HexToDec(ini.Get("FileTabContolInactive", ""))   :    IDE.FileTabContolInactive = TmpInt
        TmpInt = VAL(ini.Get("HiLighting", ""))   :    IDE.HiLighting = TmpInt
        TmpInt = VAL(ini.Get("DefaultLexLanguage", "8"))   :    IDE.DefaultLexLanguage = TmpInt

        TmpInt = VAL(ini.Get("LineNumbers", ""))   :    IDE.LineNumbers = TmpInt
        TmpInt = VAL(ini.Get("ActiveLineBack", "-1"))   :    IDE.ActiveLineBack = TmpInt

        TmpInt = VAL(ini.Get("UseTabs", "0"))   :    IDE.UseTabs = TmpInt
        TmpInt = VAL(ini.Get("TabSpaces", "0"))   :    IDE.TabSpaces = TmpInt
        TmpInt = VAL(ini.Get("CodePage", "0"))   :    IDE.CodePage = TmpInt
        TmpInt = VAL(ini.Get("AutoIndent", "0"))   :    IDE.AutoIndent = TmpInt
        TmpInt = VAL(ini.Get("CodeFolding", "0"))   :    IDE.CodeFolding = TmpInt
        TmpInt = VAL(ini.Get("CodeFoldCollapseAll", "0"))   :    IDE.CodeFoldCollapseAll = TmpInt
        TmpInt = VAL(ini.Get("CodeFoldExpandAll", "0"))   :    IDE.CodeFoldExpandAll = TmpInt
        TmpInt = VAL(ini.Get("ViewIndents", "0"))   :    IDE.ViewIndents = TmpInt
        TmpInt = VAL(ini.Get("FontZoom", "0"))   :    IDE.FontZoom = TmpInt
        TmpInt = VAL(ini.Get("WordWrap", "0"))   :    IDE.WordWrap = TmpInt
        TmpInt = VAL(ini.Get("UseAppDirectory", "1"))   :    IDE_Conf_UseAppDirectory.Checked = TmpInt 'IDE.UseAppDirectory = TmpInt
        TmpStr = ini.Get("ConstPath", "")   :    IDE.ConstPath = TmpStr

        TmpStr = ini.Get("FileFilter", "")   :    IDE.FileFilter = TmpStr
        TmpStr = ini.Get("LastDir", Application.Path)   :    IDE.LastDir = TmpStr
        TmpStr = ini.Get("CompilerPath", "")   :    IDE.CompilerPath = TmpStr
        TmpStr = ini.Get("CompilerLibPath", "")   :    IDE.CompilerLibPath = TmpStr
        TmpStr = ini.Get("CompilerIncPath", "")   :    IDE.CompilerIncPath = TmpStr
        TmpStr = ini.Get("CompilerIconPath", "")   :    IDE.CompilerIconPath = TmpStr
        TmpStr = ini.Get("CompilerHelpFile", "")   :    IDE.CompilerHelpFile = TmpStr
        TmpStr = ini.Get("CompilerTemplatePath", "")   :    IDE.CompilerTemplatePath = TmpStr
        TmpStr = ini.Get("FBCompilerPath", "")   :    IDE.FBCompilerPath = TmpStr
        TmpStr = ini.Get("FBCommandLIne", "")   :    IDE.FBCommandLIne = TmpStr
        TmpStr = ini.Get("FBCompilerHelpFile", "")   :    IDE.FBCompilerHelpFile = TmpStr
        TmpStr = ini.Get("FBRunCmd", "")   :    IDE.FBRunCmd = TmpStr
        TmpInt = VAL(ini.Get("FBPauseAfterRun", ""))   :    IDE.FBPauseAfterRun = TmpInt
        TmpStr = ini.Get("FBRunAfterFile", "")   :    IDE.FBRunAfterFile = TmpStr
        TmpInt = VAL(ini.Get("IsJava", ""))   :    IDE.IsJava = TmpInt

        TmpStr = ini.Get("IconName", "")   :    IDE.IconName = TRIM$(TmpStr)

        TmpInt = VAL(ini.Get("OptimizeOn", ""))   :    IDE.OptimizeOn = TmpInt
        TmpInt = VAL(ini.Get("TypeCheckOn", ""))   :    IDE.TypeCheckOn = TmpInt
        TmpInt = VAL(ini.Get("VerboseOn", ""))   :    IDE.VerboseOn = TmpInt
        TmpInt = VAL(ini.Get("ByteCodeOn", ""))   :    IDE.ByteCodeOn = TmpInt

        TmpInt = VAL(ini.Get("GenerateManifest", ""))   :    IDE.GenerateManifest = TmpInt
        TmpInt = VAL(ini.Get("SaveFileBeforeCompile", ""))   :    IDE.SaveFileBeforeCompile = TmpInt
        TmpInt = VAL(ini.Get("SaveAllBeforeCompile", ""))   :    IDE.SaveAllBeforeCompile = TmpInt
        TmpStr = ini.Get("ScriptBeforeCompile", "")   :    IDE.ScriptBeforeCompile = TmpStr
        TmpInt = VAL(ini.Get("SingleInstanceOnly", ""))   :    IDE.SingleInstanceOnly = TmpInt
        TmpInt = VAL(ini.Get("ShowSplashScreen", ""))   :    IDE.ShowSplashScreen = TmpInt
        TmpInt = VAL(ini.Get("SaveSettingsOnExit", ""))   :    IDE.SaveSettingsOnExit = TmpInt
        TmpInt = VAL(ini.Get("ShowSubsAfterLoad", ""))   :    IDE.ShowSubsAfterLoad = TmpInt
        TmpInt = VAL(ini.Get("SortSubs", ""))   :    IDE.SortSubs = TmpInt
        TmpInt = VAL(ini.Get("HiLightCompileErr", ""))   :    IDE.HiLightCompileErr = TmpInt
        TmpInt = VAL(ini.Get("BackupFiles", ""))   :    IDE.BackupFiles = TmpInt
        TmpStr = ini.Get("BackupFilesExt", "")   :    IDE.BackupFilesExt = TmpStr
        TmpInt = VAL(ini.Get("HighlightBraces", ""))   :    IDE.HighlightBraces = TmpInt
        TmpInt = VAL(ini.Get("AutoComplete", ""))   :    IDE.AutoComplete = TmpInt
        TmpInt = VAL(ini.Get("NewTabAtStartup", ""))   :    IDE.NewTabAtStartup = TmpInt
        TmpInt = VAL(ini.Get("AutoOpenLastProj", ""))   :    IDE.AutoOpenLastProj = TmpInt
        TmpInt = VAL(ini.Get("FindDeclDialogBox", ""))   :    IDE.FindDeclDialogBox = TmpInt
        TmpInt = VAL(ini.Get("ShowWelcome", ""))        :    IDE.ShowWelcome = TmpInt
        TmpStr = VAL(ini.Get("NewFileName", "~New"))   :    IDE.NewFileName = TmpStr
        TmpInt = VAL(ini.Get("NewFileAutoSave", ""))   :    IDE.NewFileAutoSave = TmpInt
        TmpInt = VAL(ini.Get("MenuIcons", ""))   :    IDE.MenuIcons = TmpInt

        TmpInt = VAL(ini.Get("AutoDeclClipboardActiveFile", ""))   :    IDE.AutoDeclClipboardActiveFile = TmpInt
        TmpInt = VAL(ini.Get("AutoDeclClipboardAllFiles", ""))   :    IDE.AutoDeclClipboardAllFiles = TmpInt
        TmpInt = VAL(ini.Get("AutoDeclAtTopActiveFile", ""))   :    IDE.AutoDeclAtTopActiveFile = TmpInt
        TmpInt = VAL(ini.Get("AutoDeclAtTopAllFiles", ""))   :    IDE.AutoDeclAtTopAllFiles = TmpInt
        TmpInt = VAL(ini.Get("AutoDeclInFile", ""))   :    IDE.AutoDeclInFile = TmpInt
        TmpStr = ini.Get("AutoDeclInFileName", "")   :    IDE.AutoDeclInFileName = TmpStr

        TmpInt = VAL(ini.Get("BeautifyCodeTabSpaces", "4"))   :  IDE.BeautifyCodeTabSpaces = TmpInt
        TmpInt = VAL(ini.Get("BeautifyCodeCommentSpaces", "0"))  :  IDE.BeautifyCodeCommentSpaces = TmpInt

        TmpStr = ini.Get("SearchEngine", "")   :    IDE.SearchEngine = TmpStr
        TmpStr = ini.Get("HomePage", "")   :    IDE.HomePage = TmpStr

        TmpStr = ini.Get("ExternalApp1", "")   :    IDE.ExternalApp1 = TmpStr
        TmpStr = ini.Get("ExternalApp2", "")   :    IDE.ExternalApp2 = TmpStr
        TmpStr = ini.Get("ExternalApp3", "")   :    IDE.ExternalApp3 = TmpStr
        TmpStr = ini.Get("ExternalApp4", "")   :    IDE.ExternalApp4 = TmpStr

        TmpStr = ini.Get("upx", "")
'        TmpStr = REPLACESUBSTR$(TmpStr, "%APPPATH%", Application.Path)          ''allow for "%APPPATH% = Path of FreeQ exe"
        IDE.upx = TmpStr
        TmpStr = ini.Get("ResHacker", "")
'        TmpStr = REPLACESUBSTR$(TmpStr, "%APPPATH%", Application.Path)
        IDE.ResHacker = TmpStr
        TmpInt = VAL(ini.Get("DecompressEXE", "0"))       :    IDE.DecompressEXE = TmpInt

        TmpInt = VAL(ini.Get("EmbedManifest", "0"))       :    IDE.EmbedManifest = TmpInt
        TmpInt = VAL(ini.Get("EmbedVersionInfo", "0"))   :    IDE.EmbedVersionInfo = TmpInt
        TmpStr = ini.Get("FileVersion", "1,0,0,0")   :    IDE.FileVersion = TmpStr
        TmpStr = ini.Get("ProductVersion", "1,0,0,0")   :    IDE.ProductVersion = TmpStr
        TmpStr = ini.Get("CompanyName", "My Company")   :    IDE.CompanyName = TmpStr
        TmpStr = ini.Get("CompanyEmail", "me@Company.com")   :    IDE.CompanyEmail = TmpStr
        TmpStr = ini.Get("FileDescription", "program developed in FreeQ")   :    IDE.FileDescription = TmpStr
        TmpStr = ini.Get("LegalCopyright", "Copyright 2012, my company")   :    IDE.LegalCopyright = TmpStr

        TmpStr = ini.Get("KeyWordListFile", "")   :   IDE.KeyWordListFile = TmpStr
        TmpStr = ini.Get("KeyWordListFile2", "")  :   IDE.KeyWordListFile2 = TmpStr
        TmpStr = ini.Get("KeyWordListFile3", "")  :   IDE.KeyWordListFile3 = TmpStr

        SetIDEVariables

        IF ini.FileName = TheMainIniFile THEN IDE_GetRecentList     'only on the main ini for the editor!
'       IDE_Conf_LoadProject            're open last project

    END IF
    IDE_Conf_Form.Close
END SUB



SUB SetIDEVariables

    DEFINT nX = IDE.MainFormLeft                    'need to store Mainform sizes so 
    DEFINT nY = IDE.MainFormTop                     'not to interfere with OnResize!!
    DEFINT nX2 = IDE.MainFormWidth
    DEFINT nY2 = IDE.MainFormHeight

    IF (nX2 = 0) OR (nY2 = 0) THEN                  'have new ini file...
        nX = 48
        nX2 = Screen.ClientWidth - 96
        nY = 48
        nY2 = Screen.ClientHeight - 96
        IDE.RightSplitterPos = nX2 * 0.8            '80%
        IDE.LeftSplitterPos = nX2 * 0.2             '20%

    ELSE                                            'else set limits
        IF nX < -6 THEN nX = 0                      'set limits on top & left
        IF nY < -6 THEN nY = 0
        IF (nX2 + nX) > (Screen_Width + 8) THEN     'allow some slop
            nX2 = Screen.ClientWidth - 48 - nX
        END IF
        IF nX2 < 500 THEN nX2 = 500

        IF (nY2 + nY) > (Screen_Width + 4) THEN 
            nY2 = Screen.ClientHeight - 48 - nY
        END IF
        IF nY2 < 400 THEN nY2 = 400
    END IF

    MainForm.Left = nX                              'setting MainForm Size will set
    MainForm.Top = nY                               'global IDE.MainformXXXX vars, no need to set here
    MainForm.Width = nX2
    MainForm.Height = nY2

    Splitter_Moved                                  'now physically set them
    IF IDE.RightSplitterPos < 300 THEN IDE.RightSplitterPos = 300 
    IF IDE.RightSplitterPos > (MainForm.ClientWidth - 80) THEN IDE.RightSplitterPos = (MainForm.ClientWidth - 80)
    RightPanel.Width = MainForm.ClientWidth - IDE.RightSplitterPos - RightSplitter.Width
    IF IDE.LeftSplitterPos < 10 THEN IDE.LeftSplitterPos = 10
    IF IDE.LeftSplitterPos > 50 THEN LeftPanel.Width = IDE.LeftSplitterPos
    Splitter_Moved

    'set panels/etc color
    MainListBox1.Color = IDE.Background
    MainListBoxResources.Color = IDE.Background
    MainListBoxIncludes.Color = IDE.Background
    MainListBox1.Font.Color = IDE.MainFont.Color
    MainListBoxResources.Font.Color = IDE.MainFont.Color
    MainListBoxIncludes.Font.Color = IDE.MainFont.Color
    FOR zzz = 0 TO IDE_MAX_FILES
        SubFuncListView(zzz).Color = IDE.Background
        SubFuncListView(zzz).Font.Color = IDE.MainFont.Color
    NEXT zzz

    ProjFileList.Font.Color = IDE.MainFont.Color
    ProjFileList.Color = IDE.Background
    DirTree.Font.Color = IDE.MainFont.Color
    DirTree.Color = IDE.Background

    FindTreeView.Font.Color = IDE.MainFont.Color
    FindTreeView.Color = IDE.Background
    RichEditCompile.Font.Color = IDE.MainFont.Color
    RichEditCompile.Color = IDE.Background

    LeftPanel.Color = IDE.FileTabContolBack
    LeftPanelBottomPanel.Color = IDE.FileTabContolBack
    RightPanel.Color = IDE.FileTabContolBack
    LeftPanelTopPanel.Color = IDE.FileTabContolBack
    RightPanelTopPanel.Color = IDE.FileTabContolBack
    PanelSearch.Color = IDE.FileTabContolBack
    CenterPanel.Color = IDE.FileTabContolBack
    BottomPanel.Color = IDE.FileTabContolBack
    ProjPanel.Color = IDE.FileTabContolBack
    IncResPanel.Color = IDE.FileTabContolBack
    FindAllPanel.Color = IDE.FileTabContolBack
    SubFuncsPanel.Color = IDE.FileTabContolBack
    TopPanel.Color = IDE.FileTabContolBack
    FileToolPanel.Color = IDE.FileTabContolBack
    EditToolPanel.Color = IDE.FileTabContolBack
    CompileToolPanel.Color = IDE.FileTabContolBack
    ViewToolPanel.Color = IDE.FileTabContolBack
    CodeFoldingToolPanel.Color = IDE.FileTabContolBack
    FormatToolPanel.Color = IDE.FileTabContolBack
    BookMarkToolPanel.Color = IDE.FileTabContolBack
    WidgetPanel.Color = IDE.FileTabContolBack

    'now tabcontrols
    IDE_Conf_TabControl.Color = IDE.FileTabContolBack
    TabControl3.Color = IDE.FileTabContolBack
    WidgetTab.Color = IDE.FileTabContolBack


    MFE_Tab.Color = IDE.FileTabContolBack
    MFE_Tab.TabInactiveColor = IDE.FileTabContolInactive
    re.SetStyle(STYLE_LINENUMBER, IDE.LineNumbersFore, IDE.LineNumbersBack, 0,0,0)


    'set main editor options (no menu operations)
    re.Set_TabWidth(IDE.TabSpaces)
    re.Set_WantTabs(IDE.UseTabs)
    re.Set_CodePage(IDE.CodePage)
    re.Set_Font(IDE.MainFont)
    re.Set_SelColor(IDE.SelectionFore, IDE.SelectionBack)
    IF IDE.ActiveLineBack <> -1 THEN re.ActiveLineColor(IDE.ActiveLineBack, 0) ELSE re.ActiveLineColor(IDE.BackGround, 0)
    re.HighlightBraces = IDE.HighlightBraces

    IF IDE.HighlightBraces THEN 
        re.SetStyle(STYLE_BRACEBAD, IDE.MainFont.Color, clYellow, 1, 1, 0)
        're.SetStyle(STYLE_BRACELIGHT, IDE.BackGround, IDE.MainFont.Color, 1,0,0)
        re.SetStyle(STYLE_BRACELIGHT, IDE.BackGround, RGB( 0, 141, 225 ), 1,0,0)
    END IF

    'set these options though menus, need to have check marks set correctly
    IDE.ViewStatusBar =   NOT!(IDE.ViewStatusBar)                       :   mnuViewStatusBar_Click
    IDE.ViewQuickSearch = NOT!(IDE.ViewQuickSearch)                     :   VisibileQuickSearchClick
    IDE.ViewStatusBar =   NOT!(IDE.ViewStatusBar)                       :   mnuViewStatusBar_Click
    IDE.ViewLeftPanel =   NOT!(IDE.ViewLeftPanel)                       :   mnuViewLeftPanel_Click
    IDE.ViewRightPanel =   NOT!(IDE.ViewRightPanel)                     :   mnuViewRightPanel_Click
    IDE.ViewBottomPanel =   NOT!(IDE.ViewBottomPanel)                   :   mnuViewBottomPanel_Click
    IDE.ViewTopPanel =   NOT!(IDE.ViewTopPanel)                         :   mnuViewTopPanel_Click
    IDE.ViewFileToolPanel =   NOT!(IDE.ViewFileToolPanel)               :   mnuViewFileToolBar_Click
    IDE.ViewEditToolPanel =   NOT!(IDE.ViewEditToolPanel)               :   mnuViewEditToolBar_Click
    IDE.ViewCompileToolPanel =   NOT!(IDE.ViewCompileToolPanel)         :   mnuViewCompileToolBar_Click
    IDE.ViewViewToolPanel =   NOT!(IDE.ViewViewToolPanel)               :   mnuViewViewToolBar_Click
    IDE.ViewCodeFoldingToolPanel =   NOT!(IDE.ViewCodeFoldingToolPanel) :   mnuViewCodeFoldToolBar_Click
    IDE.ViewFormatToolPanel =   NOT!(IDE.ViewFormatToolPanel)           :   mnuViewFormatToolBar_Click
    IDE.ViewBookMarkToolPanel =   NOT!(IDE.ViewBookMarkToolPanel)       :   mnuViewBookMarkToolBar_Click
    IDE.ViewIconToolPanel = NOT!(IDE.ViewIconToolPanel)                 :   mnuViewIconToolBar_Click
    IDE.ViewWidgetToolPanel = NOT!( IDE.ViewWidgetToolPanel)            :   mnuViewWidgetToolBar_Click


    IDE.CodeFolding = NOT!(IDE.CodeFolding)                     : Mnu_CodeFolding_Click
    IDE.CodeFoldCollapseAll = NOT!(IDE.CodeFoldCollapseAll)     : Mnu_CodeFoldingCollapseAll_Click
    IDE.CodeFoldExpandAll = NOT!(IDE.CodeFoldExpandAll)         : Mnu_CodeFoldingExpandAll_Click
    
    'toggle setup through menus
    IDE.HiLighting =   NOT!( IDE.HiLighting) :         Mnu_HilightClick
    IDE.WordWrap =     NOT!( IDE.WordWrap) :           Mnu_WordWrapClick
    IDE.LineNumbers =  NOT!( IDE.LineNumbers) :        Mnu_SetLineNumbersClick
    IDE.AutoIndent =   NOT!( IDE.AutoIndent) :         Mnu_AutoIndentClick
    IDE.AutoComplete = NOT!( IDE.AutoComplete) :       Mnu_AutoCompleteClick
    IDE.CodeFolding =  NOT!( IDE.CodeFolding) :        Mnu_CodeFolding_Click
    IDE.ViewIndents =  NOT!( IDE.ViewIndents) :        Mnu_ViewIndentationClick
    IDE.ViewBookMarks = NOT!(IDE.ViewBookMarks) :      mnuNViewBookMark_Click

    IF (IDE.FontZoom <> 0) AND (ABS(IDE.FontZoom) < 10) THEN                'set font size to last saved setting
        nY = IDE.FontZoom                                                   'store for upcoming modification
        IDE.FontZoom = 0                                                    'this will be reset below
        mnuRestoreFontMagnification_Click                                   'else restore normal magnification
        FOR nX = 1 TO ABS(nY)
            IF (nY > 0) THEN 
                mnuMagnifyFont_Click
            ELSE 
                mnuMinifyFont_Click                                         'simulate the user clicks
            END IF
        NEXT nX
    ELSE
        IDE.FontZoom = 0
        mnuRestoreFontMagnification_Click                                   'else restore normal magnification
    END IF


    FOR nX = 0 TO IDE_Conf_MainLanguage.ItemCount-1
        nY = VAL(RIGHT$(IDE_Conf_MainLanguage.Item(nX), 4))
        IF IDE.DefaultLexLanguage = nY THEN 
            IDE_Conf_MainLanguage.ItemIndex = nX
            mnuSetAsDefaultCompileFile.Caption = "Set active File as " _
                + LEFT$(IDE_Conf_MainLanguage.Text, INSTR(IDE_Conf_MainLanguage.Text, "   ") + 1) + "file"
            EXIT FOR
        END IF
    NEXT nx


    IconsetFlatButton.ICOHandle = RapidQ_ico
    IF IDE.IconName <> "" THEN                      'setting to null makes default RQ icon
        IF FILEEXISTS(IDE.IconName) THEN IconsetFlatButton.Icon = IDE.IconName
    END IF

    IDE_Conf_ManifestEmbedCheckBox.Checked = IDE.EmbedManifest
    IDE_Conf_VersionInfoCheckBox.Checked = IDE.EmbedVersionInfo
    IDE_Conf_VersionInfoGrid.Cell(1,1)  = IDE.FileVersion 
    IDE_Conf_VersionInfoGrid.Cell(1,2) = IDE.ProductVersion 
    IDE_Conf_VersionInfoGrid.Cell(1,6) = IDE.CompanyName 
    IDE_Conf_VersionInfoGrid.Cell(1,7) = IDE.CompanyEmail 
    IDE_Conf_VersionInfoGrid.Cell(1,8) = IDE.FileDescription 
    IDE_Conf_VersionInfoGrid.Cell(1,10) = IDE.LegalCopyright 

    SetToolsMenus
    ProjDirBack          'set the Treeview dir using IDE.LastDir

    'load custom keywords if needed
    IF (IDE.KeyWordListFile <> "") AND FILEEXISTS(IDE.KeyWordListFile) THEN IDE.KeyWordList.LoadFromFile(IDE.KeyWordListFile)
    IF (IDE.KeyWordListFile2 <> "") AND FILEEXISTS(IDE.KeyWordListFile2) THEN IDE.KeyWordList.LoadFromFile(IDE.KeyWordListFile2)
    IF (IDE.KeyWordListFile3 <> "") AND FILEEXISTS(IDE.KeyWordListFile3) THEN IDE.KeyWordList.LoadFromFile(IDE.KeyWordListFile3)

    IF IDE.KeyWordList.ItemCount > 0 THEN re.LoadKeywordList(0, IDE.KeyWordList)     ': IDE.KeyWordList.Clear
    IF IDE.KeyWordList2.ItemCount > 0 THEN re.LoadKeywordList(1, IDE.KeyWordList2)   ': IDE.KeyWordList2.Clear
    IF IDE.KeyWordList3.ItemCount > 0 THEN re.LoadKeywordList(2, IDE.KeyWordList3)   ': IDE.KeyWordList3.Clear

    IDE.CompiledOK = False                                  'reset to recompile
END SUB



SUB IDE_Conf_ToggleActiveLineColor
    IF IDE_Conf_ActiveLineBackButton.Checked THEN
        IF IDE.ActiveLineBack = -1 THEN                             '-1 = turn off, else give default
            IDE_Conf_ActiveLineBackLabel.Color = RGB(255, 243, 200)
        ELSE
            IDE_Conf_ActiveLineBackLabel.Color = IDE.ActiveLineBack
        END IF
        IDE_Conf_ActiveLineBackLabel.Visible = True
    ELSE
        IDE.ActiveLineBack = -1
        IDE_Conf_ActiveLineBackLabel.Color = IDE.ActiveLineBack
        IDE_Conf_ActiveLineBackLabel.Visible = False
    END IF
    re.ActiveLineColor(IDE.ActiveLineBack, 0)
END SUB




SUB IDE_Conf_PickFont
    FontDialog.GetFont(IDE.MainFont)
    IF FontDialog.Execute THEN
        FontDialog.SetFont(IDE.MainFont)
        IDE_Conf_TextRichEdit.Font = IDE.MainFont
    END IF
END SUB



SUB mnuRecentClearClick         'clear recent file list in QSTRINGLIST
    IDE_RecentFileList.Clear
    mnuRecent0.Visible = False
    mnuRecent1.Visible = False
    mnuRecent2.Visible = False
    mnuRecent3.Visible = False
    mnuRecent4.Visible = False
    mnuRecent5.Visible = False
    mnuRecent6.Visible = False
    mnuRecent7.Visible = False
    mnuRecent8.Visible = False
    mnuRecent9.Visible = False
    mnuRecent10.Visible = False
    mnuRecent11.Visible = False
    mnuRecent12.Visible = False
    mnuRecent13.Visible = False
    mnuRecent14.Visible = False
    mnuRecent15.Visible = False

    IF MFE_List.ItemCount > 0 THEN
        IDE_RecentFileList.AddItems(IDE.MFEActiveFile)
        mnuRecent0.Caption = "&0 " + IDE_RecentFileList.Item(0)
        mnuRecent0.Visible = True
    END IF
END SUB


SUB IDE_UpdateRecentList
    DEFINT i = IDE_RecentFileList.IndexOf(IDE.MFEActiveFile)        
    IF (i > = 0) AND (IDE_RecentFileList.ItemCount > 0) THEN IDE_RecentFileList.DelItems(i)
    IDE_RecentFileList.InsertItem(0, IDE.MFEActiveFile)                                                             'insert at beginning
    IF IDE_RecentFileList.ItemCount > (IDE_MAX_RECENTFILES + 1) THEN IDE_RecentFileList.DelItems(IDE_MAX_RECENTFILES +1)      'remove last if overflow

    ini.FileName = TheMainIniFile
    ini.Section = "Recent Files"
    FOR i = 0 TO IDE_MAX_RECENTFILES
         IF i < (IDE_RecentFileList.ItemCount) THEN 
            ini.write("File" + STR$(i), IDE_RecentFileList.Item(i))
            SELECT CASE i
                CASE 0: mnuRecent0.Visible = True:  mnuRecent0.Caption = "&0 " + IDE_RecentFileList.Item(i)
                CASE 1: mnuRecent1.Visible = True:  mnuRecent1.Caption = "&1 " + IDE_RecentFileList.Item(i)
                CASE 2: mnuRecent2.Visible = True:  mnuRecent2.Caption = "&2 " + IDE_RecentFileList.Item(i)
                CASE 3: mnuRecent3.Visible = True:  mnuRecent3.Caption = "&3 " + IDE_RecentFileList.Item(i)
                CASE 4: mnuRecent4.Visible = True:  mnuRecent4.Caption = "&4 " + IDE_RecentFileList.Item(i)
                CASE 5: mnuRecent5.Visible = True:  mnuRecent5.Caption = "&5 " + IDE_RecentFileList.Item(i)
                CASE 6: mnuRecent6.Visible = True:  mnuRecent6.Caption = "&6 " + IDE_RecentFileList.Item(i)
                CASE 7: mnuRecent7.Visible = True:  mnuRecent7.Caption = "&7 " + IDE_RecentFileList.Item(i)
                CASE 8: mnuRecent8.Visible = True:  mnuRecent8.Caption = "&8 " + IDE_RecentFileList.Item(i)
                CASE 9: mnuRecent9.Visible = True:  mnuRecent9.Caption = "&9 " + IDE_RecentFileList.Item(i)
                CASE 10: mnuRecent10.Visible = True:  mnuRecent10.Caption = "&A " + IDE_RecentFileList.Item(i)
                CASE 11: mnuRecent11.Visible = True:  mnuRecent11.Caption = "&B " + IDE_RecentFileList.Item(i)
                CASE 12: mnuRecent12.Visible = True:  mnuRecent12.Caption = "&C " + IDE_RecentFileList.Item(i)
                CASE 13: mnuRecent13.Visible = True:  mnuRecent13.Caption = "&D " + IDE_RecentFileList.Item(i)
                CASE 14: mnuRecent14.Visible = True:  mnuRecent14.Caption = "&E " + IDE_RecentFileList.Item(i)
                CASE 15: mnuRecent15.Visible = True:  mnuRecent15.Caption = "&F " + IDE_RecentFileList.Item(i)
            END SELECT
         END IF
    NEXT i
END SUB




SUB IDE_GetRecentList
    DEFSTR tmpStr = ""
    DEFINT i

    IDE_RecentFileList.Clear
    ini.Section = "Recent Files"
    FOR i = 0 TO IDE_MAX_RECENTFILES -1
        TmpStr = ini.Get("File" + STR$(i), "")
        IF TmpStr <> "" THEN 
            IDE_RecentFileList.AddItems TmpStr
            SELECT CASE i
                CASE 0: mnuRecent0.Visible = True:  mnuRecent0.Caption = "&0 " + TmpStr
                CASE 1: mnuRecent1.Visible = True:  mnuRecent1.Caption = "&1 " + TmpStr
                CASE 2: mnuRecent2.Visible = True:  mnuRecent2.Caption = "&2 " + TmpStr
                CASE 3: mnuRecent3.Visible = True:  mnuRecent3.Caption = "&3 " + TmpStr
                CASE 4: mnuRecent4.Visible = True:  mnuRecent4.Caption = "&4 " + TmpStr
                CASE 5: mnuRecent5.Visible = True:  mnuRecent5.Caption = "&5 " + TmpStr
                CASE 6: mnuRecent6.Visible = True:  mnuRecent6.Caption = "&6 " + TmpStr
                CASE 7: mnuRecent7.Visible = True:  mnuRecent7.Caption = "&7 " + TmpStr
                CASE 8: mnuRecent8.Visible = True:  mnuRecent8.Caption = "&8 " + TmpStr
                CASE 9: mnuRecent9.Visible = True:  mnuRecent9.Caption = "&9 " + TmpStr
                CASE 10: mnuRecent10.Visible = True:  mnuRecent10.Caption = "&A " + TmpStr
                CASE 11: mnuRecent11.Visible = True:  mnuRecent11.Caption = "&B " + TmpStr
                CASE 12: mnuRecent12.Visible = True:  mnuRecent12.Caption = "&C " + TmpStr
                CASE 13: mnuRecent13.Visible = True:  mnuRecent13.Caption = "&D " + TmpStr
                CASE 14: mnuRecent14.Visible = True:  mnuRecent14.Caption = "&E " + TmpStr
                CASE 15: mnuRecent15.Visible = True:  mnuRecent15.Caption = "&F " + TmpStr
            END SELECT
        END IF
    NEXT i

    ini.Section = "RecentProjects"
    TmpStr = ini.Get("File0", ""): mnuRecentProj0.Caption = TmpStr: IF TRIM$(mnuRecentProj0.Caption) = "" THEN mnuRecentProj0.Visible = False ELSE mnuRecentProj0.Visible = True
    TmpStr = ini.Get("File1", ""): mnuRecentProj1.Caption = TmpStr: IF TRIM$(mnuRecentProj1.Caption) = "" THEN mnuRecentProj1.Visible = False ELSE mnuRecentProj1.Visible = True
    TmpStr = ini.Get("File2", ""): mnuRecentProj2.Caption = TmpStr: IF TRIM$(mnuRecentProj2.Caption) = "" THEN mnuRecentProj2.Visible = False ELSE mnuRecentProj2.Visible = True
END SUB




SUB IDE_Conf_FindPathTarget (Sender AS QBUTTON)
    DEFSTR TheCurDir = DirTree.Directory    'allow to restore current state

    IF (Sender.Tag = 1) OR _
        (Sender.Tag = 6) OR _
        (Sender.Tag = 10) OR _
        (Sender.Tag = 16) OR _
        (Sender.Tag = 17) OR _
        (Sender.Tag = 21) OR _
        (Sender.Tag = 22) OR _
        (Sender.Tag = 23) OR _
        (Sender.Tag = 24) OR _
        (Sender.Tag = 30) OR _
        (Sender.Tag = 31) THEN        'compiler path, or 'help file, FB = same +10, or find external app

        DIM OpenDialog AS QOPENDIALOG
        OpenDialog.InitialDir = Application.Path
        IF OpenDialog.Execute THEN 

            IF Sender.Tag = 1 THEN 
                IDE.CompilerPath = OpenDialog.FileName
                IDE_Conf_CompilerPathEdit.Text = IDE.CompilerPath
            END IF

            IF Sender.Tag = 6 THEN IDE.CompilerHelpFile = OpenDialog.FileName               :IDE_Conf_HelpFilePathEdit.Text = IDE.CompilerHelpFile
            IF Sender.Tag = 10 THEN IDE.FBCompilerPath = OpenDialog.FileName                :IDE_Conf_FBCompilerPathEdit.Text = IDE.FBCompilerPath
            IF Sender.Tag = 16 THEN IDE.FBCompilerHelpFile = OpenDialog.FileName            :IDE_Conf_FBHelpFilePathEdit.Text = IDE.FBCompilerHelpFile
            IF Sender.Tag = 17 THEN IDE.FBRunAfterFile = OpenDialog.FileName                :IDE_Conf_FBRunAfterEdit.Text = IDE.FBRunAfterFile
            IF Sender.Tag = 21 THEN IDE.ExternalApp1 = OpenDialog.FileName                  :IDE_Conf_ExternApp1.Text = IDE.ExternalApp1
            IF Sender.Tag = 22 THEN IDE.ExternalApp2 = OpenDialog.FileName                  :IDE_Conf_ExternApp2.Text = IDE.ExternalApp2
            IF Sender.Tag = 23 THEN IDE.ExternalApp3 = OpenDialog.FileName                  :IDE_Conf_ExternApp3.Text = IDE.ExternalApp3
            IF Sender.Tag = 24 THEN IDE.ExternalApp4 = OpenDialog.FileName                  :IDE_Conf_ExternApp4.Text = IDE.ExternalApp4
            IF Sender.Tag = 30 THEN IDE.upx = OpenDialog.FileName                           :IDE_Conf_upxApp.Text       = IDE.upx
            IF Sender.Tag = 31 THEN IDE.ResHacker = OpenDialog.FileName                     :IDE_Conf_ResHackerApp.Text = IDE.ResHacker

        END IF

    ELSE
        tmpList.Clear
        gListOkButton.Tag = 2               'set our action
        gListBox.Visible = False
        gListLabel.Visible = False
        DirTree.Parent = gListForm          'must use only one QDirTree per app!!
        DirTree.Align = alNone
        DirTree.InitialDir = Application.Path
        DirTree.Left = 0
        DirTree.Top = 22
        DirTree.Width = 318
        DirTree.Height = 550
        DirTree.AddDriveTypes 1             'allow reading of drives above e: after setting parent
        DirTree.Reload
        gListForm.Caption = "Select path/ file"
        gListForm.Width = 352
        gListForm.ShowModal

        DEFSTR TheResult = tmpList.Text
        tmpList.Clear
        TheResult = TheResult - CHR$(10)      'the QDirTree returns LF CR !!
        TheResult = TheResult - CHR$(13)


        SELECT CASE Sender.Tag
            CASE 2          'lib path , no trailing slash!
                IF TheResult <> "" THEN
                    IDE.CompilerLibPath = TheResult
                    IF RIGHT$(IDE.CompilerLibPath, 1) = "\" THEN 
                        IDE.CompilerLibPath = LEFT$(IDE.CompilerLibPath, LEN(IDE.CompilerLibPath)-1)
                    END IF
                    IDE_Conf_LibPathEdit.Text = IDE.CompilerLibPath
                END IF

            CASE 3          'inc path, no trailing slash!
                IF TheResult <> "" THEN 
                    IDE.CompilerIncPath = TheResult
                    IF RIGHT$(IDE.CompilerIncPath, 1) = "\" THEN 
                        IDE.CompilerIncPath = LEFT$(IDE.CompilerIncPath, LEN(IDE.CompilerIncPath)-1)
                    END IF
                    IDE_Conf_IncludePathEdit.Text = IDE.CompilerIncPath
                END IF

            CASE 4          'icon path, no trailing slash!
                IF TheResult <> "" THEN 
                    IDE.CompilerIconPath = TheResult
                    IF RIGHT$(IDE.CompilerIconPath, 1) = "\" THEN 
                        IDE.CompilerIconPath = LEFT$(IDE.CompilerIconPath, LEN(IDE.CompilerIconPath)-1)
                    END IF
                    IDE_Conf_IconPathEdit.Text = IDE.CompilerIconPath
                END IF

            CASE 5          'templates path
                IF TheResult <> "" THEN IDE.CompilerTemplatePath = TheResult    : IDE_Conf_TemplatesPathEdit.Text = IDE.CompilerTemplatePath

            CASE 99
                IF TheResult <> "" THEN DirSearchEdit.Text = TheResult 
        END SELECT
    END IF

    'return it back to normal
    DirTree.Parent = ProjPanel
    DirTree.Height = MainForm.ClientHeight / 4
    DirTree.Width  = ProjPanel.Width
    DirTree.Align = alClient
    DirTree.Top = 2
    DirTree.Left = 1
    DirTree.InitialDir = TheCurDir
    DirTree.Directory =  TheCurDir
    DirTree.AddDriveTypes 1             'allow reading of drives above e: after setting parent
END SUB



SUB IDE_Conf_Menus_DefaultButton_Click
    IF MessageBox("Set Defaults?", "Set Shortcut keys to defaults", 1) = True THEN
        IDE.MenuShortCutFile = ""                                 'clear filename to load defaults
        ShowMessage "Defaults set on next restart..."
    END IF
END SUB


SUB IDE_Conf_Menus_LoadButton_Click
    fDialog.Filter = "Text files|*.txt|All Files|*.*"
    fDialog.Mode = fdOpen
    fDialog.MultiSelect = False
    IF fDialog.Execute THEN
        IF FILEEXISTS (fDialog.FileName) = True THEN
            'Clear (no IDE_Conf_MenuGrid.Clear)
            defint x,y
            FOR y = 1 TO IDE_Conf_MenuGrid.RowCount-1
               FOR x = 0 TO IDE_Conf_MenuGrid.ColCount-1
                   IDE_Conf_MenuGrid.Cell(x,y)= ""
               NEXT x
            NEXT y
            gFStream.Open(fDialog.FileName, fmOpenRead)
            gMem.CopyFrom(gFStream, gFStream.Size)        'store it to our memory, will not work from QFileStream
            gMem.Position = 0
            IDE_Conf_MenuGrid.LoadFromStream(gMem, 1, 0, IDE_Conf_MenuGrid.RowCount )
            IDE_Conf_MenuGrid.Tag = True
            gFStream.Close

        'now reset the shortcuts for tools
        IDE_Conf_MenuGrid.Cell(0,72) = IDE.ExternalApp1
        IDE_Conf_MenuGrid.Cell(0,73) = IDE.ExternalApp2
        IDE_Conf_MenuGrid.Cell(0,74) = IDE.ExternalApp3
        IDE_Conf_MenuGrid.Cell(0,75) = IDE.ExternalApp4

        END IF
    END IF
END SUB


SUB IDE_Conf_Menus_SaveButton_Click
    fDialog.Filter = "Text files|*.txt|All Files|*.*"
    fDialog.Mode = fdSave
    fDialog.MultiSelect = False
    IF fDialog.Execute THEN 
        IF FILEEXISTS(fDialog.FileName) THEN KILL fDialog.FileName
        tmpList.Clear
        DEFINT x, y
        DEFSTR s = ""                                                   'SaveToStream does not work!!

        'now reset the shortcuts for tools
        IDE_Conf_MenuGrid.Cell(0,72) = IDE.ExternalApp1
        IDE_Conf_MenuGrid.Cell(0,73) = IDE.ExternalApp2
        IDE_Conf_MenuGrid.Cell(0,74) = IDE.ExternalApp3
        IDE_Conf_MenuGrid.Cell(0,75) = IDE.ExternalApp4

        FOR y = 1 TO IDE_Conf_MenuGrid.RowCount-1                       'save cells manually
            FOR x = 0 TO IDE_Conf_MenuGrid.ColCount-2
                s = s + IDE_Conf_MenuGrid.Cell(x, y) + IDE_Conf_MenuGrid.Separator
            NEXT x
            s = s + IDE_Conf_MenuGrid.Cell(x, y)                        'get last entry w/o separator, but lf
            tmpList.AddItems(s)
            s = ""
        NEXT y
        IDE.MenuShortCutList = tmpList.Text
        TextToFile(fDialog.FileName, tmpList.Text)                      'QStringlist can fail... tmpList.SaveToFile(fDialog.FileName)                                    'save the modified menu to disk
        IDE.MenuShortCutFile = fDialog.FileName                         'set environment to load on restart
        SetMenuShortcuts                                                'now set the menus
    END IF
END SUB


SUB IDE_Conf_LoadProject
    IF (ini.Exist = 0) THEN EXIT SUB
    ini.Section = "Last Project File"
    DEFSTR tmpStr = ini.Get("Main", "")
    IF TmpStr <> "" THEN MFE_LoadProject(TmpStr)
END SUB


SUB ClearIni
    IF ini.Exist THEN
        KILL ini.FileName
        DO: DOEVENTS 
        LOOP UNTIL (FILEEXISTS(ini.FileName) = False)
        gFStream.Open(ini.FileName, fmCreate)
        gFStream.WriteLine(" ")
        gFStream.Close
    END IF
END SUB


SUB IDE_SetDefaultVariables
    IF MFE_List.ItemCount = 0 THEN
        IF MessageDlg("You must close all files before continuing. Close all files?", mtWarning, mbYes OR mbNo, 0) = mrYes THEN
            MFE_CloseAll
        END IF
    END IF

    IF MessageDlg("Clear setup and Overwrite with Defaults?", mtWarning, mbYes OR mbNo, 0) = mrYes THEN
        ini.FileName = TheMainIniFile
        IF ini.Exist THEN ClearIni
        IDE.New                                         'set defaults
        IDE_Conf_Form_Refresh                           'IDE Globals set the configuration form widgets
        WriteIDEVariables(True)                         'write them, then reset environment
        IDE_UpdateRecentList
        IDE_Conf_Form.Close
    END IF
    IDE.CompiledOK = False                                  'reset to recompile
END SUB



SUB IDE_Conf_Form_LoadIni
    fDialog.FileName = ""
    fDialog.Filter = "ini files|*.ini|All Files|*.*"
    fDialog.Mode = fdOpen
    fDialog.MultiSelect = False
    IF fDialog.Execute THEN
        IF FILEEXISTS (fDialog.FileName) = True THEN
            ini.FileName = fDialog.FileName
            ReadIDEVariables                                'read in new ini, then reset environment
            ini.FileName = TheMainIniFile                   'reset to default
        END IF
    END IF
    IDE.CompiledOK = False                                  'reset to recompile
END SUB


SUB IDE_Conf_LoadKeywords
    DIM OpenDialog AS QOPENDIALOG
    SELECT CASE IDE_Conf_TextRichEdit.ItemIndex
        CASE 6
            IF OpenDialog.Execute THEN IF FILEEXISTS(OpenDialog.Filename) THEN 
                IDE.KeyWordListFile = OpenDialog.Filename
                IDE.KeyWordList.LoadFromFile(IDE.KeyWordListFile)
                IF IDE.KeyWordList.ItemCount > 0 THEN re.LoadKeywordList(0, IDE.KeyWordList)
                IDE_Conf_RichEdit_Repaint
            END IF

        CASE 7
            IF OpenDialog.Execute THEN IF FILEEXISTS(OpenDialog.Filename) THEN 
                IDE.KeyWordListFile2 = OpenDialog.Filename
                IDE.KeyWordList2.LoadFromFile(IDE.KeyWordListFile2)
                IF IDE.KeyWordList2.ItemCount > 0 THEN re.LoadKeywordList(1, IDE.KeyWordList2)
                IDE_Conf_RichEdit_Repaint
            END IF

        CASE 8
            IF OpenDialog.Execute THEN IF FILEEXISTS(OpenDialog.Filename) THEN 
                IDE.KeyWordListFile3 = OpenDialog.Filename
                IDE.KeyWordList3.LoadFromFile(IDE.KeyWordListFile3)
                IF IDE.KeyWordList3.ItemCount > 0 THEN re.LoadKeywordList(2, IDE.KeyWordList3)
                IDE_Conf_RichEdit_Repaint
            END IF

        CASE ELSE
            Showmessage "Select a keyword list"
    END SELECT
END SUB





'*************************************************
'embeding
'*************************************************

SUB IDE_Conf_VersionInfoForm_Close
    IDE.EmbedManifest  =         IDE_Conf_ManifestEmbedCheckBox.Checked 
    IDE.EmbedVersionInfo  =      IDE_Conf_VersionInfoCheckBox.Checked 
    IDE.FileVersion   =          IDE_Conf_VersionInfoGrid.Cell(1,1)  
    IDE.ProductVersion   =       IDE_Conf_VersionInfoGrid.Cell(1,2) 
    IDE.CompanyName   =          IDE_Conf_VersionInfoGrid.Cell(1,6) 
    IDE.CompanyEmail   =         IDE_Conf_VersionInfoGrid.Cell(1,7) 
    IDE.FileDescription   =      IDE_Conf_VersionInfoGrid.Cell(1,8) 
    IDE.LegalCopyright   =       IDE_Conf_VersionInfoGrid.Cell(1,11) 
    IDE_Conf_VersionInfoForm.Close
END SUB



SUB IDE_Conf_VersionInfoForm_Show
    IDE_Conf_VersionInfoForm.Left = Screen.MouseX
    IDE_Conf_VersionInfoForm.Top = Screen.MouseY - 28
    IDE_Conf_VersionInfoForm.Show
END SUB



SUB IDE_Config_ResetEmbed
    zzz = False
    IF IDE_Conf_GenManifestCheckBox.Checked THEN zzz = True
    IDE.EmbedManifest = zzz
    IDE_Conf_ManifestEmbedCheckBox.Checked = IDE.EmbedManifest
    IDE.EmbedVersionInfo = zzz
    IDE_Conf_VersionInfoCheckBox.Checked = IDE.EmbedVersionInfo
END SUB

